/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _DSTATC_H
#define _DSTATC_H


#include <dnpap.h>
#include <boolset.h>
#include <mac.h>
#include <timer.h>
#include <snmp.h>


#define STAT_BOOLEAN_DATASOURCE		1
#define STAT_BOOLEAN_OWNER			2


typedef struct _TypeEntry TypeEntry;
struct _TypeEntry
{
	WORD Type;
	ULONG Pkts;
	ULONG Octets;
	
	TypeEntry *Prev;
	TypeEntry *Next;
};


typedef struct _DNPAP_ETHER_STATS
{
    LONG            Source[SNMP_SIZE_BUFINT];
    WORD            SourceLen;
    MAC_STAT        BaseStat;
    ULONG           Octets; 
    ULONG           Pkts; 
    ULONG           Pkts64Octets; 
    ULONG           Pkts65to127Octets; 
    ULONG           Pkts128to255Octets; 
    ULONG           Pkts256to511Octets;
    ULONG           Pkts512to1023Octets;
    ULONG           Pkts1024to1518Octets;
    ULONG           UtilInterval;
    ULONG           UtilTime;
    ULONG           UtilOctets;
    ULONG           UtilPkts;
    LONG            Utilization;
    BYTE            Owner[SNMP_SIZE_BUFCHR];
    WORD            OwnerLen;
    LONG            Status;

    MAC_IFACE       *Iface;
    MAC_COLL        Coll;

    TIMER_DESCR     *Timer;

    /* DNPAP additions  */
    LONG            IFTBuckets;
    LONG            IFTSize;
    ULONG           *IFTArrayPkts;
    ULONG           *IFTArrayOctets;
    LONG			LengthBuckets;
    LONG			LengthSize;
    ULONG           *LengthArrayPkts;
    ULONG           *LengthArrayOctets;
    LONG			TypeBuckets;
    HashTable       *TypeList;
    
    ULONG           Time;
    
    BooleanSet      ObjectSet;

} DNPAP_ETHER_STATS;


BOOLEAN DnpapStatCInit (DNPAP_ETHER_STATS *etherStats);
BOOLEAN DnpapStatCStart (DNPAP_ETHER_STATS *etherStats);
BOOLEAN DnpapStatCStop (DNPAP_ETHER_STATS *etherStats);

ULONG *NewBuckets(LONG nrbuckets);
ULONG *ReNewBuckets(ULONG *buckets, LONG nrbuckets);
VOID DelBuckets(ULONG *buckets);


#endif
