/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _AGENT_H_
#define _AGENT_H_


#include <dnpap.h>
#include <snmp.h>

#ifdef CONSERVATIVE_MTU
#define AGENT_BUFFER_SIZE		978		/* 1006 - 8 (UDP) - 20 (IP) */
										/* see 'Worldwide Internet
										   in "TCP/IP Illustrated Vol. 1
										   by W. Richard Stevens */
#else
#define AGENT_BUFFER_SIZE		1472	/* 1500 - 8 (UDP) - 20 (IP) */
#endif

#define AGENT_COMMUNITY_SIZE    255
#define AGENT_LIST_SIZE         32
#define AGENT_ADDR_SIZE 		16


typedef struct _AGENT_STAT AGENT_STAT;
typedef struct _AGENT_COMM AGENT_COMM;
typedef struct _AGENT_HOST AGENT_HOST;

struct _AGENT_STAT
{
	DWORD	InTotalReqVars;
	DWORD	InTotalSetVars;
	DWORD	InBadCommunityNames;
	DWORD	InBadCommunityUses;
    DWORD   datagrams;
    DWORD   errors;
};


struct _AGENT_COMM
{    
    int         index;
    BYTE        comm[255];
    WORD        commLen;
    AGENT_HOST  *hostList;
    AGENT_COMM  *next;
};


struct _AGENT_HOST
{
    DWORD       addr;
    AGENT_HOST  *next;
};


BOOLEAN 	 AgentInit(LONG port);
AGENT_STAT  *AgentStatistics(void);
BOOLEAN      AgentGetAuthenTraps(void);
VOID         AgentSetAuthenTraps(BOOLEAN enable);
BOOLEAN      AgentSendTrap (BYTE *comm, WORD commLen, ULONG systime, WORD gen,
                            WORD spec, SNMP_OBJECT *list, WORD listLen);
AGENT_COMM  *AgentCommunity(int index);


#endif
