/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _DISCD_H
#define _DISCD_H


#include <dnpap.h>


#define DISC_BOOLEAN_DATASOURCE		1
#define DISC_BOOLEAN_OWNER			2


#define DISC_TYPE_SOURCE    1
#define DISC_TYPE_DEST      2

#define DISC_TYPE_ETH       1
#define DISC_TYPE_IP        2
#define DISC_TYPE_UDP       3
#define DISC_TYPE_TCP       4

#define DISC_TYPE_ETHTIME   21
#define DISC_TYPE_IPTIME    22
#define DISC_TYPE_UDPTIME   23
#define DISC_TYPE_TCPTIME   24

#define DISC_SIZE_ETHADDR   6
#define DISC_SIZE_IPADDR    4
#define DISC_SIZE_UDPADDR   2
#define DISC_SIZE_TCPADDR   2

#define DISC_SIZE_TOIPADDR      (DISC_SIZE_ETHADDR+DISC_SIZE_IPADDR)  
#define DISC_SIZE_TOUDPADDR     (DISC_SIZE_TOIPADDR+DISC_SIZE_UDPADDR)
#define DISC_SIZE_TOTCPADDR     (DISC_SIZE_TOIPADDR+DISC_SIZE_TCPADDR)

#define DISC_SIZE_NODE   	DISC_SIZE_TOTCPADDR
#define DISC_SIZE_CONN   	(2*DISC_SIZE_NODE)

#define DISC_TABLE_ETHNODE   2
#define DISC_TABLE_IPNODE    3
#define DISC_TABLE_UDPNODE   4
#define DISC_TABLE_TCPNODE   5
#define DISC_TABLE_ETHTIME  62
#define DISC_TABLE_IPTIME   63
#define DISC_TABLE_UDPTIME  64
#define DISC_TABLE_TCPTIME  65

#define DISC_TABLE_ETHCONNSD  22
#define DISC_TABLE_IPCONNSD   23
#define DISC_TABLE_UDPCONNSD  24
#define DISC_TABLE_TCPCONNSD  25
#define DISC_TABLE_ETHCONNDS  42
#define DISC_TABLE_IPCONNDS   43
#define DISC_TABLE_UDPCONNDS  44
#define DISC_TABLE_TCPCONNDS  45
                            

#define CONTROLINDEXSIZE        1

#define DISC_ETHNODEINDEXSIZE   (CONTROLINDEXSIZE+DISC_SIZE_ETHADDR)
#define DISC_IPNODEINDEXSIZE    (CONTROLINDEXSIZE+DISC_SIZE_TOIPADDR)
#define DISC_UDPNODEINDEXSIZE   (CONTROLINDEXSIZE+DISC_SIZE_TOUDPADDR)
#define DISC_TCPNODEINDEXSIZE   (CONTROLINDEXSIZE+DISC_SIZE_TOTCPADDR)

#define DISC_ETHTIMEINDEXSIZE   (CONTROLINDEXSIZE+1)
#define DISC_IPTIMEINDEXSIZE    (CONTROLINDEXSIZE+1)
#define DISC_UDPTIMEINDEXSIZE   (CONTROLINDEXSIZE+1)
#define DISC_TCPTIMEINDEXSIZE   (CONTROLINDEXSIZE+1)

#define DISC_ETHCONNINDEXSIZE   (CONTROLINDEXSIZE+2*DISC_SIZE_ETHADDR)
#define DISC_IPCONNINDEXSIZE    (CONTROLINDEXSIZE+2*DISC_SIZE_TOIPADDR)
#define DISC_UDPCONNINDEXSIZE   (CONTROLINDEXSIZE+2*DISC_SIZE_TOUDPADDR)
#define DISC_TCPCONNINDEXSIZE   (CONTROLINDEXSIZE+2*DISC_SIZE_TOTCPADDR)


#define VALUE2BYTES(mem, val) \
            *(BYTE*) (mem)    = (BYTE)(((WORD)(val) & 0xff00U) >> 8); \
            *(BYTE*)((mem)+1) = (BYTE) ((WORD)(val) & 0x00ffU);


#define NETVALUEPTR2BYTES(dst, src) \
            memcpy(dst, src, 2);


#define NETLVALUEPTR2BYTES(dst, src) \
            memcpy(dst, src, 4);


#endif


