/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _DHOSTX_H
#define _DHOSTX_H


#include <dnpap.h>


#define HOST_SIZE_ADDR    	6	/* maximum of address sizes shown below */

#define ETH_SIZE_ADDR       6


typedef struct _DNPAP_HOST
{
    BYTE        Address[HOST_SIZE_ADDR];
    ULONG       InPkts;
    ULONG       OutPkts;
    ULONG       InOctets;
    ULONG       OutOctets;
    ULONG       OutErrors;
    ULONG       OutBroadcastPkts;
    ULONG       OutMulticastPkts;

    /* DNPAP additions  */
    ULONG       *IATBucketsPkts;
    ULONG       *ISTBucketsPkts;
    ULONG       *IATBucketsOctets;
    ULONG       *ISTBucketsOctets;
    ULONG       InBucket1Pkts;
    ULONG       InBucket2Pkts;
    ULONG       InBucket3Pkts;
    ULONG       InBucket4Pkts;
    ULONG       InBucket5Pkts;
    ULONG       InBucket6Pkts;
    ULONG       OutBucket1Pkts;
    ULONG       OutBucket2Pkts;
    ULONG       OutBucket3Pkts;
    ULONG       OutBucket4Pkts;
    ULONG       OutBucket5Pkts;
    ULONG       OutBucket6Pkts;
#ifdef NOT_HOST_GENERIC
    ULONG       InTCPPkts;
    ULONG       OutTCPPkts;
    ULONG       InOtherPkts;
    ULONG       OutOtherPkts;
#endif

    ULONG       IATTime;
    ULONG       ISTTime;

    struct _DNPAP_HOST  *LexPrev;
    struct _DNPAP_HOST  *LexNext;

	struct _DNPAP_HOST  *TimePrev;    
	struct _DNPAP_HOST  *TimeNext;    
    
    struct _DNPAP_HOST  *LRUPrev;
    struct _DNPAP_HOST  *LRUNext;
    
    struct _DNPAP_HOST  **TimeListPtr;
    
} DNPAP_HOST;


#define HOST_EVENT_RESET	1
#define HOST_EVENT_UPDATE	2
#define HOST_EVENT_STOP		3

#define HOST_FLAG_IN			0x0001
#define HOST_FLAG_OUT			0x0002
#define HOST_FLAG_MULTICAST 	0x0004
#define HOST_FLAG_BROADCAST 	0x0008
#define HOST_FLAG_ERROR 		0x0010
#define HOST_FLAG_TCP 			0x0020
#define HOST_FLAG_OTHER			0x0040
#define HOST_FLAG_64			0x0080
#define HOST_FLAG_65			0x0100
#define HOST_FLAG_128			0x0200
#define HOST_FLAG_256			0x0400
#define HOST_FLAG_512			0x0800
#define HOST_FLAG_1024			0x1000


typedef VOID (*DnpapHostTopNCallback)(ULONG hostindex, int event, DNPAP_HOST *host, WORD addrlen, int flags, LWORD size, VOID *topn);

typedef struct DnpapTopNCallback_ DnpapTopNCallback;


#endif
