/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _STATBUFC_H
#define _STATBUFC_H


#include <dnpap.h>
#include <boolset.h>
#include <snmp.h>
#include <timer.h>


#define STATBUF_BOOLEAN_VARIABLE		1
#define STATBUF_BOOLEAN_OWNER			2


#define MINALLOCENTRIES     8


typedef struct _StatBuf
{
    ULONG   Time;
    LONG    Value;

} StatBuf;


typedef struct _StatBufControl
{
    ULONG           Variable[SNMP_SIZE_BUFINT];
    WORD            VariableLen;

    LONG            RequestedSize;
    LONG            GrantedSize;
    LONG            Interval;
    LONG            SampleType;
    LONG            FullStatus;
    LONG            FullAction;
    LONG            Average;
    LONG            Deviation;

    BYTE            Owner[SNMP_SIZE_BUFCHR];
    WORD            OwnerLen;
    LONG            Status;

    TIMER_DESCR    *Timer;

    LONG            PrevValue;

    StatBuf        *Buffer;
    LONG            BufferAllocated;
    LONG            BufferPos;
    BOOLEAN         BufferWrapped;

    BooleanSet      ObjectSet;

} StatBufControl;


BOOLEAN StatBufConfigInit(VOID);

BOOLEAN StatBufCInit(StatBufControl *hostcontrol);
BOOLEAN StatBufCStart(StatBufControl *hostcontrol);
BOOLEAN StatBufCStop(StatBufControl *hostcontrol);

StatBuf* StatBufSearch(StatBufControl *statbufcontrol, SNMP_OBJECT *obj, WORD idlen);

StatBuf* NewStatBuf(LONG n);
StatBuf* ReNewStatBuf(StatBuf *p, LONG n, LONG oldn, LONG maxn);
VOID DelStatBuf(StatBuf *p);

StatBufControl* NewStatBufControl(LONG n);
VOID DelStatBufControl(StatBufControl *p);


#endif
