/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _DTOPN_C_H
#define _DTOPN_C_H


#include <dnpap.h>
#include <boolset.h>
#include <hash.h>
#include <mibsup.h>
#include <timer.h>
#include <dhostx.h>

#include "dtopn_d.h"


#define TOPN_BOOLEAN_DATASOURCE		1
#define TOPN_BOOLEAN_OWNER			2


typedef struct _DNPAP_TOPN_ENTRY
{
	BYTE  Address[HOST_SIZE_ADDR];
    ULONG PrevValue;        /*  statistics in host structure are ULONG's too  */
	ULONG Rate;

    struct _DNPAP_TOPN_ENTRY  *Prev;
    struct _DNPAP_TOPN_ENTRY  *Next;
	
} DNPAP_TOPN_ENTRY;


typedef struct _DNPAP_TOPN_CONTROL
{
    ULONG  HostIndex;
    DnpapTopNCallback *HostCallback;
	WORD  AddressLen;
    LONG  RateBase;
    LONG  TimeRemaining;
    LONG  Duration;
    LONG  RequestedSize;
    LONG  GrantedSize;
    ULONG StartTime;
    BYTE  Owner[SNMP_SIZE_BUFCHR];
    WORD  OwnerLen;
    WORD  Status;

    LONG  TableSize;
    HashTable *Table;
    
    DNPAP_TOPN_ENTRY  *TopNEntries;
    DNPAP_TOPN_ENTRY  *TopNLast;
    DNPAP_TOPN_ENTRY **TopNArray;
    
    TIMER_DESCR *Timer;

	BooleanSet   ObjectSet;
    
} DNPAP_TOPN_CONTROL;


BOOLEAN DnpapTopNCInit(DNPAP_TOPN_CONTROL *topncontrol);
BOOLEAN DnpapTopNCStart(DNPAP_TOPN_CONTROL *topncontrol);
BOOLEAN DnpapTopNCStop(DNPAP_TOPN_CONTROL *topncontrol);
	  
LONG DnpapTopNGranted(LONG requested);

VOID DnpapHostTopNNotify(ULONG hostindex, int event, DNPAP_HOST *host, WORD addrlen, int flags, LWORD size, VOID *topn);

BOOLEAN DnpapEntryAddList(DNPAP_TOPN_CONTROL *topncontrol, DNPAP_TOPN_ENTRY *entry);
BOOLEAN DnpapEntryUpdateList(DNPAP_TOPN_CONTROL *topncontrol, DNPAP_TOPN_ENTRY *entry);
DNPAP_TOPN_ENTRY* DnpapTopNEntrySearch(DNPAP_TOPN_CONTROL *topncontrol, SNMP_OBJECT *obj, WORD idlen);
      
BOOLEAN DnpapFillEntryTable(DNPAP_TOPN_CONTROL *topncontrol, LONG reqsize);


#endif
