/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef MIBSUP_H
#define MIBSUP_H


#include <dnpap.h>
#include <snmp.h>


#define MIB_READ                0x01
#define MIB_WRITE               0x02

                                       
typedef WORD (*MIB_CALLBACK)(SNMP_OBJECT *Obj, WORD IdLen, VOID *Param);


typedef struct _MIB_ELEMENT
{
    LONG         Id[SNMP_SIZE_SMALLOBJECTID];
    WORD         IdLen;
    MIB_CALLBACK Rqs;
    WORD         Type;
    WORD         Support;
} MIB_ELEMENT;


typedef struct _MIB_COMMUNITY
{
    BYTE        Comm[SNMP_SIZE_COMM];
    WORD        CommLen;
    WORD        Support;
} MIB_COMMUNITY;


typedef struct _MIB_RMON
{
    MIB_COMMUNITY  *Prf;
    WORD            PrfSze;
    MIB_ELEMENT    *Obj;
    WORD            ObjSze;
} MIB_RMON;
                     

typedef struct _MIB_OBJECT
{
    LONG        *Id;
    WORD         IdLen;
    MIB_CALLBACK Rqs;
    WORD         Type;
    WORD         Support; 
    VOID        *Param;
} MIB_OBJECT;


typedef struct _MIB_ROOT
{
    MIB_OBJECT  **Table;
    int           Size;
    int           Count;
} MIB_ROOT;
    

typedef struct _MIB_LOCAL MIB_LOCAL;

struct _MIB_LOCAL
{
    LONG        Index;
    MIB_LOCAL  *Next;
    VOID       *Data;
};


BOOLEAN     MibInit   (MIB_ELEMENT *Obj, WORD ObjSze);

BOOLEAN     MibSimple (SNMP_OBJECT *Obj, WORD IdLen);

MIB_LOCAL  *MibRmon   (SNMP_OBJECT *Obj, MIB_LOCAL *Local, 
                       WORD IdLen, WORD IdSize);
MIB_LOCAL  *MibInsert (SNMP_OBJECT *Obj, MIB_LOCAL **Local,
                       WORD IdLen, WORD IdSize);
BOOLEAN     MibRemove (SNMP_OBJECT *Obj, MIB_LOCAL **Local, 
                       WORD IdLen, WORD IdSize);
MIB_OBJECT *MibRegister(LONG         *Id,
                        WORD         IdLen,
                        MIB_CALLBACK Rqs,
                        WORD         Type,
                        WORD         Support,
                        VOID         *Param);
VOID MibDeRegister(MIB_OBJECT *Object);


#endif
