/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _REACHC_H
#define _REACHC_H


#include <dnpap.h>
#include <boolset.h>
#include <snmp.h>
#include <ping.h>
#include <echo.h>
#include <timer.h>


#define REACH_BOOLEAN_ADDRESS		1
#define REACH_BOOLEAN_OWNER			2


#define REACH_SIZE_IPADDRESS    4


typedef struct _Request
{
    VOID *Request;
    struct _Request *Next;

} Request;


typedef struct _Reach
{
    BYTE            IPAddress[REACH_SIZE_IPADDRESS];

	LONG			Delay;
	ULONG			Timeout;
	LONG			ValueSteps;
	FLOAT			ICMPWeight;
	FLOAT			UDPWeight;
	LONG			Remaining;
	LONG			ICMPReceived;
	LONG			UDPReceived;
	LONG			ICMPDropped;
	LONG			UDPDropped;
	ULONG			ICMPTime;
	ULONG			UDPTime;
	ULONG			ICMPTimeMin;
	ULONG			UDPTimeMin;
	ULONG			ICMPTimeMax;
	ULONG			UDPTimeMax;
	LONG			TotalICMPTime;
	LONG			TotalUDPTime;
	FLOAT			Value;
	
    BYTE            Owner[SNMP_SIZE_BUFCHR];
    WORD            OwnerLen;
    LONG            Status;

	TIMER_DESCR	   *Timer;
	
    USHORT          PingSeqNr;
    Request        *PingList;
    ULONG          *PingBuffer;
    USHORT          EchoSeqNr;
    Request        *EchoList;
    ULONG          *EchoBuffer;

    BooleanSet      ObjectSet;

} Reach;


BOOLEAN ReachConfigInit(VOID);

BOOLEAN ReachCInit(Reach *hostcontrol);
BOOLEAN ReachCStart(Reach *hostcontrol);
BOOLEAN ReachCStop(Reach *hostcontrol);


#endif
