;************************************************************************
;* MODULE INFORMATION*
;**********************
;*     FILE     NAME:       neusend.asm
;*     SYSTEM   NAME:       
;*     ORIGINAL AUTHOR(S):  Paul Lemmers
;*     VERSION  NUMBER:     
;*     CREATION DATE:       1991/11/12
;*
;* DESCRIPTION: Last file in the link list for NEUS. It signals
;*              the end of the data and code segments.
;*              
;************************************************************************
;* CHANGES INFORMATION **
;************************
;* REVISION:    $Revision:   1.2  $
;* WORKFILE:    $Workfile:   neusend.asm  $
;* LOGINFO:     $Log:   D:/CPROG/NDIS/NEUS/VCS/NEUSEND.ASV  $
;*              
;*                 Rev 1.2   15 Jul 1992 13:41:02   PAUL
;*              No change.
;*              
;*                 Rev 1.1   12 Mar 1992 22:30:54   PAUL
;*              High Resolution timer
;*              
;*                 Rev 1.0   16 Feb 1992 18:21:42   PAUL
;*              Initial revision.
;************************************************************************/
;
	NAME    neusend
	INCLUDE neussdef.inc
	.XLIST
	.XCREF
	INCLUDE neusglb.inc
	.CREF
	SUBTITLE 'BSS initialisation part and "safe" init vars'
	.LIST
;
; In the _BSS segment after the _end_data label you can put data that
; you want discarded after the init request.

_BSS	SEGMENT
	extrn	__beg_bss:near
	EVEN			;I know, this is nonsense and I also
				;wanted DWORD alignment for 386...
_end_data dw	0		;Do not remove this word. _init_bss()
				;needs it.
;
; Here is a very tricky construction:
; After all the data defined in assembler (neusmain.asm) and
; in all the other c-files, we get more...... assembler defined
; data.
; These variables are here to make sure that they are safe during
; the whole init request.
; At the end of the init request most of the memory changes from
; function, meaning or whatever you call it. It was used as variables
; in the init request and afterwards (part of) it will be used for
; "dynamically" allocated memory. (actually it is simply not freed.)
; To make sure that no essential values will be lost, the following
; variables are stored at the end of the DGROUP segment. Since the
; "dynamic" memory will never pass _end_data, it is safe there.
;

freemem		dw	0	; End of dynamic memory

_BSS	ENDS

	PAGE
_TEXT   SEGMENT
	ASSUME	CS: _TEXT

;************************************************************************
;* NAME:        init_bss
;* SYNOPSIS:    void	init_bss(void)
;* DESCRIPTION: Clears uninitialised memory to 0
;* UNMODIFIED REGISTERS:
;*              ds bp si di
;* RETURNS:     nothing
;************************************************************************
	public	_init_bss
_init_bss proc	near
	push	bp
	mov	bp,sp

	mov	ax,ds
	mov	es,ax		;let es point to data segment
	mov	cx,(dataOFFSET _end_data)
				;number of words to clear
	xor	ax,ax
	mov	di,dataOFFSET __beg_bss
				;set to start
	sub	cx,di		;cx := length of bss in bytes
	sar	cx,1		;cx := length of bss in words
	rep stosw		;clear memory
	jc	nomore
	stosb			;and one more byte to clear
			
nomore:	pop	bp
	ret
_init_bss endp

_TEXT	ENDS
	.XLIST
	SUBTITLE
	.LIST

	END
