/************************************************************************
** MODULE INFORMATION*
**********************
**     FILE     NAME:       neusglb.h
**     SYSTEM   NAME:       
**     ORIGINAL AUTHOR(S):  Paul Lemmers
**     VERSION  NUMBER:     
**     CREATION DATE:       1991/11/12
**
** DESCRIPTION: This file contains declarations of variables in memory
**              that will be present after (and during) Init processing.
**              The idea is to define this data in assembler in neusmain.asm.
**              There you can watch allignment, ordering, etc.
**              Please be wise and do not define any data in the part of
**              C-code that will remain resident, unless you are absolutely
**              sure about what you are doing (initialisation!).
**
**              Check the memory usage with the MemTest exported function
**              in DLL mode.
**              
*************************************************************************
** CHANGES INFORMATION **
*************************
** REVISION:    $Revision:   1.8  $
** WORKFILE:    $Workfile:   neusglb.h  $
** LOGINFO:     $Log:   D:/CPROG/NDIS/NEUS/VCS/NEUSGLB.H_V  $
**              
**                 Rev 1.8   30 Mar 1993 09:37:34   PAUL
**              Mulktisend removed etc.
**              
**                 Rev 1.7   20 Sep 1992 21:28:22   PAUL
**              DevHelp_SemHandle addition
**              
**                 Rev 1.6   15 Jul 1992 13:41:02   PAUL
**              Modifications for inactivity timer
**              
**                 Rev 1.5   31 Mar 1992 09:05:30   PAUL
**              Ahum......
**              
**                 Rev 1.4   12 Mar 1992 22:30:56   PAUL
**              High Resolution timer
**              
**                 Rev 1.3   05 Mar 1992 13:14:50   PAUL
**              Extra variables for MULTI_SEND
**              
**                 Rev 1.2   24 Feb 1992 18:23:20   PAUL
**              ???
**              
**                 Rev 1.1   21 Feb 1992 22:25:24   PAUL
**              Updates for always valid pxNextEvent pointer
**              
**                 Rev 1.0   16 Feb 1992 18:21:58   PAUL
**              Initial revision.
*************************************************************************/

#if defined(_H2INC)
#include <ndisdef.h>
#include <neus.h>
#endif

#define MAXSEG      20

typedef union _QEL *PQEL;

typedef struct _NLEV {
	PQEL            next;
	unsigned short	usFlags;
	unsigned short	usLostSt;
	unsigned short	usLostFr;
	unsigned short  usEventType;
	unsigned short  usHandle3;
	unsigned short  usRet1;
	unsigned short  usRet2;
	unsigned long   ulTime;
	} NLEV;
/* Flags bit values */
#define REQ_ACTIVE  1
#define REQ_QUEUED  2

/* The order and size off usEventType until ulTime */
/* must match with event record from neus.h !!!!   */
#define	STD_EVENT_SIZE     12

typedef struct _DELEV {
	PQEL            next;
	unsigned short  usHandleMAC;
	unsigned short  usFrameSize;
	unsigned short  usLen;
	unsigned long   ulTime;
	/* RX BUF DESCR */
	} DELEV;

union _QEL {
	struct _DELEV   delevent;
	struct _NLEV    nlevent;
	};

typedef struct _QDESC {
	unsigned short q_size;  /* total # number of elements allocated */
	PQEL           Mem;     /* Pointer to start of allocated memory */
	PQEL           Head;    /* Elements are added here */
	PQEL           Tail;    /* Remove here */
	} QDESC;

typedef struct SEGD *PSEGD;
struct	SEGD {
	unsigned short fAttr;
	unsigned short usBegin;
	unsigned short usSeg3;
	unsigned short usSeg0;
	unsigned long  ulLock;
	};
/* fAttr flags */
#define SEG_MORE   1

struct MACMOD {
	LPBUF          pCCT;       /* Common Characteristics Table */
	unsigned short usID;
	unsigned short usDS;
	LPFUN          pSysReq;     /* System Requests entry point */
	LPBUF          pSSCT;       /* Serv. Spec. Characteristics Table */
	LPBUF          pSSST;       /* Serv. Spec. Status Table */
	LPBUF          pUpDT;       /* Upper Dispatch Table */
	LPFUN	       pReq;        /* Request address */
	LPFUN	       pTxChain;    /* TransmitChain address */
	LPFUN	       pTrData;     /* TransferData address */
	LPFUN	       pRcvRel;     /* ReceiveRelease address */
	LPFUN	       pIndOn;      /* IndicationOn address */
	LPFUN	       pIndOff;     /* IndicationOff address */
	};

#if ! defined(_H2INC)
#define SIZE_RX (sizeof(struct _DELEV)+sizeof(RxBufDescr)+(MaxBlocks-1)*sizeof(BlockD))
#endif

extern unsigned short ufGlb;
#define GF_DEB     1
#define GF_GIVE    2
#define GF_MAC_OK  4
#define GF_BLOCKED 8
#define GF_RCV_CHK 16

typedef unsigned short (_far *USPF)();
extern USPF DevHelp;
extern void _far *pgisGlobTime;
extern unsigned short    dherrno;
extern short     open_cnt;

extern CCT       mycct;
extern PLD       myPLD;

extern LPFUN     ProtAddr;
extern MBYTE     ProtVer[2];
extern ProtmanReqBlock ProtReq;

extern BINDL  myBindings;
extern unsigned short   usLastRecsAvail;

extern struct MACMOD LoMod;
extern struct _QDESC BlockedQue;
extern struct _QDESC GenReqFree;
extern struct _QDESC TxFree;
extern struct _QDESC RxQue;
extern struct _QDESC RxFree;

extern unsigned short ticks;
extern unsigned short inact_timer;
extern unsigned short inact_user;

extern unsigned short usMaxLen;
extern unsigned short nsel;
extern unsigned short maxsel;
extern unsigned short awRing0Sels[MAXSEG];

extern unsigned short MaxGenReq;
extern unsigned short MaxTx;
extern unsigned short MaxRx;
extern unsigned short MaxFilters;
extern unsigned short MaxBlocks;

extern unsigned short usLastRecsAvail;

extern unsigned short usLostFrames;
extern unsigned short usLostStatus;

extern unsigned short usCurrentSeg;
extern PSEGD aSel;

extern unsigned short usFreeOffs;
extern unsigned short usOldestSeg;
extern unsigned short usOldestOffs;
extern PTXSEG pTxSeg;

extern char   end_asmdata[];

/* prototypes of global driver specific asm functions */
/* from neusmain.asm */
extern unsigned short InstallTick(void);
extern unsigned short DeInstallTick(void);
extern unsigned short test_counter(void);

extern void do_Send(struct _TxBufD _far *pTx, struct _NLEV *pEvent);
extern void do_GenReq(struct _iocparm _far *pParm, struct _NLEV *pEvent);

extern void ChkFreed(void);
extern void _far *C_MallocEvent(unsigned short usExtra);
extern unsigned long GetStamp(void);
extern int SaveSel(unsigned short _far *dest);

/* from neusque.asm */
struct _NLEV *Q_Get(struct _QDESC *pQ);

/* from neusrel.asm */
extern void	freeit(void);

/* from neusend.asm */
extern unsigned short _end_data;
extern unsigned short freemem;
