/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
/* cdev.h */
/*
** This file is meant for device drivers written in the C language
** BE VERY CAREFUL it needs /Zp or #pragma pack(1) to allign the
** Request Header and other structures........
** Please include it as late as possible if the pack(1) pragma is used!
**
*/

#if !defined(NULL)
	/* then define NULL pointer (model dependent) */
#define NULL	((void *)0)
#endif

#if !defined(FNULL)
	/* then define far NULL pointer (model independent) */
#define FNULL	((void far *)0)
#endif

#define UC	unsigned char
#define UI	unsigned int
#define UL	unsigned long

#define	STAT_DONE ((UI)0x0100)
#define	STAT_BUSY ((UI)0x0200)
#define	STAT_DEV  ((UI)0x4000)
#define	STAT_ERR  ((UI)0x8000)

#define E_WRITE_PROT ((UC) 0)
#define E_UNKN_UNIT  ((UC) 1)
#define E_NOT_READY  ((UC) 2)
#define E_UNKN_COMM  ((UC) 3)
#define E_CRC        ((UC) 4)
#define E_BAD_DRV_LEN ((UC) 5)
#define E_SEEK_ERR   ((UC) 6)
#define E_UNKN_MEDIA ((UC) 7)
#define E_SECT_NOTF  ((UC) 8)
#define E_NO_PAPER   ((UC) 9)
#define E_WRT_FAULT  ((UC) 0xa)
#define E_RD_FAULT   ((UC) 0xb)
#define E_GEN_FAIL   ((UC) 0xc)
#define E_CH_DISK    ((UC) 0xd)
#define E_UNCERT_MED ((UC) 0x10)
#define E_CHAR_INT   ((UC) 0x11)
#define E_NO_MONIT   ((UC) 0x12)
#define E_INVAL_PAR  ((UC) 0x13)


#define C_INIT		((UC) 0)
#define C_MEDIA_CHECK	((UC) 1)
#define C_BUILD_BPB	((UC) 2)
#define C_READ		((UC) 4)
#define C_NOND_READ_NW	((UC) 5)
#define C_INPUT_STAT	((UC) 6)
#define C_INPUT_FLUSH	((UC) 7)
#define C_WRITE		((UC) 8)
#define C_WRITE_VERIFY	((UC) 9)
#define C_OUTPUT_STAT	((UC) 10)
#define C_OUTPUT_FLUSH	((UC) 11)
#define C_DEV_OPEN	((UC) 13)
#define C_DEV_CLOSE	((UC) 14)
#define C_REMOV_MEDIA	((UC) 15)
#define C_GEN_IOCtl	((UC) 16)
#define C_RESET_MEDIA	((UC) 17)
#define C_GET_LOG_DRMAP	((UC) 18)
#define C_SET_LOG_DRMAP	((UC) 19)
#define C_DEINSTALL	((UC) 20)
#define C_PORT_ACCESS	((UC) 21)
#define C_PART_FIXD	((UC) 22)
#define C_GET_FIXD_MAP	((UC) 23)


/* request header */
typedef	struct	{
	UC	reqlen;		/* length field */
	UC	unit_code;	/* block device unit code */
	UC	command;	/* request command */
	UI	status;		/* return status */
	UC	res[4];
	UL	queue_link;
	} REQHDR;


/* INIT request: C_INIT */
typedef struct	{
	REQHDR	hdr;
	struct {
		UC	nr_units;
		union {
			void	(far *dh_ptr)();
			struct {
				UI	code_size;
				UI	data_size;
				} sizes;
			} sizes_and_ptr;
		char	far *argp;
		UC	drive_num;
		} rdata;
	} INIT_R;

/* Device Open request: C_DEV_OPEN */
/* only request header */

/* Device Close request: C_DEV_CLOSE */
/* only request header */

/* Generic IOCtl request: C_GEN_IOCtl */
typedef struct {
	REQHDR	hdr;
	struct {
		UC	func_cat;
		UC	func_code;
		void far *parmp;
		void far *datap;
		} rdata;
	} IOCtl_R;



/*-----------------------------*/
/*   function prototypes       */
/*-----------------------------*/
/* assembler */
void c_strat(REQHDR far *);
void init_bss(void);
void freeit(void);

/* C */
void Init(INIT_R far *);
void Device_Open(REQHDR far *);
void Device_Close(REQHDR far *);
void Generic_IOCtl(IOCtl_R far *);

/* default assembler data definitions */
extern UI _end_data;
