;************************************************************************
;* MODULE INFORMATION*
;**********************
;*     FILE     NAME:       dhlp006.asm
;*     SYSTEM   NAME:       devlib
;*     ORIGINAL AUTHOR(S):  Paul Lemmers
;*     VERSION  NUMBER:     
;*     CREATION DATE:       1990/8/14
;*
;* DESCRIPTION: 
;*              Contains DevHelp SemRequest function.
;************************************************************************
;* CHANGES INFORMATION **
;************************
;* REVISION:    $Revision:   1.1  $
;* WORKFILE:    $Workfile:   dhlp006.asm  $
;* LOGINFO:     $Log:   D:/CPROG/MYDEV/DEVLIB/VCS/DHLP006.ASV  $
;*              
;*                 Rev 1.1   17 Dec 1990 14:30:46   PAUL
;*              included devhlp.inc and os2def.h types
;*              
;*                 Rev 1.0   14 Aug 1990 14:33:10   PAUL
;*              Initial revision.
;************************************************************************/
;
	INCLUDE	cdev.inc
	INCLUDE	devhlp.inc


_DATA	SEGMENT
	EXTRN	_DevHelp:DWORD
_DATA	ENDS

_TEXT	SEGMENT
	PUBLIC	_dev_SemRequest
;************************************************************************
;* NAME:        dev_SemRequest
;* SYNOPSIS:    USHORT dev_SemRequest(void _far *hsem, ULONG timeout)
;*              void far *hsem;     Semaphore handle.
;*              ULONG timeout;      Timeout value
;* DESCRIPTION: See DevHelp SemRequest function.
;* UNMODIFIED REGISTERS:
;*              ds bp si di
;* RETURNS:     ax = 0 -->   no error
;*              else    error code
;************************************************************************
	hsem    = 4
	timeout = 8
_dev_SemRequest	PROC	NEAR
	PUSH	BP
	MOV	BP,SP
	push	di		; save di

	mov	ax,[bp+hsem+2]
	mov	bx,[bp+hsem]
	mov	di,[bp+timeout+2]
	mov	cx,[bp+timeout]
	mov	dl,DevHlp_SemRequest
	call	[_DevHelp]
	jc	$L000		; jump if error
	xor	ax,ax

$L000:	pop	di		; restore di
	POP	BP
	RET
_dev_SemRequest	ENDP

_TEXT	ENDS

	END
