;************************************************************************
;* MODULE INFORMATION*
;**********************
;*     FILE     NAME:       dhlp014.asm
;*     SYSTEM   NAME:       devlib
;*     ORIGINAL AUTHOR(S):  Paul Lemmers
;*     VERSION  NUMBER:     
;*     CREATION DATE:       1990/8/14
;*
;* DESCRIPTION: 
;*              Contains DevHelp UnLock function.
;************************************************************************
;* CHANGES INFORMATION **
;************************
;* REVISION:    $Revision:   1.2  $
;* WORKFILE:    $Workfile:   dhlp014.asm  $
;* LOGINFO:     $Log:   D:/CPROG/MYDEV/DEVLIB/VCS/DHLP014.ASV  $
;*              
;*                 Rev 1.2   18 Dec 1990 14:04:22   PAUL
;*              Ahum, adapted to _fastcall naming
;*              
;*                 Rev 1.1   17 Dec 1990 14:09:54   PAUL
;*              _fastcall and devhlp.inc
;*              
;*                 Rev 1.0   14 Aug 1990 14:36:30   PAUL
;*              Initial revision.
;************************************************************************/
;
	INCLUDE	cdev.inc
	INCLUDE	devhlp.inc


_DATA	SEGMENT
	EXTRN	_DevHelp:DWORD
_DATA	ENDS

_TEXT	SEGMENT
	PUBLIC	@dev_Unlock
;************************************************************************
;* NAME:        dev_Unlock
;* SYNOPSIS:    USHORT _fastcall dev_Unlock(ULONG LockHandle)
;*              ULONG  LockHandle;     Lock handle of segment to be unlocked
;* DESCRIPTION: See DevHelp documentation of Unlock.
;* CALL REGISTERS:
;*              dx:ax  LocHandle
;* UNMODIFIED REGISTERS:
;*              ds bp si di
;* RETURNS:     ax = 0 -->   no error
;*              else    error code
;************************************************************************
	LockHandle = 4
@dev_Unlock	PROC	NEAR

	mov	bx,ax
	mov	ax,dx
	mov	dl,DevHlp_Unlock
	call	[_DevHelp]
	jc	$L000		; jump if access not allowed
	xor	ax,ax
	jmp	short $L001
$L000:	mov	ax,0ffffh

$L001:	RET
@dev_Unlock	ENDP

_TEXT	ENDS

	END
