;************************************************************************
;* MODULE INFORMATION*
;**********************
;*     FILE     NAME:       dhlp019.asm
;*     SYSTEM   NAME:       devlib
;*     ORIGINAL AUTHOR(S):  Paul Lemmers
;*     VERSION  NUMBER:     
;*     CREATION DATE:       1990/8/21
;*
;* DESCRIPTION: 
;*              Contains DevHelp FreePhys function.
;************************************************************************
;* CHANGES INFORMATION **
;************************
;* REVISION:    $Revision:   1.2  $
;* WORKFILE:    $Workfile:   dhlp019.asm  $
;* LOGINFO:     $Log:   D:/CPROG/MYDEV/DEVLIB/VCS/DHLP019.ASV  $
;*              
;*                 Rev 1.2   18 Dec 1990 14:04:30   PAUL
;*              Ahum, adapted to _fastcall naming
;*              
;*                 Rev 1.1   17 Dec 1990 14:10:04   PAUL
;*              _fastcall and devhlp.inc
;*              
;*                 Rev 1.0   03 Sep 1990 15:03:34   PAUL
;*              Initial revision.
;************************************************************************/
;
	INCLUDE	cdev.inc
	INCLUDE	devhlp.inc


_DATA	SEGMENT
	EXTRN	_DevHelp:DWORD
_DATA	ENDS

_TEXT	SEGMENT
	PUBLIC	@dev_FreePhys
;************************************************************************
;* NAME:        dev_FreePhys
;* SYNOPSIS:    USHORT _fastcall dev_FreePhys(ULONG phys)
;*              ULONG  phys;    32-bit physical address
;* DESCRIPTION: See DevHelp documentation of FreePhys
;* CALL REGISTERS:
;*              dx:ax    phys
;* UNMODIFIED REGISTERS:
;*              ds bp si di
;* RETURNS:     ax = 0 -->   succesful
;*              ax != 0      unsuccesful
;************************************************************************
	phys   = 4
@dev_FreePhys	PROC	NEAR

	mov	bx,ax
	mov	ax,dx
	mov	dl,DevHlp_FreePhys
	call	[_DevHelp]
	mov	ax,0
	jnc	$L000		; jump if succesful
	dec	ax

$L000:	RET
@dev_FreePhys	ENDP

_TEXT	ENDS

	END
