;************************************************************************
;* MODULE INFORMATION*
;**********************
;*     FILE     NAME:       dhlp01b.asm
;*     SYSTEM   NAME:       devlib
;*     ORIGINAL AUTHOR(S):  Paul Lemmers
;*     VERSION  NUMBER:     
;*     CREATION DATE:       1990/12/16
;*
;* DESCRIPTION: 
;*              Contains DevHelp SetIRQ function.
;************************************************************************
;* CHANGES INFORMATION **
;************************
;* REVISION:    $Revision:   1.1  $
;* WORKFILE:    $Workfile:   dhlp01b.asm  $
;* LOGINFO:     $Log:   D:/CPROG/MYDEV/DEVLIB/VCS/DHLP01B.ASV  $
;*              
;*                 Rev 1.1   18 Dec 1990 14:04:34   PAUL
;*              Ahum, adapted to _fastcall naming
;*              
;*                 Rev 1.0   17 Dec 1990 14:17:18   PAUL
;*              Initial revision.
;************************************************************************/
;
	INCLUDE	cdev.inc
	INCLUDE devhlp.inc


_DATA	SEGMENT
	EXTRN	_DevHelp:DWORD
_DATA	ENDS

_TEXT	SEGMENT
	PUBLIC	@dev_SetIRQ
;************************************************************************
;* NAME:        dev_SetIRQ
;* SYNOPSIS:    USHORT _fastcall dev_SetIRQ(USHORT IRQNum
;*                               void (_near *handler)(),
;*                               USHORT ShareFlag)
;*              USHORT  IRQNum;
;*              void (_near *handler)();
;*              USHORT ShareFlag;
;* DESCRIPTION: See DevHelp documentation of SetIRQ
;* CALL REGISTERS:
;*              ax    IRQNum
;*              bx    handler
;*              dx    ShareFlag
;* UNMODIFIED REGISTERS:
;*              ds bp si di
;* RETURNS:     ax = 0 -->   no error
;*              else         ax=-1 (error code) IRQ not available
;************************************************************************
@dev_SetIRQ	PROC	NEAR

	xchg	bx,ax		; Exchange Handler and IRQNum
	mov	dh,dl		; Move ShareFlag
	mov	dl,DevHlp_SetIRQ
	call	[_DevHelp]
	mov	ax,0FFFFh
	jc	$L000		; jump if error
	xor	ax,ax

$L000:	RET
@dev_SetIRQ	ENDP

_TEXT	ENDS

	END
