;************************************************************************
;* MODULE INFORMATION*
;**********************
;*     FILE     NAME:       dhlp024.asm
;*     SYSTEM   NAME:       devlib
;*     ORIGINAL AUTHOR(S):  Paul Lemmers
;*     VERSION  NUMBER:     
;*     CREATION DATE:       1990/8/21
;*
;* DESCRIPTION: 
;*              Contains DevHelp GetDOSVar function.
;************************************************************************
;* CHANGES INFORMATION **
;************************
;* REVISION:    $Revision:   1.1  $
;* WORKFILE:    $Workfile:   dhlp024.asm  $
;* LOGINFO:     $Log:   D:/CPROG/MYDEV/DEVLIB/VCS/DHLP024.ASV  $
;*              
;*                 Rev 1.1   17 Dec 1990 14:31:18   PAUL
;*              included devhlp.inc and os2def.h types
;*              
;*                 Rev 1.0   03 Sep 1990 15:03:58   PAUL
;*              Initial revision.
;************************************************************************/
;
	INCLUDE	cdev.inc
	INCLUDE	devhlp.inc


_DATA	SEGMENT
	EXTRN	_DevHelp:DWORD
_DATA	ENDS

_TEXT	SEGMENT
	PUBLIC	_dev_GetDOSVar
;************************************************************************
;* NAME:        _dev_GetDOSVar
;* SYNOPSIS:    USHORT dev_GetDOSVar(USHORT Variable, void _far *pFarPoint)
;*              USHORT        Variable;     Variable of interest value
;*              void far     *pPoint;       Far pointer to far pointer
;* DESCRIPTION: See DevHelp documentation of GetDOSVar.
;* UNMODIFIED REGISTERS:
;*              ds bp si di
;* RETURNS:     ax = 0 -->   no error
;*              else    error code
;************************************************************************
	Variable   = 4
	pFarPoint  = 6
_dev_GetDOSVar	PROC	NEAR
	PUSH	BP
	MOV	BP,SP

	mov	al,[bp+Variable]
	mov	dl,DevHlp_GetDOSVar
	call	[_DevHelp]
	jc	$L000		; jump if error
	mov	cx,bx		; save low word
	les	bx,[bp+pFarPoint]
	mov	es:[bx],cx	; store low word
	mov	es:[bx+2],ax	; store high word
	xor	ax,ax
	jmp	short $L001

$L000:	xor	ax,ax
	dec	ax		; Non-zero returncode
$L001:	POP	BP
	RET
_dev_GetDOSVar	ENDP

_TEXT	ENDS

	END
