;************************************************************************
;* MODULE INFORMATION*
;**********************
;*     FILE     NAME:       dhlp02d.asm
;*     SYSTEM   NAME:       devlib
;*     ORIGINAL AUTHOR(S):  Paul Lemmers
;*     VERSION  NUMBER:     
;*     CREATION DATE:       1990/8/14
;*
;* DESCRIPTION: 
;*              Contains DevHelp AllocGDTSelector function.
;************************************************************************
;* CHANGES INFORMATION **
;************************
;* REVISION:    $Revision:   1.1  $
;* WORKFILE:    $Workfile:   dhlp02d.asm  $
;* LOGINFO:     $Log:   D:/CPROG/MYDEV/DEVLIB/VCS/DHLP02D.ASV  $
;*              
;*                 Rev 1.1   17 Dec 1990 14:31:26   PAUL
;*              included devhlp.inc and os2def.h types
;*              
;*                 Rev 1.0   14 Aug 1990 14:38:32   PAUL
;*              Initial revision.
;************************************************************************/
;
	INCLUDE	cdev.inc
	INCLUDE	devhlp.inc


_DATA	SEGMENT
	EXTRN	_DevHelp:DWORD
_DATA	ENDS

_TEXT	SEGMENT
	PUBLIC	_dev_AllocGDTSelector
;************************************************************************
;* NAME:        dev_AllocGDTSelector
;* SYNOPSIS:    USHORT dev_AllocGDTSelector(PSEL psel, short nsel)
;*              PSEL psel;    Array address where selector will be stored.
;*              short nsel;   Requested number of selectors
;* DESCRIPTION: See DevHelp documentation of AllocGDTSelector.
;* UNMODIFIED REGISTERS:
;*              ds bp si di
;* RETURNS:     ax = 0 -->   no error
;*              else    error code
;************************************************************************
	psel  = 4
	nsel  = 8
_dev_AllocGDTSelector	PROC	NEAR
	PUSH	BP
	MOV	BP,SP
	push	di

	les	di,[bp+psel]
	mov	cx,[bp+nsel]
	mov	dl,DevHlp_AllocGDTSelector
	call	[_DevHelp]
	jc	$L000		; jump if error
	xor	ax,ax

$L000:	pop	di		; restore di
	POP	BP
	RET
_dev_AllocGDTSelector	ENDP

_TEXT	ENDS

	END
