;************************************************************************
;* MODULE INFORMATION*
;**********************
;*     FILE     NAME:       dhlp02e.asm
;*     SYSTEM   NAME:       devlib
;*     ORIGINAL AUTHOR(S):  Paul Lemmers
;*     VERSION  NUMBER:     
;*     CREATION DATE:       1990/8/14
;*
;* DESCRIPTION: 
;*              Contains DevHelp PhysToGDTSelector function.
;************************************************************************
;* CHANGES INFORMATION **
;************************
;* REVISION:    $Revision:   1.1  $
;* WORKFILE:    $Workfile:   dhlp02e.asm  $
;* LOGINFO:     $Log:   D:/CPROG/MYDEV/DEVLIB/VCS/DHLP02E.ASV  $
;*              
;*                 Rev 1.1   17 Dec 1990 14:31:28   PAUL
;*              included devhlp.inc and os2def.h types
;*              
;*                 Rev 1.0   14 Aug 1990 14:39:28   PAUL
;*              Initial revision.
;************************************************************************/
;
	INCLUDE	cdev.inc
	INCLUDE	devhlp.inc


_DATA	SEGMENT
	EXTRN	_DevHelp:DWORD
_DATA	ENDS

_TEXT	SEGMENT
	PUBLIC	_dev_PhysToGDTSelector
;************************************************************************
;* NAME:        dev_PhysToGDTSelector
;* SYNOPSIS:    USHORT dev_PhysToGDTSelector(ULONG phys, USHORT len, SEL sel)
;*              ULONG   phys;    Physical address
;*              USHORT  len;     Length of memory
;*              USHORT  sel;     Future selector for this memory
;* DESCRIPTION: See DevHelp documentation of PhysToGDTSelector.
;* UNMODIFIED REGISTERS:
;*              ds bp si di
;* RETURNS:     ax = 0 -->   no error
;*              else    error code
;************************************************************************
	phys   = 4
	len    = 8
	sel    = 0Ah
_dev_PhysToGDTSelector	PROC	NEAR
	PUSH	BP
	MOV	BP,SP
	push	si

	mov	bx,[bp+phys]
	mov	ax,[bp+phys+2]
	mov	cx,[bp+len]
	mov	si,[bp+sel]
	mov	dl,DevHlp_PhysToGDTSelector
	call	[_DevHelp]
	jc	$L000		; jump if error
	xor	ax,ax

$L000:	pop	si		; restore di
	POP	BP
	RET
_dev_PhysToGDTSelector	ENDP

_TEXT	ENDS

	END
