/************************************************************************
** MODULE INFORMATION*
**********************
**     FILE     NAME:       dprt001.c
**     SYSTEM   NAME:       devlib
**     ORIGINAL AUTHOR(S):  Paul Lemmers
**     VERSION  NUMBER:     
**     CREATION DATE:       1990/8/14
**
** DESCRIPTION: 
**              
*************************************************************************
** CHANGES INFORMATION **
*************************
** REVISION:    $Revision:   1.2  $
** WORKFILE:    $Workfile:   dprt001.c  $
** LOGINFO:     $Log:   D:/CPROG/MYDEV/DEVLIB/VCS/DPRT001.C_V  $
**              
**                 Rev 1.2   17 Dec 1990 14:34:10   PAUL
**              Function headers added
**              
**                 Rev 1.1   09 Dec 1990 19:06:58   PAUL
**              Adaptions for MSC 6.00
**              
**                 Rev 1.0   14 Aug 1990 14:25:38   PAUL
**              Initial revision.
*************************************************************************/
#if ! defined(PRD)
static char _pvcs_hdr[] =
"$Header:   D:/CPROG/MYDEV/DEVLIB/VCS/DPRT001.C_V   1.2   17 Dec 1990 14:34:10   PAUL  $";
#endif

#include <os2def.h>
#include <devdos.h>
#include "devlib.h"


/**************************************************************
** NAME:        dev_printf
** SYNOPSIS:    int dev_printf(const char far *fmt, ...)
**              const char far *fmt;    format specifier as printf,
**                                      see format() for more details.
** DESCRIPTION: Printf() equivalent for a device driver at init time.
**              The use of this function at non init time is absolutely
**              forbidden since it will call DosPutMessage.
** RETURNS:     As printf()
**************************************************************/
int	dev_printf(const char far *fmt, ...)
{
	char	ls[200];
	unsigned len;

	len = format(ls, fmt, (char far *)((&fmt)+1));

	if ( DosPutMessage(1, len, ls) ) /* write to stdout */
		return(0);  /* whoops an error.... */
	else
		return(len);
}
