###
#	name:		makefile
# 	programmer:	Paul Lemmers
#	date:		27 may 1990
#	description:	Make file for devlib files
#	uses:		void
###

!include ..\..\..\include\standard.mak

###
#	The globals
###
opt=				#	the changeable options
dbgopt=  			#	Include /Zi/Od for debugging
lnkopt=				#	Include /CO    for debugging

###
#	The standard definitions
###
stdopt=/W4			# 
resopt=/AS /Aw /Gs /G2 /Ox /Zlp	# dev. driver options for MSC
masmopt=/Cp /W3 /c		#	assembler options
asm=ml $(masmopt) $(dbgopt)	/I.. #	Assembler invocation
cc=cl /c /I.. /DPRD $(stdopt) $(dbgopt) #	C compiler invocation
lnk=LINK /MAP /NOI /NOD		#	Linker invocation
#

all:	dhdw001.obj dhlp006.obj dhlp007.obj dhlp008.obj \
	dhlp013.obj dhlp014.obj dhlp016.obj dhlp018.obj \
	dhlp019.obj dhlp01b.obj dhlp01c.obj dhlp024.obj \
	dhlp027.obj dhlp02d.obj dhlp031.obj dhlp03a.obj \
	dhlp02e.obj dmem001.obj dmem002.obj \
	dstr001.obj dstr002.obj dstr003.obj \
	dstr004.obj dstr005.obj dcnv001.obj \
	dprt100.obj dprt001.obj dprt002.obj \
	devtest1.exe devtest2.exe

clean:
	-$(RM) *.obj
	-$(RM) *.exe

#
# Assembler files
#

dhdw001.obj:	dhdw001.asm \
		cdev.inc
	$(asm) $*.asm

dhlp006.obj:	dhlp006.asm \
		cdev.inc
	$(asm) $*.asm

dhlp007.obj:	dhlp007.asm \
		cdev.inc
	$(asm) $*.asm

dhlp008.obj:	dhlp008.asm \
		cdev.inc
	$(asm) $*.asm

dhlp013.obj:	dhlp013.asm \
		cdev.inc
	$(asm) $*.asm

dhlp014.obj:	dhlp014.asm \
		cdev.inc
	$(asm) $*.asm

dhlp016.obj:	dhlp016.asm \
		cdev.inc
	$(asm) $*.asm

dhlp018.obj:	dhlp018.asm \
		cdev.inc
	$(asm) $*.asm

dhlp019.obj:	dhlp019.asm \
		cdev.inc
	$(asm) $*.asm

dhlp01b.obj:	dhlp01b.asm \
		cdev.inc
	$(asm) $*.asm

dhlp01c.obj:	dhlp01c.asm \
		cdev.inc
	$(asm) $*.asm

dhlp024.obj:	dhlp024.asm \
		cdev.inc
	$(asm) $*.asm

dhlp027.obj:	dhlp027.asm \
		cdev.inc
	$(asm) $*.asm

dhlp02d.obj:	dhlp02d.asm \
		cdev.inc
	$(asm) $*.asm

dhlp02e.obj:	dhlp02e.asm \
		cdev.inc
	$(asm) $*.asm

dhlp031.obj:	dhlp031.asm \
		cdev.inc
	$(asm) $*.asm

dhlp03a.obj:	dhlp03a.asm \
		cdev.inc
	$(asm) $*.asm

dmem001.obj:	dmem001.asm \
		cdev.inc
	$(asm) $*.asm

dmem002.obj:	dmem002.asm \
		cdev.inc
	$(asm) $*.asm

dstr001.obj:	dstr001.asm \
		cdev.inc
	$(asm) $*.asm

dstr002.obj:	dstr002.asm \
		cdev.inc
	$(asm) $*.asm

dstr003.obj:	dstr003.asm \
		cdev.inc
	$(asm) $*.asm

dstr004.obj:	dstr004.asm \
		cdev.inc
	$(asm) $*.asm

dstr005.obj:	dstr005.asm \
		cdev.inc
	$(asm) $*.asm

dcnv001.obj:	dcnv001.asm \
		cdev.inc
	$(asm) $*.asm

#
# C files
#

dprt100.obj:	dprt100.c
	$(cc) $(resopt) $*.c

dprt001.obj:	dprt001.c
	$(cc) $(resopt) $*.c

dprt002.obj:	dprt002.c
	$(cc) $(resopt) $*.c

#
# Test sources
#

devtest1.exe:	devtest1.c \
		dmem001.obj \
		dmem002.obj \
		dstr001.obj \
		dstr002.obj \
		dstr003.obj \
		dstr004.obj \
		dstr005.obj
	cl $(stdopt) /Lp /Zi $**


devtest2.exe:	devtest2.c \
		dprt001.obj \
		dprt002.obj \
		dprt100.obj \
		dmem001.obj \
		dmem002.obj \
		dstr001.obj \
		dcnv001.obj
	cl $(stdopt) /Lp /Zi $**

#	cl $(stdopt) /Zi $** /link /NOD /NOE:SLIBCEP
