#************************************************************************
#* MODULE INFORMATION*
#*********************
#*     FILE     NAME:       makefile
#*     SYSTEM   NAME:       
#*     ORIGINAL AUTHOR(S):  Paul Lemmers
#*     VERSION  NUMBER:     
#*     CREATION DATE:       1990/11/12
#*
#* DESCRIPTION: 
#*              
#************************************************************************
#* CHANGES INFORMATION **
#************************
#* REVISION:    $Revision:   1.2  $
#* WORKFILE:    $Workfile:   makefile  $
#* LOGINFO:     $Log:   D:/CPROG/NDIS/NEUS/VCS/MAKEFILE.__V  $
#*              
#*                 Rev 1.2   15 Jul 1992 13:41:00   PAUL
#*              No change.
#*              
#*                 Rev 1.1   21 Feb 1992 22:25:06   PAUL
#*              Comment prefix update
#*   
#*                 Rev 1.0   16 Feb 1992 18:21:04   PAUL
#*              Initial revision.
#************************************************************************

!include ..\..\include\standard.mak

###
#	The globals
###
dlib=devlib
linc=.              #   local include directory for general device drivers
opt=				#	the changeable options
dbgopt=  			#	Include /Zi/Od for debugging
lnkopt=				#	Include /CO    for debugging
###
#	The standard definitions
###
stdopt=/W4 /I$(linc) /I$(dlib) /AS /Aw /Gs /G2 /Ox /Zlp # dev. driver options for MSC
masmopt=/Cp /c /W3		#	assembler options
olib=obj 			#	Object directory from system
llib=lst			#	List directory from system
tlib=tst		#	Full test directory
asm=ml $(masmopt) $(dbgopt)	#	Assembler invocation
cc=cl /c $(stdopt) $(dbgopt)	#	C compiler invocation
lnk=LINK /MAP /NOI /NOD		#	Linker invocation
h2inc=h2inc $(stdopt) /Ni	#	H2INC options

#
# targets
#
#all:	devlib.all \
#        neus.os2 \
#        neus.lib

devlib.all:
        @cd devlib
        nmake -f msc_os2.mak all
        @cd ..

#install: all $(BINDIR)\neus.os2 $(INCDIR)\ndisdef.h $(INCDIR)\neus.h
install: $(BINDIR)\neus.os2 $(INCDIR)\ndisdef.h $(INCDIR)\neus.h

$(BINDIR)\neus.os2: neus.os2
        $(CP) neus.os2 $(BINDIR)

$(INCDIR)\ndisdef.h: ndisdef.h
        $(CP) ndisdef.h $(INCDIR)

$(INCDIR)\neus.h: neus.h
        $(CP) neus.h $(INCDIR)

clean:
	-$(RM) neusglb.inc
	-$(RM) neus.inc
	-$(RM) ndisdef.inc
	-$(RM) *.lib
	-$(RM) *.map
#	-$(RM) *.os2
	-$(RM) *.sym
	-$(RM) *.lst
	-$(RM) *.err
	-$(RM) *.obj
	-$(RM) *.cod
        @cd devlib
        nmake -f msc_os2.mak clean
        @cd ..

#
# Show combined object/source listing for one file
# Invocation: nmake cmod=neustrat showcod
showcod:	$(cmod).cod

$(cmod).cod:	$(cmod).c
	$(cc) /Fc $(opt) $(cmod).c
	del $(cmod).obj
	
###
# 	The rules for the assembly-files
###
neusmain.obj:	neusmain.asm \
				ndisdef.inc \
				neus.inc \
				neusglb.inc
	$(asm) /Fl neusmain.lst neusmain.asm

neusque.obj:	neusque.asm \
				neusglb.inc
	$(asm) /Fl neusque.lst neusque.asm

neusrel.obj:	neusrel.asm \
				neusglb.inc
	$(asm) /Fl neusrel.lst neusrel.asm

neusend.obj:	neusend.asm \
				neusglb.inc
	$(asm) /Fl neusend.lst neusend.asm

###
# 	The rules for the INC files
# If you only want .INC files: nmake inc
###
inc:	neusglb.inc neus.inc \
	ndisdef.inc

neusglb.inc:	neusglb.h
	@if exist neusglb.inc @del neusglb.inc
	$(h2inc) neusglb.h

neus.inc:	neus.h
	@if exist neus.inc @del neus.inc
	$(h2inc) neus.h

ndisdef.inc:	ndisdef.h
	@if exist ndisdef.inc @del ndisdef.inc
	$(h2inc) ndisdef.h

###
# 	The rules for the real C-files
###
neustrat.OBJ: neustrat.C \
				ndisdef.h \
				$(linc)\cdev.h \
				$(linc)\devioctl.h \
				$(dlib)\devlib.h \
				neus.h \
				neusglb.h
	$(cc) $(opt) neustrat.C

neusinit.OBJ: 	neusinit.C \
				ndisdef.h \
				neus.h \
				$(dlib)\devlib.h \
				$(linc)\devdos.h \
				$(linc)\cdev.h \
				protparm.h \
				neusglb.h
	$(cc) $(opt) neusinit.C

protparm.OBJ: protparm.c \
			  $(dlib)\devlib.h \
			  protparm.h \
			  ndisdef.h
	$(cc) $(opt) protparm.c

###
# 	The Link rule for the system
###
#neus.os2:	neusmain.obj \
#		neustrat.obj \
#		neusque.obj \
#		$(dlib)\dmem001.obj \
#		$(dlib)\dmem002.obj \
#		$(dlib)\dhdw001.obj \
#		$(dlib)\dhlp006.obj \
#		$(dlib)\dhlp007.obj \
#		$(dlib)\dhlp008.obj \
#		$(dlib)\dhlp013.obj \
#		$(dlib)\dhlp014.obj \
#		$(dlib)\dhlp016.obj \
#		$(dlib)\dhlp027.obj \
#		$(dlib)\dhlp02d.obj \
#		$(dlib)\dhlp02e.obj \
#		neusrel.obj \
#		neusinit.obj \
#		neusend.obj \
#		protparm.obj \
#		$(dlib)\dprt001.obj \
#		$(dlib)\dprt100.obj \
#		$(dlib)\dcnv001.obj \
#		neusmain.def \
#		neusmain.lnk
#	$(lnk) $(lnkopt) @neusmain.lnk
#	@if exist neus.os2 @del neus.os2
#	ren neus.exe neus.os2
#	$(MAPSYM) neus

neus.lib:	neusmain.def
	implib neus.lib neusmain.def

###
#
###
neustest.exe:	neustest.C \
		neus.lib \
		$(linc)\cdev.h \
		$(linc)\devioctl.h \
		neus.h
	CL /Lp /W4 /AS /Zi /Zp neustest.C /link neus.lib /CO /NOI
