/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _ALARM_C_H
#define _ALARM_C_H


#include <dnpap.h>
#include <boolset.h>
#include <snmp.h>
#include <timer.h>
#include <event.h>


#define ALARM_BOOLEAN_VARIABLE		1
#define ALARM_BOOLEAN_OWNER			2


typedef struct RmonAlarm_
{
    ULONG Index;
    LONG Interval;                 
	LONG Variable[SNMP_SIZE_OBJECTID];
    WORD VarLen;
	LONG SampleType;               
	LONG Value;                    
	LONG PrevValue;                    
	LONG PrevDeltaValue;                    
	LONG StartupAlarm;             
	LONG RisingThreshold;          
    BOOLEAN RisingEvent;
	LONG FallingThreshold;         
    BOOLEAN FallingEvent;
	ULONG RisingEventIndex;         
	ULONG FallingEventIndex;        
	EventHook *RisingEventHook;
	EventHook *FallingEventHook;
	BYTE Owner[SNMP_SIZE_BUFCHR];     
	WORD OwnerLen;
	WORD Status;                   
	
	TIMER_DESCR *Timer;
	BOOLEAN JustStarted;

    BooleanSet ObjectSet;
	
} RmonAlarm;


BOOLEAN     AlarmCInit(RmonAlarm* alarm);
BOOLEAN     AlarmCStart(RmonAlarm* alarm);
BOOLEAN     AlarmCStop(RmonAlarm* alarm);

WORD        AlarmSample(LONG *id, WORD idlen, LONG *value, SNMP_OBJECT *obj);

VOID		AlarmDeRegisterGenerator(ULONG eventIndex, VOID *generator);

RmonAlarm*  NewRmonAlarm(WORD nrevents);
RmonAlarm*  ReNewRmonAlarm(RmonAlarm* ptr, WORD nrevents);
VOID        DelRmonAlarm(RmonAlarm* ptr);


#endif
