/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _CHANNEL_H
#define _CHANNEL_H


#include <dnpap.h>
#include <snmp.h>
#include <mac.h>

#include "channelx.h"


BOOLEAN ChannelMInit(VOID);

WORD ChannelIndex (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelIfIndex (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelAcceptType (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelDataControl (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelTurnOnEventIndex (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelTurnOffEventIndex (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelEventIndex (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelEventStatus (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelMatches (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelDescription (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelOwner (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);
WORD ChannelStatus (SNMP_OBJECT *Obj, WORD IdLen, VOID *param);

BOOLEAN ChannelRegisterAllGenerators(ULONG eventIndex);
BOOLEAN ChannelRegisterAllParties(ULONG eventIndex);

FilterCallback *ChannelRegisterFilter(ULONG channelIndex, ChannelFilterCallback match, ChannelFilterDeRegisterCallback deregister, VOID *filter);
BOOLEAN ChannelDeRegisterFilter(ULONG channelIndex, FilterCallback *callback);
SinkCallback *ChannelRegisterSink(ULONG channelIndex, ChannelSinkCallback callback, ChannelSinkDeRegisterCallback deregister, VOID *sink);
BOOLEAN ChannelDeRegisterSink(ULONG channelIndex, SinkCallback *callback);


#endif
