/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _EVENT_C_H
#define _EVENT_C_H


#include <dnpap.h>
#include <boolset.h>
#include <log.h>


#define EVENT_BOOLEAN_COMMUNITY		1
#define EVENT_BOOLEAN_OWNER			2


#define EVENT_SIZE_DESCR  128
#define EVENT_SIZE_COMM   128


struct Event_
{     
    ULONG Index;
	CHAR Description[EVENT_SIZE_DESCR];
    WORD DescrLen;
	LONG Type;
	BYTE Community[EVENT_SIZE_COMM];
    WORD CommLen;
	ULONG LastTimeSent;
	BYTE Owner[SNMP_SIZE_BUFCHR];
	WORD OwnerLen;
	WORD Status;
	
    LONG NrLogs;
	LONG LogPos;
	ULONG LogIndex;
	BOOLEAN LogBounced;
	Log **Logs;

	EventHook *Generators;	           
    PartyCallback *Parties;
    
    BooleanSet ObjectSet;
};


struct EventHook_
{   
    EventGeneratorDeRegisterCallback DeRegister;
    Event *Event;
	VOID *Generator;
    EventHook *Prev;
    EventHook *Next;
};


struct PartyCallback_
{   
    EventPartyCallback Notify;
    EventPartyDeRegisterCallback DeRegister;
    VOID *Party;
    PartyCallback *Prev;
    PartyCallback *Next;
};


BOOLEAN     EventCInit(Event* event);
BOOLEAN     EventCStart(Event* event);
BOOLEAN     EventCStop(Event* event);

Event*  NewEvent(VOID);
VOID    DelEvent(Event* ptr);

EventHook *EventAddGenerator(Event* event, EventGeneratorDeRegisterCallback deregister, VOID *generator);
BOOLEAN EventRemoveGenerator(Event* event, EventHook *hook);

PartyCallback *EventAddParty(Event* event, EventPartyCallback notify, EventPartyDeRegisterCallback deregister, VOID *party);
BOOLEAN EventRemoveParty(Event* event, PartyCallback *callback);
BOOLEAN EventNotify(Event* event);


#endif

