/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _HOSTC_H
#define _HOSTC_H


#include <dnpap.h>
#include <boolset.h>
#include <snmp.h>
#include <hash.h>
#include <channel.h>

/*  hostx.h exposes the HOST structure  */
#include "hostx.h"


#define HOST_BOOLEAN_DATASOURCE		1
#define HOST_BOOLEAN_OWNER			2


typedef struct _HOST_CONTROL
{
    ULONG            Index;
    ULONG           Source[SNMP_SIZE_BUFINT];
    WORD            SourceLen;
    BOOLEAN         Channel;
    SinkCallback   *ChannelCallback;
	WORD			AddressLen;
    LONG            TableSize;
    ULONG           LastDeleteTime;
    BYTE            Owner[SNMP_SIZE_BUFCHR];
    WORD            OwnerLen;
    LONG            Status;
    
    MAC_COLL        Coll;
    MAC_IFACE       *Iface;
    
    HashTable	    *Table;
    
    HOST	        *LexList;
    
    HOST	        *TimeList;
    HOST	        *TimeLast;
    HOST	        **TimeTable;
    BOOLEAN			TimeListUpdated;
    
    HOST            *LRUList;
    HOST            *LRULast;

    TopNCallback    *TopNs;
    
	BooleanSet       ObjectSet;
    
} HOST_CONTROL;


struct TopNCallback_
{   
    HostTopNCallback Notify;
    VOID *TopN;             
    TopNCallback *Prev;
    TopNCallback *Next;
};


BOOLEAN HostConfigInit(VOID);

BOOLEAN HostCInit(HOST_CONTROL *hostcontrol);
BOOLEAN HostCStart(HOST_CONTROL *hostcontrol);
BOOLEAN HostCStop(HOST_CONTROL *hostcontrol);

TopNCallback *HostAddTopN(HOST_CONTROL *hostcontrol, HostTopNCallback notify, VOID *topn);
BOOLEAN HostRemoveTopN(HOST_CONTROL *hostcontrol, TopNCallback *callback);

VOID HostChannelPkt(ULONG channelIndex, int type, PROT_PKT *pkt, VOID *sink);
VOID HostDeRegister(ULONG channelIndex, VOID *sink);

HOST* HostSearchNext(HOST_CONTROL *hostcontrol, HOST *host, WORD len);
HOST* HostSearchHash(HOST_CONTROL *hostcontrol, SNMP_OBJECT *obj, WORD idlen);
HOST* HostTimeSearch(HOST_CONTROL *hostcontrol, SNMP_OBJECT *obj, WORD idlen);
LONG  HostSearchCreationOrder(HOST_CONTROL *hostcontrol, HOST *host);


#endif
