/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _HOSTX_H
#define _HOSTX_H


#include <dnpap.h>


#define HOST_SIZE_ADDR    	6	/* maximum of address sizes shown below */

#define ETH_SIZE_ADDR       6


typedef struct _HOST
{
    BYTE        Address[HOST_SIZE_ADDR];
    ULONG       InPkts;
    ULONG       OutPkts;
    ULONG       InOctets;
    ULONG       OutOctets;
    ULONG       OutErrors;
    ULONG       OutBroadcastPkts;
    ULONG       OutMulticastPkts;

    struct _HOST  *LexPrev;
    struct _HOST  *LexNext;

	struct _HOST  *TimePrev;    
	struct _HOST  *TimeNext;    
    
    struct _HOST  *LRUPrev;
    struct _HOST  *LRUNext;
    
    struct _HOST  **TimeListPtr;
    
} HOST;


#define HOST_EVENT_RESET	1
#define HOST_EVENT_UPDATE	2
#define HOST_EVENT_STOP		3
	  
#define HOST_FLAG_IN			0x0001
#define HOST_FLAG_OUT			0x0002
#define HOST_FLAG_MULTICAST 	0x0004
#define HOST_FLAG_BROADCAST 	0x0008
#define HOST_FLAG_ERROR 		0x0010


typedef VOID (*HostTopNCallback)(ULONG hostIndex, int event, HOST *host, WORD addrlen, int flags, LWORD size, VOID *topn);

typedef struct TopNCallback_ TopNCallback;


#endif
