/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _STATC_H
#define _STATC_H


#include <dnpap.h>
#include <boolset.h>
#include <mac.h>
#include <timer.h>
#include <snmp.h>


#define STAT_BOOLEAN_DATASOURCE		1
#define STAT_BOOLEAN_OWNER			2


typedef struct _ETHER_STATS
{
    ULONG           Source[SNMP_SIZE_BUFINT];
    WORD            SourceLen;
    MAC_STAT        BaseStat;
    ULONG           Octets; 
    ULONG           Pkts; 
    ULONG           Pkts64Octets; 
    ULONG           Pkts65to127Octets; 
    ULONG           Pkts128to255Octets; 
    ULONG           Pkts256to511Octets;
    ULONG           Pkts512to1023Octets;
    ULONG           Pkts1024to1518Octets;
    BYTE            Owner[SNMP_SIZE_BUFCHR];
    WORD            OwnerLen;
    LONG            Status;

    MAC_IFACE       *Iface;
    MAC_COLL        Coll;

    BooleanSet      ObjectSet;

} ETHER_STATS;


BOOLEAN EtherStatsCInit (ETHER_STATS *etherStats);
BOOLEAN EtherStatsCStart (ETHER_STATS *etherStats);
BOOLEAN EtherStatsCStop (ETHER_STATS *etherStats);

VOID EtherStatsHandlePkt(ETHER_STATS *etherStats, PROT_PKT *pkt);


#endif
