/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _TOPN_C_H
#define _TOPN_C_H


#include <dnpap.h>
#include <boolset.h>
#include <hash.h>
#include <mibsup.h>
#include <timer.h>
#include <hostx.h>

#include "topn_d.h"


#define TOPN_BOOLEAN_DATASOURCE		1
#define TOPN_BOOLEAN_OWNER			2


typedef struct _TOPN_ENTRY
{
	BYTE  Address[HOST_SIZE_ADDR];
    ULONG PrevValue;        /*  statistics in host structure are ULONG's too  */
	ULONG Rate;

    struct _TOPN_ENTRY  *Prev;
    struct _TOPN_ENTRY  *Next;
	
} TOPN_ENTRY;


typedef struct _TOPN_CONTROL
{
    ULONG  HostIndex;
    TopNCallback *HostCallback;
    WORD  AddressLen;
    LONG  RateBase;
    LONG  TimeRemaining;
    LONG  Duration;
    LONG  RequestedSize;
    LONG  GrantedSize;
    ULONG StartTime;
    BYTE  Owner[SNMP_SIZE_BUFCHR];
    WORD  OwnerLen;
    WORD  Status;

    LONG  TableSize;
    HashTable *Table;
    
    TOPN_ENTRY  *TopNEntries;
    TOPN_ENTRY  *TopNLast;
    TOPN_ENTRY **TopNArray;
    
    TIMER_DESCR *Timer;

	BooleanSet   ObjectSet;
    
} TOPN_CONTROL;


BOOLEAN TopNCInit(TOPN_CONTROL *topncontrol);
BOOLEAN TopNCStart(TOPN_CONTROL *topncontrol);
BOOLEAN TopNCStop(TOPN_CONTROL *topncontrol);

LONG TopNGranted(LONG requested);

VOID HostTopNNotify(ULONG hostindex, int event, HOST *host, WORD addrlen, int flags, LWORD size, VOID *topn);

BOOLEAN EntryAddList(TOPN_CONTROL *topncontrol, TOPN_ENTRY *entry);
BOOLEAN EntryUpdateList(TOPN_CONTROL *topncontrol, TOPN_ENTRY *entry);
TOPN_ENTRY* TopNEntrySearch(TOPN_CONTROL *topncontrol, SNMP_OBJECT *obj, WORD idlen);
      
BOOLEAN FillEntryTable(TOPN_CONTROL *topncontrol, LONG reqsize);


#endif
