/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _FILTER2C_H
#define _FILTER2C_H

#include <dnpap.h>
#include <boolset.h>
#include <snmp.h>
#include <channelx.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <bpf.h>


#define FILTER2_BOOLEAN_CHANNEL		1
#define FILTER2_BOOLEAN_OWNER		2


typedef struct bpf_program PROGRAM;
typedef struct bpf_insn INSN;


typedef struct _FILTER2
{
    ULONG    ChannelIndex;
    FilterCallback *ChannelCallback;
	PROGRAM  Program;
    BYTE     Owner[SNMP_SIZE_BUFCHR];
    WORD     OwnerLen;
    LONG     Status;

    BooleanSet ObjectSet;

} FILTER2;


BOOLEAN Filter2CInit(FILTER2 *filter);
BOOLEAN Filter2CStart(FILTER2 *filter);
BOOLEAN Filter2CStop(FILTER2 *filter);

BOOLEAN Filter2Pkt(ULONG channelIndex, int type, PROT_PKT *pkt, VOID *filter);
VOID Filter2DeRegister(ULONG channelIndex, VOID *filter);


#endif
