/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _BPF_H_
#define _BPF_H_

 
#include <nw.h>
#include <mac.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>

      
#define BPF_MTU     1500
#define BPF_FRAME   2048


typedef struct _BPF_DESCR	BPF_DESCR;


struct _BPF_DESCR
{
    BPF_DESCR   *next;
    NW_DG       *nw; 
    MAC_IFACE   *mac;
	ULONG		offset;		/* offset of interface data into kernel memory */

    ULONG       LostPkts;
    ULONG       Octets;
    ULONG       Pkts;
    ULONG       BroadcastPkts;
    ULONG       MulticastPkts;
    ULONG       CRCAlignErrors;         
    ULONG       UndersizePkts;            
    ULONG       OversizePkts;             
    ULONG       Fragments;
    ULONG       Jabbers;         
    ULONG       BufferedPkts;
    ULONG       StackedPkts;
    ULONG       DiscardedPkts;
    ULONG       TruncatedPkts; 

	ULONG		OutPkts;
	ULONG       OutOctets;
	ULONG       OutDiscards;
    ULONG       OutBroadcastPkts;
    ULONG       OutMulticastPkts;

	/* extra interface parameters from kernel memory */
	ULONG       OutQLen;
	ULONG		InErrors;
	ULONG		OutErrors;
    ULONG       Collisions;
};           


BOOLEAN BpfInit(void);
void    BpfExit(void);


#endif
