/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _DLPI_H_
#define _DLPI_H_

 
#include <kstat.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>

#include <nw.h>
#include <mac.h>

      
#define DLPI_MTU    1500
#define DLPI_FRAME  2048

#define DLPI_SIZE_IFNET 1024


typedef struct _DLPI_DESCR	DLPI_DESCR;


struct _DLPI_DESCR
{
    DLPI_DESCR  *next;
    NW_DG       *nw; 
    MAC_IFACE   *mac;
	kstat_t		*stats;
	BOOLEAN		Offsets;
	SHORT		CollisionsOffset;
	SHORT		InPktsOffset;
	SHORT		InErrorsOffset;
	SHORT		OutPktsOffset;
	SHORT		OutErrorsOffset;
	SHORT		FrammingsOffset;
	SHORT		CRCsOffset;

    ULONG       LostPkts;
    ULONG       Octets;
    ULONG       Pkts;
    ULONG       BroadcastPkts;
    ULONG       MulticastPkts;
    ULONG       CRCAlignErrors;         
    ULONG       UndersizePkts;            
    ULONG       OversizePkts;             
    ULONG       Fragments;
    ULONG       Jabbers;         
    ULONG       BufferedPkts;
    ULONG       StackedPkts;
    ULONG       DiscardedPkts;
    ULONG       TruncatedPkts; 

	ULONG		OutPkts;
	ULONG       OutOctets;
	ULONG       OutDiscards;
    ULONG       OutBroadcastPkts;
    ULONG       OutMulticastPkts;

	/* extra interface parameters from kernel statistics */
	ULONG		InErrors;
	ULONG		OutErrors;
    ULONG       Collisions;

	ULONG		Frammings;
};


BOOLEAN DlpiInit(void);
void    DlpiExit(void);


#endif
