/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#include <chain.h>
#include <udp.h>
#include "echod.h"



static BOOLEAN Rcve(UDP_DESCR *descr, CHAIN *chain, UDP_HDR *udpHdr, IP_HDR *ipHdr);



UDP_DESCR echodUdp =
{
    Rcve,
    7,
    UDP_ADDR_ANY,
    UDP_PORT_ANY,
    UDP_ADDR_ANY,
    0
};

ECHOD_STAT echodStat;


BOOLEAN EchodInit(void)
{
    static BOOLEAN init = FALSE;
    
    if (!init)
    {
        init = UdpRegister(&echodUdp);
    }

    return init;
}


ECHOD_STAT *EchodStatistics(void)
{
    return &echodStat;
}



static BOOLEAN Rcve(UDP_DESCR *descr, CHAIN *chain, UDP_HDR *udpHdr, IP_HDR *ipHdr)
{
    WORD    port;
    DWORD   addr;
    BOOLEAN success = FALSE;
    
    port        = udpHdr->src;
    udpHdr->src = udpHdr->dst;
    udpHdr->dst = port;

    addr        = ipHdr->src;
    ipHdr->src  = ipHdr->dst;
    ipHdr->dst  = addr;

    success = UdpSend(chain, udpHdr, ipHdr, descr);
    
    if (success)
        echodStat.datagrams++;
    else
        echodStat.errors++;

    return success;
}
