/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _ETH_H_
#define _ETH_H_

 
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>

#include <nw.h>
#include <mac.h>

      
#define ETH_MTU		1500
#define ETH_FRAME	2048

#define ETH_STATS			"/proc/net/dev"
#define ETH_STATS_FORMAT	"%lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu"
#define ETH_STATS_SIZE		11



typedef struct _ETH_DESCR	ETH_DESCR;


struct _ETH_DESCR
{
    ETH_DESCR   *next;
    NW_DG       *nw; 
    MAC_IFACE   *mac;

    ULONG       LostPkts;
    ULONG       Octets;
    ULONG       Pkts;
    ULONG       BroadcastPkts;
    ULONG       MulticastPkts;
    ULONG       CRCAlignErrors;         
    ULONG       UndersizePkts;            
    ULONG       OversizePkts;             
    ULONG       Fragments;
    ULONG       Jabbers;         
    ULONG       BufferedPkts;
    ULONG       StackedPkts;
    ULONG       DiscardedPkts;
    ULONG       TruncatedPkts; 

	ULONG		OutPkts;
	ULONG       OutOctets;
	ULONG       OutDiscards;
    ULONG       OutBroadcastPkts;
    ULONG       OutMulticastPkts;

	/* extra interface parameters from kernel memory */
	ULONG		InErrors;
	ULONG		OutErrors;
	ULONG		InDrops;
	ULONG		OutDrops;
    ULONG       Collisions;
};           


BOOLEAN EthInit(void);
void    EthExit(void);


#endif
