/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _ICMP_H_
#define _ICMP_H_


#include <dnpap.h>
#include <ip.h>
#include <chain.h>

typedef struct _ICMP_HDR                ICMP_HDR;
typedef struct _ICMP_DESCR              ICMP_DESCR;


struct _ICMP_HDR
{
    BYTE        type;
    BYTE        code;
    WORD        check;
    WORD        id;
    WORD        seqnr;
};


struct _ICMP_DESCR
{
	BOOLEAN     (*Rcve)(ICMP_DESCR *descr, CHAIN *chain, ICMP_HDR *icmpHdr, IP_HDR *ipHdr);
    BYTE        type;
    BYTE        code;
    WORD        id;
    WORD        seqnr;
	DWORD    	locAddr;
	DWORD       remAddr;
    VOID        *specific;
    ICMP_DESCR  *next;
};


#define ICMP_UNREACHABLE     3
#define ICMP_QUENCH          4
#define ICMP_TIME_EXCEEDED   11
#define ICMP_PARM_PROBLEM    12
#define ICMP_REDIRECT        5

#define ICMP_ECHO_REQUEST    8
#define ICMP_ECHO_REPLY      0
#define ICMP_STAMP_REQUEST   13
#define ICMP_STAMP_REPLY     14
#define ICMP_INFO_REQUEST    15
#define ICMP_INFO_REPLY      16

#define ICMP_CODE_ANY        0xff
#define ICMP_TYPE_ANY        0xff
#define ICMP_ADDR_ANY        0xffffffffL
#define ICMP_ID_ANY          0xffff
#define ICMP_SEQNR_ANY       0xffff



BOOLEAN IcmpInit(void);
BOOLEAN IcmpRegister(ICMP_DESCR *icmp);
BOOLEAN IcmpRemove(ICMP_DESCR *icmp);
BOOLEAN IcmpSend(CHAIN *chain, ICMP_HDR *icmpHdr, IP_HDR *ipHdr);
WORD    IcmpAnyId(VOID);





#endif
