

include ../../include/gcc_unx.std


MCFLAGS = -I/data/d4/develop

SYS	= subscript
SYSLIB	= subscript

WEAVE = nuweb -o
TANGLE = nuweb -t

TEX = latex

TOUCH = touch

.SUFFIXES: .w .tex .h .c .dvi .o .ps


all: tangle.ok obj #doc

install: all $(INCDIR)/$(SYS).h $(INCDIR)/$(SYS)x.h $(INCDIR)/$(SYS)l.h $(LIBDIR)/lib$(SYSLIB).a

$(INCDIR)/$(SYS).h: $(SYS).h
	$(CP) $(SYS).h $(INCDIR)/$(SYS).h

$(INCDIR)/$(SYS)x.h: $(SYS)x.h
	$(CP) $(SYS)x.h $(INCDIR)/$(SYS)x.h

$(INCDIR)/$(SYS)l.h: $(SYS)l.h
	$(CP) $(SYS)l.h $(INCDIR)/$(SYS)l.h

$(LIBDIR)/lib$(SYSLIB).a: $(SYS)m.o $(SYS)c.o $(SYS)l.o
	$(AR) $(LIBDIR)/lib$(SYSLIB).a $(SYS)m.o $(SYS)c.o $(SYS)l.o
	ranlib $(LIBDIR)/lib$(SYSLIB).a


clean:
	- $(RM) *.exe
	- $(RM) *.obj
	- $(RM) *.o
	- $(RM) *.i
	- $(RM) *.lib
	- $(RM) *.man
	- $(RM) *.err
	- $(RM) *.bak


tangle.ok: $(SYS).w
	$(TANGLE) $(SYS).w
	$(TOUCH) tangle.ok


doc: $(SYS).dvi

$(SYS).dvi: $(SYS).tex
	$(TEX) $(SYS).tex
	$(WEAVE) $(SYS).w
	$(TEX) $(SYS).tex

$(SYS).tex: $(SYS).w
	$(WEAVE) $(SYS).w

obj: $(SYS)m.o $(SYS)c.o $(SYS)l.o

$(SYS)m.o: $(SYS)m.c $(SYS)c.h $(SYS)x.h $(SYS)l.c $(SYS).h
$(SYS)c.o: $(SYS)c.c $(SYS)c.h $(SYS)x.h $(SYS)l.c
$(SYS)l.o: $(SYS)l.c $(SYS)c.h

