
#line 3276 "subscript.w"

#ifndef _SUBSCRIPTL_H_
#define _SUBSCRIPTL_H_


#ifdef SUBSCRIPT_PERL
#include <perl/INTERN.h>
#include <perl/perl.h>
#undef WORD
#endif
#include <dnpap.h>
#include <hash.h>
#include <mibsup.h>
#include <protocol.h>
#include <mac.h>
#include <timer.h>
#include <channel.h>
#include <event.h>
#include <nw.h>
#include <nwsnmpdef.h>
#include <scheme.h>


#line 3604 "subscript.w"

typedef CHAR *(*RunGetsFunction)(VOID *run, int line);
typedef int (*RunPutsFunction)(VOID *run, int line, CHAR *log);

#line 3298 "subscript.w"


#line 3611 "subscript.w"

typedef struct LanguageCallback_ LanguageCallback;

typedef struct _LANGUAGE_MIB_OBJECT
{
    MIB_OBJECT          *object;
    int                 offset;
} LANGUAGE_MIB_OBJECT;

struct LanguageCallback_
{
	int id;
	BOOLEAN suspend;

	VOID *language;
	LanguageCallback *prev;
	LanguageCallback *next;

	VOID *callback;
	VOID *param;
	union
	{
		TIMER_DESCR  *timer;
		struct
		{
			int interface;
			MAC_COLL coll;
		} mac;
		struct
		{
			int index;
			SinkCallback  *callback;
		} channel;
		struct
		{
			int index;
			FilterCallback  *callback;
		} filter;
		struct
		{
			int index;
			EventHook  *hook;
		} generator;
		struct
		{
			int index;
			PartyCallback  *callback;
		} event;
        LANGUAGE_MIB_OBJECT mib;
		struct
		{
			int request;
			NW_DG *conn;
		} snmp;
		NW_DG *accept;
	} callbacks;
};

#line 3299 "subscript.w"



#line 3728 "subscript.w"

#define SCHEME_HASH_SIZE_KEY		32

#line 3301 "subscript.w"



#line 3674 "subscript.w"

typedef struct Scheme_
{
    VOID				*run;
    RunGetsFunction		rungets;
    RunPutsFunction		runputs;

    Scheme_Env			*env;

    Scheme_Object		*init;
    Scheme_Object		*start;
    Scheme_Object		*stop;
    Scheme_Object		*resume;
    Scheme_Object		*exit;

	LanguageCallback	*macs;
	LanguageCallback	*timers;
	LanguageCallback	*filters;
	LanguageCallback	*channels;
	LanguageCallback	*generators;
	LanguageCallback	*events;
	LanguageCallback	*mibs;
	LanguageCallback	*snmps;
	LanguageCallback	*traps;

	Scheme_Object		*stdinport;
	Scheme_Object		*stdoutport;
    CHAR				*stdindata;
    int					stdinline;
    int					stdinpos;
    CHAR				*stdoutdata;
    int					stdoutline;
    int					stdoutpos;

	Scheme_Object		*hash_type;
	Scheme_Object		*packet_type;
	Scheme_Object		*varbind_type;

} Scheme;

#line 3717 "subscript.w"

typedef struct Scheme_Assoc_Entry_
{
	BYTE key[SCHEME_HASH_SIZE_KEY];
	Scheme_Object *data;

} Scheme_Assoc_Entry;

#line 3303 "subscript.w"


#line 6973 "subscript.w"

typedef struct Perl_
{
#ifdef SUBSCRIPT_PERL
    VOID				*run;
    RunGetsFunction		rungets;
    RunPutsFunction		runputs;

    PerlInterpreter		*env;

    OP					*init;
    OP					*start;
    OP					*stop;
    OP					*resume;
    OP					*exit;

	LanguageCallback	*macs;
	LanguageCallback	*timers;
	LanguageCallback	*filters;
	LanguageCallback	*channels;
	LanguageCallback	*generators;
	LanguageCallback	*events;
	LanguageCallback	*mibs;
	LanguageCallback	*snmps;
	LanguageCallback	*traps;
#endif

} Perl;

#line 3304 "subscript.w"



#line 3734 "subscript.w"

#define SCHEME_HASHP(obj)		(SCHEME_TYPE(obj) == scheme->hash_type)
#define SCHEME_VARBINDP(obj)	(SCHEME_TYPE(obj) == scheme->varbind_type)

#line 3306 "subscript.w"



#line 2428 "subscript.w"

#define RUN_COMMAND_NULL			0
#define RUN_COMMAND_INIT			1
#define RUN_COMMAND_START			2
#define RUN_COMMAND_STOP			3
#define RUN_COMMAND_RESUME			4
#define RUN_COMMAND_EXIT			5

#line 3308 "subscript.w"



#line 3749 "subscript.w"

VOID *SchemeInit(RunGetsFunction rungets,
                 RunPutsFunction runputs,
                 VOID *run);

#line 3310 "subscript.w"


#line 3927 "subscript.w"

BOOLEAN SchemeCall(Scheme *scheme, int command);

#line 3311 "subscript.w"


#line 4001 "subscript.w"

VOID SchemeExit(Scheme *scheme);

#line 3312 "subscript.w"



#line 7011 "subscript.w"

VOID *PerlInit(RunGetsFunction rungets,
               RunPutsFunction runputs,
			   VOID *run);

#line 3314 "subscript.w"


#line 7069 "subscript.w"

BOOLEAN PerlCall(Perl *perl, int command);

#line 3315 "subscript.w"


#line 7118 "subscript.w"

VOID PerlExit(Perl *perl);

#line 3316 "subscript.w"



#line 4090 "subscript.w"

int SchemeInputGetc(Scheme_Input_Port *port);

#line 3318 "subscript.w"


#line 4117 "subscript.w"

void SchemeInputUnGetc(int c, Scheme_Input_Port *port);

#line 3319 "subscript.w"


#line 4155 "subscript.w"

int SchemeInputPoll(Scheme_Input_Port *port);

#line 3320 "subscript.w"


#line 4174 "subscript.w"

void SchemeInputClose(Scheme_Input_Port *port);

#line 3321 "subscript.w"


#line 4188 "subscript.w"

void SchemeOutputPuts(char *s, Scheme_Output_Port *port);

#line 3322 "subscript.w"


#line 4204 "subscript.w"

void SchemeOutputClose(Scheme_Output_Port *port);

#line 3323 "subscript.w"



#line 6716 "subscript.w"

BOOLEAN AddCallback(LanguageCallback **list, LanguageCallback *entry);

#line 3325 "subscript.w"


#line 6735 "subscript.w"

LanguageCallback *SearchCallback(LanguageCallback *list, int id);

#line 3326 "subscript.w"


#line 6755 "subscript.w"

LanguageCallback *RemoveCallback(LanguageCallback **list, int id);

#line 3327 "subscript.w"


#line 6774 "subscript.w"

VOID CutCallback(LanguageCallback **list, LanguageCallback *entry);

#line 3328 "subscript.w"



#line 3875 "subscript.w"

VOID SchemeContextInit(VOID);

#line 3330 "subscript.w"


#line 3889 "subscript.w"

Scheme *SchemeContextSwitch(Scheme *scheme);

#line 3331 "subscript.w"


#line 3913 "subscript.w"

Scheme *SchemeContextCurrent(VOID);

#line 3332 "subscript.w"



#line 7192 "subscript.w"

VOID PerlContextInit(VOID);

#line 3334 "subscript.w"


#line 7206 "subscript.w"

Perl *PerlContextSwitch(Perl *perl);

#line 3335 "subscript.w"


#line 7226 "subscript.w"

Perl *PerlContextCurrent(VOID);

#line 3336 "subscript.w"


#endif
