
#line 1665 "subscript.w"


#line 1708 "subscript.w"

#include <dnpap.h>
#include <boolset.h>
#include <message.h>
#include <mibsup.h>
#include <mibrqs.h>

#include "subscriptl.h"
#include "subscriptc.h"
#include "subscript.h"

#line 1666 "subscript.w"



#line 1721 "subscript.w"

#define INDEX_SIZE_CONTROL    1
#define INDEX_SIZE_SOURCE     2
#define INDEX_SIZE_ERROR      2

#line 1668 "subscript.w"



#line 1728 "subscript.w"

static MIB_LOCAL *SubscriptSourceControlInstance = NULL;
static MIB_LOCAL *SubscriptRunControlInstance = NULL;

#line 1670 "subscript.w"



#line 1734 "subscript.w"

static BOOLEAN SubscriptSourceMibNext(SNMP_OBJECT *obj, MIB_LOCAL **local, WORD idlen, WORD indexsize, SourceLine **line);
static BOOLEAN SubscriptRunMibNext(SNMP_OBJECT *obj, MIB_LOCAL **local, WORD idlen, WORD indexsize, LogLine **line);

#line 1672 "subscript.w"



#line 1746 "subscript.w"

BOOLEAN SubscriptMInit(VOID)
{
	MessageConfig(SUBSCRIPT_ERROR, "Subscript");
	if (SubscriptConfigInit() == FALSE)
		return FALSE;
	return TRUE;
}

#line 1674 "subscript.w"



#line 1758 "subscript.w"

#define SOURCECONTROL_DATA	((Script *)(*local)->Data)

BOOLEAN SubscriptSourceMibNext(SNMP_OBJECT *obj, MIB_LOCAL **local, WORD idlen, WORD indexsize, SourceLine **line)
{
BOOLEAN first = FALSE;

	if (*local == NULL || indexsize < 1)
		return FALSE;

	if (obj->Id[idlen] < (*local)->Index)
		first = TRUE;

	switch (indexsize)
	{
	case INDEX_SIZE_SOURCE:
		if (first == FALSE && obj->IdLen >= idlen + indexsize)
		{
			if ((*line = SourceListGetNextLine(SOURCECONTROL_DATA->Source, obj->Id[idlen+1])) != NULL)
			{
				obj->Id[idlen] = (*local)->Index;
				obj->Id[idlen+1] = (*line)->LineNumber;
				obj->IdLen = idlen + INDEX_SIZE_SOURCE;
				break;
			}
			*local = (*local)->Next;
		}
		while (*local != NULL && SOURCECONTROL_DATA->Source->Lines == 0)
			*local = (*local)->Next;
		if (*local == NULL)
			return FALSE;
		*line = SourceListGetNextLine(SOURCECONTROL_DATA->Source, 0);
		obj->Id[idlen] = (*local)->Index;
		obj->Id[idlen+1] = (*line)->LineNumber;
		obj->IdLen = idlen + INDEX_SIZE_SOURCE;
		break;
	case INDEX_SIZE_CONTROL:
		if (first == FALSE && obj->IdLen >= idlen + indexsize)
		{
			/* only go to next collector if requested index was higher or equal */
			if (obj->Id[idlen] >= (*local)->Index)
				*local = (*local)->Next;
			if (*local == NULL)
				return FALSE;
		}
		obj->Id[idlen] = (*local)->Index;
		obj->IdLen = idlen + INDEX_SIZE_CONTROL;
		break;
	}
	return TRUE;
}

#line 1676 "subscript.w"


#line 1812 "subscript.w"

#define RUNCONTROL_DATA	((Run *)(*local)->Data)

BOOLEAN SubscriptRunMibNext(SNMP_OBJECT *obj, MIB_LOCAL **local, WORD idlen, WORD indexsize, LogLine **line)
{
BOOLEAN first = FALSE;

	if (*local == NULL || indexsize < 1)
		return FALSE;

	if (obj->Id[idlen] < (*local)->Index)
		first = TRUE;

	switch (indexsize)
	{
	case INDEX_SIZE_SOURCE:
		if (first == FALSE && obj->IdLen >= idlen + indexsize)
		{
			if ((*line = LogListGetNextLine(RUNCONTROL_DATA->Logs, obj->Id[idlen+1])) != NULL)
			{
				obj->Id[idlen] = (*local)->Index;
				obj->Id[idlen+1] = (*line)->LineNumber;
				obj->IdLen = idlen + INDEX_SIZE_SOURCE;
				break;
			}
			*local = (*local)->Next;
		}
		while (*local != NULL && RUNCONTROL_DATA->Logs->Lines == 0)
			*local = (*local)->Next;
		if (*local == NULL)
			return FALSE;
		*line = LogListGetNextLine(RUNCONTROL_DATA->Logs, 0);
		obj->Id[idlen] = (*local)->Index;
		obj->Id[idlen+1] = (*line)->LineNumber;
		obj->IdLen = idlen + INDEX_SIZE_SOURCE;
		break;
	case INDEX_SIZE_CONTROL:
		if (first == FALSE && obj->IdLen >= idlen + indexsize)
		{
			/* only go to next collector if requested index was higher or equal */
			if (obj->Id[idlen] >= (*local)->Index)
				*local = (*local)->Next;
			if (*local == NULL)
				return FALSE;
		}
		obj->Id[idlen] = (*local)->Index;
		obj->IdLen = idlen + INDEX_SIZE_CONTROL;
		break;
	}
	return TRUE;
}

#line 1677 "subscript.w"



#line 118 "subscript.w"

WORD SubscriptSourceControlIndex(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;

	if ((local = MibRmon(obj, SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptSourceMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		obj->Syntax.LngInt = local->Index;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
	return SNMP_GENERROR;
}

#line 1679 "subscript.w"


#line 165 "subscript.w"

WORD SubscriptSourceControlFileName(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Script *data;
	SourceList *source;

	if ((local = MibRmon(obj, SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptSourceMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Script *) local->Data;
		memcpy(obj->Syntax.BufChr, data->FileName, obj->SyntaxLen = data->FileNameLen);
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		data = (Script *) local->Data;
		if (data->Status != SNMP_UNDERCREATION)
			return SNMP_READONLY;
		memcpy(data->FileName, obj->Syntax.BufChr, data->FileNameLen = obj->SyntaxLen);
        /* run FileExists() to update FileStatus */
        if (FileExists(data) == TRUE && data->Source->Lines == 0)
        {
            if ((source = FileRead(data)) == NULL)
            	return SNMP_GENERROR;
            SourceListDel(data->Source);
            data->Source = source;
        }
		return SNMP_NOERROR;
	case SNMP_PDU_COMMIT:
		return SNMP_NOERROR;
	case SNMP_PDU_UNDO:
		return SNMP_GENERROR;
	}
	return SNMP_GENERROR;
}

#line 1680 "subscript.w"


#line 240 "subscript.w"

WORD SubscriptSourceControlFileStatus(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Script *data;
	SourceList *source;

	if ((local = MibRmon(obj, SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptSourceMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Script *) local->Data;
        /* FileStatus is changed in File.*() functions */
        if (data->FileStatus == FILE_STATUS_NULL)
            FileExists(data);
		obj->Syntax.LngInt = data->FileStatus;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		data = (Script *) local->Data;
		if (data->Status != SNMP_UNDERCREATION)
			return SNMP_READONLY;
        if (obj->Syntax.LngInt < FILE_STATUS_SAVE ||
            obj->Syntax.LngInt > FILE_STATUS_RELOAD)
            return SNMP_BADVALUE;
        switch (obj->Syntax.LngInt)
        {
        case FILE_STATUS_SAVE:
            if (FileExists(data) == TRUE)
                return SNMP_BADVALUE;
            if (FileWrite(data) == FALSE)
                return SNMP_BADVALUE;
            break;
        case FILE_STATUS_OVERWRITE:
            if (FileWrite(data) == FALSE)
                return SNMP_BADVALUE;
            break;
        case FILE_STATUS_RELOAD:
            if (FileExists(data) == FALSE)
                return SNMP_BADVALUE;
            if ((source = FileRead(data)) == NULL)
                return SNMP_GENERROR;
            SourceListDel(data->Source);
            data->Source = source;
            break;
        default:
            return SNMP_GENERROR;
        }
		return SNMP_NOERROR;
	case SNMP_PDU_COMMIT:
		return SNMP_NOERROR;
	case SNMP_PDU_UNDO:
		return SNMP_GENERROR;
	}
	return SNMP_GENERROR;
}

#line 1681 "subscript.w"


#line 326 "subscript.w"

WORD SubscriptSourceControlLanguage(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Script *data;

	if ((local = MibRmon(obj, SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptSourceMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Script *) local->Data;
        if (data->Language == SCRIPT_LANGUAGE_NULL)
            return SNMP_NOSUCHNAME;
		obj->Syntax.LngInt = data->Language;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		data = (Script *) local->Data;
		if (data->Status != SNMP_UNDERCREATION)
			return SNMP_READONLY;
		switch (obj->Syntax.LngInt)
		{
		case SCRIPT_LANGUAGE_SCHEME:
		case SCRIPT_LANGUAGE_PERL:
			break;
		default:
            return SNMP_BADVALUE;
		}
		data->Language = obj->Syntax.LngInt;
		return SNMP_NOERROR;
	case SNMP_PDU_COMMIT:
		return SNMP_NOERROR;
	case SNMP_PDU_UNDO:
		return SNMP_GENERROR;
	}
	return SNMP_GENERROR;
}

#line 1682 "subscript.w"


#line 388 "subscript.w"

WORD SubscriptSourceControlLines(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Script *data;

	if ((local = MibRmon(obj, SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptSourceMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Script *) local->Data;
		obj->Syntax.LngInt = data->Source->Lines;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
	return SNMP_GENERROR;
}

#line 1683 "subscript.w"


#line 436 "subscript.w"

WORD SubscriptSourceControlOwner(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Script *data;
	SourceList *source;

	if ((local = MibRmon(obj, SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptSourceMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Script *) local->Data;
		if (BeholderStrictRMON && !BooleanCheck(data->ObjectSet, SUBSCRIPT_SOURCE_BOOLEAN_OWNER))
			return SNMP_NOSUCHNAME;
		memcpy(obj->Syntax.BufChr, data->Owner, obj->SyntaxLen = data->OwnerLen);
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		data = (Script *) local->Data;
#ifdef RMON_OWNER_STRICT
		if (data->Status != SNMP_UNDERCREATION)
			return SNMP_READONLY;
#endif
		memcpy(data->Owner, obj->Syntax.BufChr, data->OwnerLen = obj->SyntaxLen);
        /* run FileExists() to update FileStatus */
        if (FileExists(data) == TRUE && data->Source->Lines == 0)
        {
            if ((source = FileRead(data)) == NULL)
            	return SNMP_GENERROR;
            SourceListDel(data->Source);
            data->Source = source;
        }
		BooleanSetTrue(data->ObjectSet, SUBSCRIPT_SOURCE_BOOLEAN_OWNER);
		return SNMP_NOERROR;
	case SNMP_PDU_COMMIT:
		return SNMP_NOERROR;
	case SNMP_PDU_UNDO:
		return SNMP_GENERROR;
	}
	return SNMP_GENERROR;
}

#line 1684 "subscript.w"


#line 504 "subscript.w"

WORD SubscriptSourceControlStatus(SNMP_OBJECT *obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Script *data;

	local = MibRmon(obj, SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL);

	switch (obj->Request)
	{
	case SNMP_PDU_GET:
		if (local == NULL)
		{
			obj->Syntax.LngInt = SNMP_INVALID;
			return SNMP_NOSUCHNAME;
		}
		data = (Script *) local->Data;
		obj->Syntax.LngInt = data->Status;
		return SNMP_NOERROR;
	case SNMP_PDU_NEXT:
		if (SubscriptSourceMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
		{
			obj->Syntax.LngInt = SNMP_INVALID;
			return SNMP_NOSUCHNAME;
		}
		data = (Script *) local->Data;
		obj->Syntax.LngInt = data->Status;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		if (local == NULL)
		{
			switch (obj->Syntax.LngInt)
			{
			case SNMP_CREATEREQUEST:
				if ((local = MibInsert(obj, &SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
					return SNMP_GENERROR;
				if ((local->Data = ScriptNew()) == NULL)
				{
					MibRemove(obj, &SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL);
					return SNMP_GENERROR;
				}
				data = (Script *) local->Data;
				if (SubscriptSourceCInit(data) == TRUE)
				{
					data->Index = local->Index;
					data->Status = SNMP_UNDERCREATION;
					DnpapMessage(DMC_MESSAGE, SUBSCRIPT_CREATE, "subscriptSource: collector %ld created", local->Index);
					return SNMP_NOERROR;
				}
				ScriptDel(local->Data);
				MibRemove(obj, &SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL);
				return SNMP_GENERROR;
			default:
				return SNMP_NOSUCHNAME;
			}
		}
		data = (Script *) local->Data;
		switch (data->Status)
		{
		case SNMP_UNDERCREATION:
			switch (obj->Syntax.LngInt)
			{
			case SNMP_VALID:
				if (SubscriptSourceCStart(data) == TRUE)
				{
					data->Status = SNMP_VALID;
					DnpapMessage(DMC_MESSAGE, SUBSCRIPT_ACTIVE, "subscriptSource: collector %ld active", local->Index);
					return SNMP_NOERROR;
				}
				return SNMP_BADVALUE;
			case SNMP_INVALID:
				if (SubscriptSourceCStop(data) == TRUE)
				{
					ScriptDel(local->Data);
					DnpapMessage(DMC_MESSAGE, SUBSCRIPT_DESTROY, "subscriptSource: collector %ld destroyed", local->Index);
					if (MibRemove(obj, &SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL) == TRUE)
						return SNMP_NOERROR;
				}
				return SNMP_GENERROR;
			case SNMP_UNDERCREATION:
				return SNMP_NOERROR;
			default:
				return SNMP_BADVALUE;
			}
		case SNMP_VALID:
			switch (obj->Syntax.LngInt)
			{
			case SNMP_INVALID:
				if (SubscriptSourceCStop(data) == TRUE)
				{
					ScriptDel(local->Data);
					DnpapMessage(DMC_MESSAGE, SUBSCRIPT_DESTROY, "subscriptSource: collector %ld destroyed", local->Index);
					if (MibRemove(obj, &SubscriptSourceControlInstance, idlen, INDEX_SIZE_CONTROL) == TRUE)
						return SNMP_NOERROR;
				}
				return SNMP_GENERROR;
			case SNMP_UNDERCREATION:
				if (SubscriptSourceCStop(data) == FALSE)
					return SNMP_GENERROR;
				data->FileStatus = FILE_STATUS_NULL;
            	SourceListDel(data->Source);
				data->Source = SourceListNew();
				data->Status = SNMP_UNDERCREATION;
				return SNMP_NOERROR;
			case SNMP_VALID:
				return SNMP_NOERROR;
			default:
				return SNMP_BADVALUE;
			}
		}
	case SNMP_PDU_COMMIT:
		return SNMP_NOERROR;
	case SNMP_PDU_UNDO:
		return SNMP_GENERROR;
	}
	return SNMP_GENERROR;
}

#line 1685 "subscript.w"



#line 696 "subscript.w"

WORD SubscriptSourceIndex(SNMP_OBJECT *obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Script *data;
	SourceLine *line = NULL;

	if ((local = MibRmon(obj, SubscriptSourceControlInstance, idlen, INDEX_SIZE_SOURCE)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptSourceMibNext(obj, &local, idlen, INDEX_SIZE_SOURCE, &line) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Script *) local->Data;
		if (line == NULL && (line = SourceListGetLine(data->Source, obj->Id[idlen+1])) == NULL)
			return SNMP_NOSUCHNAME;
		obj->Syntax.LngInt = local->Index;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
	return SNMP_GENERROR;
}

#line 1687 "subscript.w"


#line 744 "subscript.w"

WORD SubscriptSourceLineNumber(SNMP_OBJECT *obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Script *data;
	SourceLine *line = NULL;

	if ((local = MibRmon(obj, SubscriptSourceControlInstance, idlen, INDEX_SIZE_SOURCE)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptSourceMibNext(obj, &local, idlen, INDEX_SIZE_SOURCE, &line) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Script *) local->Data;
		if (line == NULL && (line = SourceListGetLine(data->Source, obj->Id[idlen+1])) == NULL)
			return SNMP_NOSUCHNAME;
		obj->Syntax.LngInt = obj->Id[idlen+1];
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
	return SNMP_GENERROR;
}

#line 1688 "subscript.w"


#line 797 "subscript.w"

WORD SubscriptSourceLine(SNMP_OBJECT *obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Script *data;
	SourceLine *line = NULL;

	if ((local = MibRmon(obj, SubscriptSourceControlInstance, idlen, INDEX_SIZE_SOURCE)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptSourceMibNext(obj, &local, idlen, INDEX_SIZE_SOURCE, &line) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Script *) local->Data;
		if (line == NULL && (line = SourceListGetLine(data->Source, obj->Id[idlen+1])) == NULL)
			return SNMP_NOSUCHNAME;
		memcpy(obj->Syntax.BufChr, line->Line, obj->SyntaxLen = strlen(line->Line));
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		data = (Script *) local->Data;
		if (data->Status != SNMP_UNDERCREATION)
			return SNMP_READONLY;
        if (obj->SyntaxLen == strlen(SOURCE_STRING_DELETE) && strncmp(obj->Syntax.BufChr, SOURCE_STRING_DELETE, strlen(SOURCE_STRING_DELETE)) == 0)
        {
            if (SourceListDelLine(data->Source, obj->Id[idlen+1]) == FALSE)
    			return SNMP_BADVALUE;
        }
        else
        {
	    	if (SourceListAddLine(data->Source, obj->Id[idlen+1], obj->Syntax.BufChr, (int)obj->SyntaxLen) == FALSE)
    			return SNMP_BADVALUE;
        }
		return SNMP_NOERROR;
	case SNMP_PDU_COMMIT:
		return SNMP_NOERROR;
	case SNMP_PDU_UNDO:
		return SNMP_GENERROR;
	}
	return SNMP_GENERROR;
}

#line 1689 "subscript.w"



#line 914 "subscript.w"

WORD SubscriptRunControlIndex(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;

	if ((local = MibRmon(obj, SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptRunMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		obj->Syntax.LngInt = local->Index;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
	return SNMP_GENERROR;
}

#line 1691 "subscript.w"


#line 959 "subscript.w"

WORD SubscriptRunControlScript(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Run *data;

	if ((local = MibRmon(obj, SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptRunMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Run *) local->Data;
        if (data->Script == 0)
    		return SNMP_NOSUCHNAME;
		obj->Syntax.LngInt = data->Script;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		data = (Run *) local->Data;
		if (data->Status != SNMP_UNDERCREATION)
			return SNMP_READONLY;
		if (obj->Syntax.LngInt < 1)
			return SNMP_BADVALUE;
		data->Script = obj->Syntax.LngInt;
		return SNMP_NOERROR;
	case SNMP_PDU_COMMIT:
		return SNMP_NOERROR;
	case SNMP_PDU_UNDO:
		return SNMP_GENERROR;
	}
	return SNMP_GENERROR;
}

#line 1692 "subscript.w"


#line 1031 "subscript.w"

WORD SubscriptRunControlCommand(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Run *data;

	if ((local = MibRmon(obj, SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptRunMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Run *) local->Data;
		if (data->Status != SNMP_VALID || data->Command == RUN_COMMAND_NULL)
			return SNMP_NOSUCHNAME;
		obj->Syntax.LngInt = data->Command;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		data = (Run *) local->Data;
		if (data->Status != SNMP_VALID)
			return SNMP_NOSUCHNAME;
		switch (obj->Syntax.LngInt)
		{
     /* case RUN_COMMAND_INIT:
      *  	if (data->Command != RUN_COMMAND_NULL)
      *  	    return SNMP_BADVALUE;
      *  	break;
	  */
		case RUN_COMMAND_START:
			if (data->Command != RUN_COMMAND_INIT)
				return SNMP_BADVALUE;
			break;
		case RUN_COMMAND_STOP:
			if (data->Command != RUN_COMMAND_START && data->Command != RUN_COMMAND_RESUME)
				return SNMP_BADVALUE;
			break;
		case RUN_COMMAND_RESUME:
			if (data->Command != RUN_COMMAND_STOP)
				return SNMP_BADVALUE;
			break;
     /* case RUN_COMMAND_EXIT:
	  * 	if (data->Command != RUN_COMMAND_STOP)
	  * 		return SNMP_BADVALUE;
	  *     break;
	  */
		default:
			return SNMP_BADVALUE;
		}
  	 	if (RunDoCommand(data, obj->Syntax.LngInt) == FALSE)
   	 	    return SNMP_GENERROR;
   	 	/* data->Command is set by RunDoCommand */
		return SNMP_NOERROR;
	case SNMP_PDU_COMMIT:
		return SNMP_NOERROR;
	case SNMP_PDU_UNDO:
		return SNMP_GENERROR;
	}
	return SNMP_GENERROR;
}

#line 1693 "subscript.w"


#line 1116 "subscript.w"

WORD SubscriptRunControlLines(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Run *data;

	if ((local = MibRmon(obj, SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptRunMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Run *) local->Data;
		obj->Syntax.LngInt = data->Logs->Lines;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
	return SNMP_GENERROR;
}

#line 1694 "subscript.w"


#line 1158 "subscript.w"

WORD SubscriptRunControlOwner(SNMP_OBJECT * obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Run *data;

	if ((local = MibRmon(obj, SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptRunMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Run *) local->Data;
		if (BeholderStrictRMON && !BooleanCheck(data->ObjectSet, SUBSCRIPT_RUN_BOOLEAN_OWNER))
			return SNMP_NOSUCHNAME;
		memcpy(obj->Syntax.BufChr, data->Owner, obj->SyntaxLen = data->OwnerLen);
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		data = (Run *) local->Data;
#ifdef RMON_OWNER_STRICT
		if (data->Status != SNMP_UNDERCREATION)
			return SNMP_READONLY;
#endif
		memcpy(data->Owner, obj->Syntax.BufChr, data->OwnerLen = obj->SyntaxLen);
		BooleanSetTrue(data->ObjectSet, SUBSCRIPT_RUN_BOOLEAN_OWNER);
		return SNMP_NOERROR;
	case SNMP_PDU_COMMIT:
		return SNMP_NOERROR;
	case SNMP_PDU_UNDO:
		return SNMP_GENERROR;
	}
	return SNMP_GENERROR;
}

#line 1695 "subscript.w"


#line 1220 "subscript.w"

WORD SubscriptRunControlStatus(SNMP_OBJECT *obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Run *data;

	local = MibRmon(obj, SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL);

	switch (obj->Request)
	{
	case SNMP_PDU_GET:
		if (local == NULL)
		{
			obj->Syntax.LngInt = SNMP_INVALID;
			return SNMP_NOSUCHNAME;
		}
		data = (Run *) local->Data;
		obj->Syntax.LngInt = data->Status;
		return SNMP_NOERROR;
	case SNMP_PDU_NEXT:
		if (SubscriptRunMibNext(obj, &local, idlen, INDEX_SIZE_CONTROL, NULL) == FALSE)
		{
			obj->Syntax.LngInt = SNMP_INVALID;
			return SNMP_NOSUCHNAME;
		}
		data = (Run *) local->Data;
		obj->Syntax.LngInt = data->Status;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		if (local == NULL)
		{
			switch (obj->Syntax.LngInt)
			{
			case SNMP_CREATEREQUEST:
				if ((local = MibInsert(obj, &SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL)) == NULL)
					return SNMP_GENERROR;
				if ((local->Data = RunNew()) == NULL)
				{
					MibRemove(obj, &SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL);
					return SNMP_GENERROR;
				}
				data = (Run *) local->Data;
				if (SubscriptRunCInit(data) == TRUE)
				{
					data->Index = local->Index;
					data->Status = SNMP_UNDERCREATION;
					DnpapMessage(DMC_MESSAGE, SUBSCRIPT_CREATE, "subscriptRun: collector %ld created", local->Index);
					return SNMP_NOERROR;
				}
				RunDel(local->Data);
				MibRemove(obj, &SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL);
				return SNMP_GENERROR;
			default:
				return SNMP_NOSUCHNAME;
			}
		}
		data = (Run *) local->Data;
		switch (data->Status)
		{
		case SNMP_UNDERCREATION:
			switch (obj->Syntax.LngInt)
			{
			case SNMP_VALID:
				if (SubscriptRunCStart(data) == TRUE)
				{
					data->Status = SNMP_VALID;
					DnpapMessage(DMC_MESSAGE, SUBSCRIPT_ACTIVE, "subscriptRun: collector %ld active", local->Index);
					return SNMP_NOERROR;
				}
				return SNMP_BADVALUE;
			case SNMP_INVALID:
				if (SubscriptRunCStop(data) == TRUE)
				{
					RunDel(local->Data);
					DnpapMessage(DMC_MESSAGE, SUBSCRIPT_DESTROY, "subscriptRun: collector %ld destroyed", local->Index);
					if (MibRemove(obj, &SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL) == TRUE)
						return SNMP_NOERROR;
				}
				return SNMP_GENERROR;
			case SNMP_UNDERCREATION:
				return SNMP_NOERROR;
			default:
				return SNMP_BADVALUE;
			}
		case SNMP_VALID:
			switch (obj->Syntax.LngInt)
			{
			case SNMP_INVALID:
				if (SubscriptRunCStop(data) == TRUE)
				{
					RunDel(local->Data);
					DnpapMessage(DMC_MESSAGE, SUBSCRIPT_DESTROY, "subscriptRun: collector %ld destroyed", local->Index);
					if (MibRemove(obj, &SubscriptRunControlInstance, idlen, INDEX_SIZE_CONTROL) == TRUE)
						return SNMP_NOERROR;
				}
				return SNMP_GENERROR;
			case SNMP_UNDERCREATION:
				if (SubscriptRunCStop(data) == FALSE)
					return SNMP_GENERROR;
				data->Command = RUN_COMMAND_NULL;
            	LogListDel(data->Logs);
				data->Logs = LogListNew();
				data->LogLine = 1;
				data->Status = SNMP_UNDERCREATION;
				return SNMP_NOERROR;
			case SNMP_VALID:
				return SNMP_NOERROR;
			default:
				return SNMP_BADVALUE;
			}
		}
	case SNMP_PDU_COMMIT:
		return SNMP_NOERROR;
	case SNMP_PDU_UNDO:
		return SNMP_GENERROR;
	}
	return SNMP_GENERROR;
}

#line 1696 "subscript.w"



#line 1413 "subscript.w"

WORD SubscriptRunLogIndex(SNMP_OBJECT *obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Run *data;
	LogLine *line = NULL;

	if ((local = MibRmon(obj, SubscriptRunControlInstance, idlen, INDEX_SIZE_ERROR)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptRunMibNext(obj, &local, idlen, INDEX_SIZE_ERROR, &line) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Run *) local->Data;
		if (line == NULL && (line = LogListGetLine(data->Logs, obj->Id[idlen+1])) == NULL)
			return SNMP_NOSUCHNAME;
		obj->Syntax.LngInt = local->Index;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
	return SNMP_GENERROR;
}

#line 1698 "subscript.w"


#line 1461 "subscript.w"

WORD SubscriptRunLogLineNumber(SNMP_OBJECT *obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Run *data;
	LogLine *line = NULL;

	if ((local = MibRmon(obj, SubscriptRunControlInstance, idlen, INDEX_SIZE_ERROR)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptRunMibNext(obj, &local, idlen, INDEX_SIZE_ERROR, &line) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Run *) local->Data;
		if (line == NULL && (line = LogListGetLine(data->Logs, obj->Id[idlen+1])) == NULL)
			return SNMP_NOSUCHNAME;
		obj->Syntax.LngInt = obj->Id[idlen+1];
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
	return SNMP_GENERROR;
}

#line 1699 "subscript.w"


#line 1509 "subscript.w"

WORD SubscriptRunLogLine(SNMP_OBJECT *obj, WORD idlen, VOID *param)
{
	MIB_LOCAL *local = NULL;
	Run *data;
	LogLine *line = NULL;

	if ((local = MibRmon(obj, SubscriptRunControlInstance, idlen, INDEX_SIZE_ERROR)) == NULL)
		return SNMP_NOSUCHNAME;

	switch (obj->Request)
	{
	case SNMP_PDU_NEXT:
		if (SubscriptRunMibNext(obj, &local, idlen, INDEX_SIZE_ERROR, &line) == FALSE)
			return SNMP_NOSUCHNAME;
	case SNMP_PDU_GET:
		data = (Run *) local->Data;
		if (line == NULL && (line = LogListGetLine(data->Logs, obj->Id[idlen+1])) == NULL)
			return SNMP_NOSUCHNAME;
		memcpy(obj->Syntax.BufChr, line->Line, obj->SyntaxLen = strlen(line->Line));
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
	return SNMP_GENERROR;
}

#line 1700 "subscript.w"



#line 1872 "subscript.w"

ScriptHook *SubscriptRegisterRun(ULONG scriptIndex)
{
ScriptHook *hook;
MIB_LOCAL *local;
Script *data;

	if (scriptIndex == 0)
		return NULL;

	for (local = SubscriptSourceControlInstance; local != NULL; local = local->Next)
	{
		data = (Script *) local->Data;
        if (local->Index < scriptIndex)
            continue;
        if (local->Index != scriptIndex)
            return NULL;
        if (data->Status != SNMP_VALID)
            return NULL;
        if ((hook = SubscriptAddRun(data)) != NULL)
            return hook;
        break;
	}

    return NULL;
}

#line 1702 "subscript.w"


#line 1906 "subscript.w"

BOOLEAN SubscriptDeRegisterRun(ULONG scriptIndex, ScriptHook *hook)
{
	MIB_LOCAL *local;
	Script *data;

	if (scriptIndex == 0 || hook == NULL)
		return TRUE;

	for (local = SubscriptSourceControlInstance; local != NULL; local = local->Next)
	{
		data = (Script *) local->Data;
        if (local->Index < scriptIndex)
            continue;
        if (local->Index != scriptIndex)
            return FALSE;
        if (SubscriptRemoveRun(data, hook) == TRUE)
            return TRUE;
        break;
	}

    return FALSE;
}

#line 1703 "subscript.w"

