/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dnpap.h>
#include <config.h>
#include <snmp.h>
#include <mibsup.h>
#include <mibrqs.h>
#include <time.h>
#ifdef UNIX
#include <sys/types.h>
#include <sys/time.h>
#include <pwd.h>
#endif

#include "control.h"

#define BEHOLDER_EXIT	BEHOLDER_ERROR

#define BEHOLDER_TIME_FORMAT	"%H:%M:%S %d-%m-%Y %Z"

static CHAR beholderUser[SNMP_SIZE_BUFCHR] = "user";
static CHAR beholderPath[SNMP_SIZE_BUFCHR] = "";
EXPORT CHAR *beholderVersion = VERSION;
static CHAR beholderStart[SNMP_SIZE_BUFCHR] = "";
static LONG beholderStatus = BEHOLDER_STATUS_VALID;

BOOLEAN ControlMInit(CHAR * argv0)
{
#ifdef UNIX
	struct passwd *passwd;

#endif
	time_t now;
	struct tm *tm;

#ifdef UNIX
	if ((passwd = getpwuid(getuid())) != NULL)
		strcpy(beholderUser, passwd->pw_name);
#endif

	strcpy(beholderPath, argv0);
	time(&now);
	tm = localtime(&now);
	strftime(beholderStart, SNMP_SIZE_BUFCHR, BEHOLDER_TIME_FORMAT, tm);

	return TRUE;
}

WORD BeholderUser(SNMP_OBJECT * obj, WORD idlen, VOID * param)
{
	if (MibSimple(obj, idlen) == FALSE)
		return SNMP_NOSUCHNAME;
	if (obj->Request == SNMP_PDU_SET)
		return SNMP_NOSUCHNAME;
	memcpy(obj->Syntax.BufChr, beholderUser, obj->SyntaxLen = strlen(beholderUser));
	return SNMP_NOERROR;
}

WORD BeholderPath(SNMP_OBJECT * obj, WORD idlen, VOID * param)
{
	if (MibSimple(obj, idlen) == FALSE)
		return SNMP_NOSUCHNAME;
	if (obj->Request == SNMP_PDU_SET)
		return SNMP_NOSUCHNAME;
	memcpy(obj->Syntax.BufChr, beholderPath, obj->SyntaxLen = strlen(beholderPath));
	return SNMP_NOERROR;
}

WORD BeholderVersion(SNMP_OBJECT * obj, WORD idlen, VOID * param)
{
	if (MibSimple(obj, idlen) == FALSE)
		return SNMP_NOSUCHNAME;
	if (obj->Request == SNMP_PDU_SET)
		return SNMP_NOSUCHNAME;
	memcpy(obj->Syntax.BufChr, beholderVersion, obj->SyntaxLen = strlen(beholderVersion));
	return SNMP_NOERROR;
}

WORD BeholderStart(SNMP_OBJECT * obj, WORD idlen, VOID * param)
{
	if (MibSimple(obj, idlen) == FALSE)
		return SNMP_NOSUCHNAME;
	if (obj->Request == SNMP_PDU_SET)
		return SNMP_NOSUCHNAME;
	memcpy(obj->Syntax.BufChr, beholderStart, obj->SyntaxLen = strlen(beholderStart));
	return SNMP_NOERROR;
}

WORD BeholderStatus(SNMP_OBJECT * obj, WORD idlen, VOID * param)
{
	if (MibSimple(obj, idlen) == FALSE)
		return SNMP_NOSUCHNAME;
	if (obj->Request == SNMP_PDU_SET)
	{
		switch (obj->Syntax.LngInt)
		{
		case BEHOLDER_STATUS_VALID:
			beholderStatus = obj->Syntax.LngInt;
			break;
		case BEHOLDER_STATUS_INVALID:
			DnpapMessage(DMC_MESSAGE, BEHOLDER_EXIT, "Beholder TNG exit !");
			DnpapExit(0);
			break;
		default:
			return SNMP_BADVALUE;
		}
	}
	else
	{
		obj->Syntax.LngInt = beholderStatus;
	}
	return SNMP_NOERROR;
}
