LIBDIR  = k:\btng\lib
INCDIR  = k:\btng\include
BINDIR  = k:\btng\bin
MANDIR  = k:\btng\man
HLPDIR  = k:\btng\help

MODEL   = L
MODE    = p

# minimal system
#CFLAGS  = $(XCFLAGS) $(MCFLAGS)
# full system
#CFLAGS  = $(XCFLAGS) $(MCFLAGS) -DDNPAP_RMON_EXTENSIONS -DNEURO -DDISCOVERY -DPACKETTYPE 
# full system with internal performance test
CFLAGS  = $(XCFLAGS) $(MCFLAGS) -DDNPAP_RMON_EXTENSIONS -DNEURO -DDISCOVERY -DPERFORMANCE_TEST -DPACKETTYPE 

LFLAGS  = $(XLFLAGS) $(MLFLAGS)

#
# Define -DNOUDP if you don't have IBM TCP/IP 1.2 for OS/2
#
# CCFLAGS  = -Zi -Gt1024 -W4 -DMSC -DOS2 -DSNORAVAIL -I$(INCDIR) -L$(MODE) -A$(MODEL) $(CFLAGS)
# develop
CCFLAGS  = -Zi -Gt1024 -W4 -DMSC -DOS2 -DSNORAVAIL -I$(INCDIR) -L$(MODE) -A$(MODEL) $(CFLAGS)
# distribution
# CCFLAGS  = -Gt1024 -W4 -DMSC -DOS2 -DSNORAVAIL -I$(INCDIR) -L$(MODE) -A$(MODEL) $(CFLAGS)

LDFLAGS = -F 6000 -L$(MODE) $(LFLAGS)

CC      = cl
AR      = lib
RM      = del
CP      = copy
MK      = nmake
CD      = cd
PS      = tooaps
MN      = tooman
RC      = rc
QH      = helpmake
ZIP     = zip
PR      = lpr
CI      = cfg2ini
COMPILE = $(CC) $(CCFLAGS) -c
LINK    = $(CC) $(CCFLAGS) $(LDFLAGS)
MAN     = $(MN) -Extra -Ps -Sort -QR -I -Kop:$(SYS)
MAKE    = $(MK)
MARKEXE = markexe
MAPSYM  = mapsym

.SUFFIXES:
.SUFFIXES: .c .h .obj .exe .lib .man .hlp .hps .cps .asm .aps .cfg .ini


.c.obj:
    $(CC) $(CCFLAGS) -c $*.c
.c.exe:
     $(CC) $(CCFLAGS) $(LDFLAGS) $*.c 
.obj.exe:
    $(CC) $(CCFLAGS) $(LDFLAGS) $*.obj 
.h.hps:
    $(PS) $*.h > $*.hps
.c.cps:
    $(PS) $*.c > $*.cps
.asm.aps:
    $(PS) $*.asm > $*.aps
.c.man:
    $(MN) -Kop:$* -Extra -Ps -Sort -QR -I $*.c > $*.man
.asm.man:
    $(MN) -Kop:$* -Extra -Ps -Sort -QR -I $*.asm > $*.man
.c.hlp:
    $(MN) -Kop:$* -Extra -QH -Sort -TS480 -TA4 -X $*.c > $*.tmp
    $(QH) /e15 /t /a: /O$*.hlp $*.tmp
    $(RM) $*.tmp
.asm.hlp:
    $(MN) -Kop:$* -Extra -QH -Sort -TS480 -TA4 -X $*.asm > $*.tmp
    $(QH) /e15 /t /a: /O$*.hlp $*.tmp
    $(RM) $*.tmp
.cfg.ini:
    $(CI) $*.cfg

