/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <dnpap.h>
#include <dstring.h>
#include <message.h>

#include "maxmem.h"

#define NRBLOCKS    100

void main(int argc, char *argv[])
{
	LONG i, count;
	VOID *p, *q;
	BYTE *t;
	VOID *r[NRBLOCKS];

	/* test the Memory functions */

	ConfigInit(argc, argv);
	ConfigLoad();

	MemoryInit(0, 0);

	MessageInit("stdio:out", MSGFILE, MSGSTDIO, NULL);
	MessageConfig(BEHOLDER_ERROR, "Beholder");

	DnpapMessage(DMC_MESSAGE, 0, "starting Tester");

	DnpapMessage(DMC_MESSAGE, 3, "MemoryGetAvail: %ld", MemoryGetAvail());
	DnpapMessage(DMC_MESSAGE, 4, "MemoryGetMaxChunk: %ld", MemoryGetMaxChunk());
	DnpapMessage(DMC_MESSAGE, 5, "MemoryGetUsed: %ld", MemoryGetMaxMemory() - MemoryGetAvail());
	DnpapMessage(DMC_MESSAGE, 5, "MemoryGetUsed2: %ld", MemoryGetUsed());

	DnpapMessage(DMC_MESSAGE, 1, "allocating 4 bytes");
	p = DnpapMalloc(4);
	DnpapMessage(DMC_MESSAGE, 1, "releasing 4 bytes");
	DnpapFree(p);
	DnpapMessage(DMC_MESSAGE, 1, "reallocating 12 bytes");
	p = DnpapRealloc(p, 12);

	DnpapMessage(DMC_MESSAGE, 1, "allocating 16 bytes");
	t = DnpapMalloc(16);
	DnpapMessage(DMC_MESSAGE, 1, "filling 17 bytes");
	for (i = 0; i < 17; i++)
		t[i] = 15;
	DnpapMessage(DMC_MESSAGE, 1, "releasing 16 bytes");
	DnpapFree(t);
	DnpapMessage(DMC_MESSAGE, 1, "releasing 16 bytes again");
	DnpapFree(t);

	DnpapMessage(DMC_MESSAGE, 1, "allocating 16 bytes");
	t = DnpapMalloc(16);
	DnpapMessage(DMC_MESSAGE, 1, "filling byte -1");
	t[-1] = 15;
	DnpapMessage(DMC_MESSAGE, 1, "reallocating 3 bytes");
	t = DnpapRealloc(t, 13);
	DnpapMessage(DMC_MESSAGE, 1, "reallocating 33 bytes");
	t = DnpapRealloc(t, 33);
	DnpapMessage(DMC_MESSAGE, 1, "releasing 33 bytes");
	DnpapFree(t);
	DnpapMessage(DMC_MESSAGE, 1, "releasing 33 bytes again");
	DnpapFree(t);

	DnpapMessage(DMC_MESSAGE, 1, "allocating 2000 bytes");
	p = DnpapMalloc(2000);
	DnpapMessage(DMC_MESSAGE, 2, "allocating 20000 bytes");
	q = DnpapMalloc(20000);

	DnpapMessage(DMC_MESSAGE, 5, "MemoryGetUsed2: %ld", MemoryGetUsed());

	for (i = 0; i < NRBLOCKS; i++)
		r[i] = NULL;

	count = 0;
	for (i = 0; i < NRBLOCKS; i++)
	{
		r[i] = DnpapMalloc(1000);
		if (!r[i])
		{
			if (p)
			{
				DnpapFree(p);
				p = NULL;
			}
			else if (q)
			{
				DnpapFree(q);
				q = NULL;
			}
			else
			{
				DnpapMessage(DMC_MESSAGE, 6, "Number of blocks allocated: %d", count);
				break;
			}
		}
		else
			count++;
	}

	DnpapMessage(DMC_MESSAGE, 6, "Number of blocks allocated: %d", count);

	for (i = 0; i < NRBLOCKS; i++)
	{
		DnpapFree(r[i]);
		r[i] = NULL;
	}

	DnpapMessage(DMC_MESSAGE, 5, "MemoryGetUsed2: %ld", MemoryGetUsed());
    
	for (count = 0; count < 100000; count++)
	{
		i = rand() % NRBLOCKS;
		if (r[i] == NULL)
			r[i] = DnpapMalloc(53);
		else
		{
			if ((rand() % 10) > 5)
				r[i] = DnpapRealloc(r[i], 1053);
			else
			{
				DnpapFree(r[i]);
				r[i] = NULL;
			}
		}
	}

	for (i = 0; i < NRBLOCKS; i++)
	{
		DnpapFree(r[i]);
		r[i] = NULL;
	}

	DnpapMessage(DMC_MESSAGE, 3, "MemoryGetAvail: %ld", MemoryGetAvail());
	DnpapMessage(DMC_MESSAGE, 4, "MemoryGetMaxChunk: %ld", MemoryGetMaxChunk());
	DnpapMessage(DMC_MESSAGE, 5, "MemoryGetUsed: %ld", MemoryGetMaxMemory() - MemoryGetAvail());

	DnpapExit(0);
}
