/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _RING_H
#define _RING_H


#include <dnpap.h>


typedef struct RingPos_
{
	LONG Start;
	LONG Len;
	
} RingPos;


typedef struct Ring_
{
	LONG Size;
	LONG Start;
	LONG Stop;
	
	RingPos *PosList;
	LONG PosCount;
	LONG PosMax;
	
	BYTE *Buffer;
	
} Ring;



Ring *RingAlloc(LONG size, LONG elems);
VOID RingFree(Ring *ring);

BOOLEAN RingSetMaxElems(Ring *ring, LONG elems);
LONG RingGetMaxElems(Ring *ring);
LONG RingGetElems(Ring *ring);

BOOLEAN RingPutMem(Ring *ring, BYTE *mem, LONG len);
BOOLEAN RingGetMem(Ring *ring, BYTE *mem, LONG *len);
BOOLEAN RingPeekMem(Ring *ring, LONG elem, LONG offset, BYTE **p, BYTE *mem, LONG *len);

LONG RingAvailMem(Ring *ring);


#endif
