/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#include <dnpap.h>
#include <stdio.h>

#include "ring.h"
                     

#define SIZE      4567
#define ELEMS     1000

int main(VOID)
{
Ring *ring;
BYTE mem1[] = { 1, 2, 3, 4, 5 };
BYTE mem2[] = { 6, 7, 8, 9, 0 };
BYTE mem3[] = { 0, 0, 0, 0, 0 };
BYTE *p;
BOOLEAN rc;                   
LONG i, len;

    ring = RingAlloc(SIZE, ELEMS);
                              
    while (RingAvailMem(ring) > sizeof(mem1) + sizeof(mem2) &&
           RingGetElems(ring) < ELEMS)
    {
        rc = RingPutMem(ring, mem1, sizeof(mem1));
        if (rc == FALSE)
            fprintf(stderr, "RingPutMem: mem1 failure\n");
        rc = RingPutMem(ring, mem2, sizeof(mem2));
        if (rc == FALSE)
            fprintf(stderr, "RingPutMem: mem2 failure\n");
    }
    
    printf("mem avail = %ld\n", RingAvailMem(ring));
    
    while (RingAvailMem(ring) < SIZE)
    {
        rc = RingGetMem(ring, mem3, &len);
        if (rc == FALSE || len != sizeof(mem1))
            fprintf(stderr, "RingGetMem: mem1 failure\n");
        rc = RingGetMem(ring, mem3, &len);
        if (rc == FALSE || len != sizeof(mem2))
            fprintf(stderr, "RingGetMem: mem2 failure\n");
    }
    
    while (RingAvailMem(ring) > sizeof(mem1) + sizeof(mem2) &&
           RingGetElems(ring) < ELEMS)
    {
        rc = RingPutMem(ring, mem1, sizeof(mem1));
        if (rc == FALSE)
            fprintf(stderr, "RingPutMem: mem1 failure\n");
        rc = RingPutMem(ring, mem2, sizeof(mem2));
        if (rc == FALSE)
            fprintf(stderr, "RingPutMem: mem2 failure\n");
    }
    
    for (i = 0; i < RingGetElems(ring); i++)
    {                                              
        len = 2;
        rc = RingPeekMem(ring, i, 2, &p, mem3, &len);
        if (rc == FALSE)
            fprintf(stderr, "RingPeekMem: mem3 failure\n");
        if (memcmp(mem1+2, mem3, 2) != 0 && memcmp(mem2+2, mem3, 2) != 0)
            fprintf(stderr, "RingPeekMem: mem3 compare failure\n");
    }
	
	return 0;
}
