/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#include <stdlib.h>
#include <stdio.h>
#ifndef GCC
#include <conio.h>
#endif
#include <dnpap.h>
#include <stdarg.h>
#include "timer.h"



VOID callback1(TIMER_DESCR *timer, ULONG now, VOID *parm)
{
    static ULONG count=1;
    static ULONG old=0;

    printf("1 -> %lu %lu\n", now-old, now/count++);
    old=now;
}

VOID callback2(TIMER_DESCR *timer, ULONG now, VOID *parm)
{
    static ULONG count=1;
    static ULONG old=0;

    printf("2 -> %lu %lu\n", now-old, now/count++);
    old=now;
}

void main (void)
{
    TIMER_DESCR *handle1, *handle2;
    
    
    if (!TimerInit())
        exit(1);
    if ((handle1=TimerRegister(callback1,0,1000L,TIMER_FOREVER,TIMER_TYPE_RECOVER))==0)
        exit(1);
    if ((handle2=TimerRegister(callback2,0,310L,TIMER_FOREVER,TIMER_TYPE_RECOVER))==0)
        exit(1);
    while(1)
    {
        if (!TimerCheck())
            break;
    }
    if (!TimerRemove(handle1))
        exit(1);
    if (!TimerRemove(handle2))
        exit(1);
    exit(0);
};
