include ../include/gcc_unx.std

SYS     = mibdf
SYSLIB  = mibdf

OBJ =   mibapi.o $(SYS).o parse.o 

all: obj doc

install: all $(INCDIR)/$(SYS).h $(MANDIR)/$(SYS).man $(LIBDIR)/lib$(SYSLIB).a 

$(INCDIR)/$(SYS).h: $(SYS).h 
	$(CP) $(SYS).h $(INCDIR)/$(SYS).h

$(MANDIR)/$(SYS).man: $(SYS).man 
	$(CP) $(SYS).man $(MANDIR)/$(SYS).man 

$(LIBDIR)/lib$(SYSLIB).a: $(OBJ) 
	$(AR) $(LIBDIR)/lib$(SYSLIB).a $(OBJ) 
	$(RANLIB) $(LIBDIR)/lib$(SYSLIB).a
	
obj: $(OBJ)
       
doc: $(SYS).man

clean:
	- $(RM) *.o
	- $(RM) *.a
	- $(RM) *.exe
	- $(RM) core
	- $(RM) test
	- $(RM) *.man
	- $(RM) *.err
	- $(RM) *.bak

$(SYS).man: $(SYS).c mibapi.c parse.c
	$(MAN) $(SYS).c mibapi.c parse.c > $(SYS).man

$(SYS).o: $(SYS).c $(SYS).h

mibapi.o: mibapi.c $(SYS).h

parse.o: parse.c $(SYS).h


test.exe: test
	emxbind -bs test

test: test.o $(INC)
	$(LN) $(CFLAGS) -o test test.o $(LDFLAGS)  -lmibdf -ldnpap 

test.o: test.c
