include ../include/gcc_unx.std

MCFLAGS = -I. -I../fore -I../eni

SYS     = nw
SYSLIB  = nw

OBJ =   $(SYS).o $(NWOBJS)

all: obj

install: all $(INCDIR)/$(SYS).h $(LIBDIR)/lib$(SYSLIB).a $(INCDIR)/$(SYS)snmpdef.h

$(INCDIR)/$(SYS).h: $(SYS).h 
	$(CP) $(SYS).h $(INCDIR)/$(SYS).h

$(LIBDIR)/lib$(SYSLIB).a: $(OBJ) 
	$(AR) $(LIBDIR)/lib$(SYSLIB).a $(OBJ)
	$(RANLIB) $(LIBDIR)/lib$(SYSLIB).a
	
$(INCDIR)/nwsnmpdef.h: nwsnmp/nwsnmpdef.h
	$(CP) nwsnmp/nwsnmpdef.h $@

obj: $(OBJ)
       
clean:
	- $(RM) *.o
	- $(RM) *.a
	- $(RM) *.exe
	- $(RM) core
	- $(RM) test
	- $(RM) *.man
	- $(RM) *.err
	- $(RM) *.bak

$(SYS).o: $(SYS).c $(SYS).h

nwtcp.o: nwtcp/nwtcp.c nwtcp/nwtcp.h
	$(CC) $(CFLAGS) -Inwtcp -c -o nwtcp.o nwtcp/nwtcp.c 

nwudp.o: nwudp/nwudp.c nwudp/nwudp.h
	$(CC) $(CFLAGS) -Inwudp -c -o nwudp.o nwudp/nwudp.c 

nwicmp.o: nwicmp/nwicmp.c nwicmp/nwicmp.h
	$(CC) $(CFLAGS) -Inwicmp -c -o nwicmp.o nwicmp/nwicmp.c 

nwsnmp.o: nwsnmp/nwsnmp.c nwsnmp/nwsnmp.h nwsnmp/nwsnmpdef.h
	$(CC) $(CFLAGS) -Inwsnmp -c -o nwsnmp.o nwsnmp/nwsnmp.c 

nwnit.o: nwnit/nwnit.c nwnit/nwnit.h
	$(CC) $(CFLAGS) -Inwnit -c -o nwnit.o nwnit/nwnit.c 

nwpf.o: nwpf/nwpf.c nwpf/nwpf.h
	$(CC) $(CFLAGS) -Inwpf -c -o nwpf.o nwpf/nwpf.c 

nwdlpi.o: nwdlpi/nwdlpi.c nwdlpi/nwdlpi.h
	$(CC) $(CFLAGS) -Inwdlpi -c -o nwdlpi.o nwdlpi/nwdlpi.c 

nweth.o: nweth/nweth.c nweth/nweth.h
	$(CC) $(CFLAGS) -Inweth -c -o nweth.o nweth/nweth.c 

nwfore.o: nwfore/nwfore.c nwfore/nwfore.h
	$(CC) $(CFLAGS) -Inwfore -c -o nwfore.o nwfore/nwfore.c 

nweni.o: nweni/nweni.c nweni/nweni.h
	$(CC) $(CFLAGS) -Inweni -c -o nweni.o nweni/nweni.c 

nwbpf.o: nwbpf/nwbpf.c nwbpf/nwbpf.h
	$(CC) $(CFLAGS) -Inwbpf -c -o nwbpf.o nwbpf/nwbpf.c 
