/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _NWDLPI_H
#define _NWDLPI_H
    

#include <sys/types.h>
#include <sys/time.h>
#include <sys/dlpi.h>

#include <block.h>
#include <dnpap.h>

#include "nw.h"
            

#define NWDLPI_SIZE_ENTRY       32
#define NWDLPI_SIZE_INTERFACE   32
#define NWDLPI_SIZE_PACKET      2048
#define NWDLPI_SIZE_ADDRESS		6
#define NWDLPI_SIZE_SAP			2
#define NWDLPI_SIZE_DLBUF		8192

#define NWDLPI_INTERFACE	"le"
#define NWDLPI_DEVICE		"/dev/le"
#define NWDLPI_FILTER   	"pfmod"
#define NWDLPI_BUFFER   	"bufmod"

#define NWDLPI_INFTIME		-1
#define NWDLPI_MAXWAIT		10

                      
enum NwDlpiErrors
{
    NWDLPI_OK = NW_ERROR, 
    NWDLPI_PARAM, NWDLPI_INIT, NWDLPI_ROOT,
    NWDLPI_OPEN, NWDLPI_SETUP, NWDLPI_IOCTL, NWDLPI_PUSH, 
    NWDLPI_NEWDLPI, 
    NWDLPI_ADDLIST, NWDLPI_BLOCK,
    NWDLPI_READ, NWDLPI_SEND,     
    NWDLPI_WEVENT, NWDLPI_EEVENT, NWDLPI_NEVENT,
    NWDLPI_MORE, NWDLPI_LENGTH, NWDLPI_ALARM, 
	NWDLPI_GETMSG, NWDLPI_PUTMSG,
    NWDLPI_ACK, NWDLPI_PRIM,
	NWDLPI_CONFIG
};


typedef struct sb_hdr SB_HDR;
typedef dl_attach_req_t ATTACH_REQ;
typedef dl_detach_req_t DETACH_REQ;
typedef dl_bind_req_t BIND_REQ;
typedef dl_bind_ack_t BIND_ACK;
typedef dl_unbind_req_t UNBIND_REQ;
typedef dl_info_req_t INFO_REQ;
typedef dl_info_ack_t INFO_ACK;
typedef dl_promiscon_req_t PROMISCON_REQ;
typedef dl_promiscoff_req_t PROMISCOFF_REQ;
typedef dl_ok_ack_t OK_ACK;

typedef union DL_primitives DL_PRIMITIVES;


extern NW_DG_IFACE DlpiDgIface;


#endif
