#include <stdio.h>
#include <string.h>

#include <dnpap.h>
#include <maxmem.h>
#include <message.h>
#include <timer.h>
#include <block.h>
#include <dlpi.h>


static VOID Recv(NW_DG *nw, CHAR *addr, BYTE *frame, INT length, VOID *parm);


INT main(INT argc, char **argv)
{
NW_DG *dg;

    if (ConfigInit(argc, argv) == FALSE || ConfigLoad() == FALSE)
    {
        DnpapMessage(DMC_FATAL, 1, "ConfigInit failed");
        DnpapExit(1);
    }

    MemoryInit(8000000L, 32000L);

    MessageInit("stdio:out", MSGFILE, MSGSTDIO, NULL);
    MessageConfig(1, "Beholder");
    
    if (!TimerInit())
        DnpapMessage(DMC_WARNING,1,"TimerInit failed");

    if (BlockInit() != 0)
        DnpapMessage(DMC_WARNING,1,"BlockInit failed");
    
	if (!NwInit())
        DnpapMessage(DMC_WARNING,1,"NwInit failed");

	dg = NwDgAccept("dlpi:le0:8192:0", Recv, NULL);

    while (1)
        if (Block()!=0)
            DnpapMessage(DMC_WARNING,1,"Block exit !");

    return 0;
}


VOID Recv(NW_DG *nw, char *addr, BYTE *frame, int length, void *parm)
{
	printf("addr: %s, frame: %lu, length: %lu\n", addr, frame, length);
}
