/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _NWICMP_H
#define _NWICMP_H
    

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#ifndef LINUX
#include <netinet/in_systm.h>
#endif
#include <netinet/in.h>
#include <netinet/ip.h>
#ifndef LINUX
#include <netinet/ip_icmp.h>
#else
#include <linux/icmp.h>
#endif
#include <arpa/inet.h>

#include <block.h>
#include <dnpap.h>

#include "nw.h"
            

#define NWICMP_SIZE_ENTRY        32
#define NWICMP_SIZE_HOST        256
#define NWICMP_SIZE_PACKET     2048


#define INADDR_NONE     0xffffffff

                      
enum NwIcmpErrors
{
    NWICMP_OK = NW_ERROR, 
    NWICMP_PARAM, NWICMP_PROTO, NWICMP_INIT, NWICMP_ROOT,
    NWICMP_NEWICMP, NWICMP_OPEN, 
    NWICMP_ADDLIST,
    NWICMP_ADDR, NWICMP_BLOCK,
    NWICMP_READ, NWICMP_RECV, NWICMP_SEND, 
    NWICMP_WEVENT, NWICMP_EEVENT, NWICMP_NEVENT
};


extern NW_DG_IFACE IcmpDgIface;


#endif
