/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _NWNIT_H
#define _NWNIT_H
    

#include <sys/types.h>
#include <sys/time.h>

#include <block.h>
#include <dnpap.h>

#include "nw.h"
            

#define NWNIT_SIZE_ENTRY        32
#define NWNIT_SIZE_INTERFACE    32
#define NWNIT_SIZE_PACKET     2048
#define NWNIT_SIZE_ADDRESS       6

/* only add flags, don't delete any otherwise the code may break */
#define NWNIT_DEFAULT_FLAGS     (NI_TIMESTAMP | NI_DROPS | NI_LEN)

#define NWNITDEVICE     "/dev/nit"
#define NWNITFILTER     "pf"
#define NWNITBUFFER     "nbuf"

                      
enum NwNitErrors
{
    NWNIT_OK = NW_ERROR, 
    NWNIT_PARAM, NWNIT_INIT, NWNIT_ROOT,
    NWNIT_OPEN, NWNIT_SETUP, NWNIT_IOCTL, NWNIT_PUSH, 
    NWNIT_NEWNIT, 
    NWNIT_ADDLIST, NWNIT_BLOCK,
    NWNIT_READ, NWNIT_SEND,     
    NWNIT_WEVENT, NWNIT_EEVENT, NWNIT_NEVENT,
	NWNIT_CONFIG
};


typedef struct nit_bufhdr   NITBUFHDR;
typedef struct nit_iftime   IFTIME;
typedef struct nit_ifdrops  IFDROPS;
typedef struct nit_iflen    IFLEN;


extern NW_DG_IFACE NitDgIface;


#endif
