#ifndef _NWSNMPDEF_H
#define _NWSNMPDEF_H


#include <dnpap.h>
#include <snmp.h>


#define NWSNMP_SIZE_ADDRESS		256
#define NWSNMP_SIZE_HOST		128
#define NWSNMP_SIZE_REQUEST		16
#define NWSNMP_SIZE_COMMUNITY	SNMP_SIZE_COMM
#define NWSNMP_SIZE_UDPADDR		256
#define NWSNMP_SIZE_UDPPORT		16
#define NWSNMP_SIZE_UDP			2048
#define NWSNMP_SIZE_OBJECTS		32


struct SnmpRequest
{
	INT Id				  /* SNMP PDU id */;
	INT Status			  /* SNMP PDU status */;
	INT Index			  /* SNMP PDU index */;
};


struct SnmpTrap
{
	LONG  Id[SNMP_SIZE_BUFINT];
	UINT  IdLen;
	ULONG IpAddress;
	INT   General;
	INT   Specific;
	ULONG Time;
};


typedef struct _NwSnmpFrame
{
	union
	{
		struct SnmpRequest Request;
		struct SnmpTrap    Trap;
	} Pdu;

	INT NrObjects		  /* number of objects in packet */;
	SNMP_OBJECT	*Objects  /* pointer to array of objects */;

} NwSnmpFrame;

      

BOOLEAN NwSnmpHost(NW_DG *dg, CHAR *host);
BOOLEAN NwSnmpCommunity(NW_DG *dg, BYTE *community, INT *commlen);

BOOLEAN Addr2Snmp(CHAR *addr, CHAR *host, INT *port, 
				  CHAR *request, WORD *type, BYTE *community, INT *commlen);


#endif
