##!/bin/sh -- 					# wish I were -*-Perl-*-
# eval "exec perl -P -S $0 $*"
#	if !$$;
# @(#)Demo.pl	1.7 16 Jan 1995

# This program is a demonstration of the Tricklet 
# perl interface made by the DNPAP group of
# the Technical University Delft, The Netherlands.
# It displays useful information about a router (or any MIB-II device)
# Written by Bruce Barnett <barnett@crd.ge.com>
#		9/14/93
# Copyright 1993,1995 GE
# All commercial rights reserved
# 
push(@INC,'.');
require "spook.pl";
#
# handle the arguments
#
if( @ARGV>3 )
{
	die 	"call as:  perl demoget.pl [<host> <community> [<medium>]\n" ,
		" where:\n" ,
		"	<host>		name of RMON monitor\n" ,
		"	<community>	community name for creating collectors\n",
		"	<medium>	UDP or PIPE\n";
}
($iniHost , $iniComm , $iniMed , @rest) = @ARGV;
$sleeptime = 10;
$seconds = $sleeptime;

if (!defined($iniHost)) {
    printf(STDERR "must specify hostname as command line argument\n");
    exit 1;
}
if (!defined($iniMed)) {
    $iniMed = "UDP";
}
#
# open a SNMP connection 
#
&snmp_open(1) || die "can't open a Spook connection\n";
if($iniHost ne "") { &snmp_host(1,$iniHost);}
if($iniMed ne "")  {&snmp_medium(1,$iniMed);}
&snmp_connect(1) || die "could't connect to ($iniHost,$iniMed)";
if($iniComm ne "") {&snmp_community(1,$iniComm);}
#
#collect and print some SNMP variables
#
$sysName=&snmp_get(1,"sysName");
$sysName =~ s/\"//g;
printf("$sysName:\n");
$sysDescr=&snmp_get(1,"sysDescr");
$sysDescr =~ s/\"//g;
$sysDescr =~ s/\\n/\n/g;
printf($sysDescr); printf("\n");
#printf("sysObjectID=%s\n",&snmp_get(1,"sysObjectID"));
$upTime=&snmp_get(1,"sysUpTime");
$units = "seconds";
$uptime = $upTime/100.0;
if ($uptime > 60) {
    $units = "minutes";
    $uptime = $uptime/60.0;
    if ($uptime > 60) {
	$units = "hours";
	$uptime = $uptime/60.0;
	if ($uptime > 24) {
	    $units = "days";
	    $uptime = $uptime/24.0;
	}
    }
}
printf("up for %3.1f %s\n", $uptime, $units);

$syscontact=&snmp_get(1,"sysContact");
if (!((undef($syscontact)) || (($syscontact eq "") || ($syscontact eq 0)))) {
    printf("sysContact=[%c][%s][%d]\n",$syscontact, $syscontact, $syscontact);
}

$syslocation=&snmp_get(1,"sysLocation");
if (!((undef($syslocation)) || (($syslocation eq "") || ($syslocation eq 0)))) {
    printf("sysLocation=[%c][%s][%d]\n",$syslocation, $syslocation, $syslocation);
}
#printf("sysServices=%s\n",&snmp_get(1,"sysServices"));
$x = &snmp_get(1,"ipForwarding");
if ($x == 1 ) {
    printf ("Gateway/Router\n");
}


@interfaces = ();
sub interfacesCollect
{
	local($i,$j,@repl) = @_;
	push(@interfaces,$repl[2]);
}						 


# put all possible interfaces in <interfaces>
&snmp_tbl(1,main'interfacesCollect,("ifIndex[]"));
#
@ipaddresses = ();
sub ipaddressesCollect {
	local($i,$j,@repl) = @_;
	push(@ipaddresses,$repl[2]);
}						 


# put all possible interfaces in <interfaces>
&snmp_tbl(1,main'ipaddressesCollect,("ipAdEntAddr[]"));


# wait until an even number of seconds...
&wait_until();
$now=time; 

# cycle thru each IP address
# even though the router may have more interfaces
foreach $ipaddress (@ipaddresses) {
    
    if ($ipaddress ne "127.0.0.1") {
	$variable = "ipAdEntNetMask[" . $ipaddress . "]";
	$netmask = &snmp_get(1, $variable);
	
#    $variable = "ipAdEntBcastAddr[" . $ipaddress . "]";
#    $bcast = &snmp_get(1, $variable);
	
	$variable = "ipAdEntIfIndex[" . $ipaddress . "]";
	$i = &snmp_get(1, $variable);
	
	$variable = "ifType[" . $i . "]";
	$type = &snmp_get(1, $variable);
	if ($type == 6) {
	    $ifkind = "ether";	    
	} elsif ($type == 15) {
	    $ifkind = "fddi";	    
	} elsif ($type == 22) {
	    $ifkind = "Serial";	    
	} elsif ($type == 9) {
	    $ifkind = "TokenRing";	    
	} else {
	    $ifkind ="TYPE[" . $type . "]";
	}
	if ( # change the order arounds - as type22 is most common 
	    ($type == 22) ||	# point to point serial (most likely)
	    ($type == 2) ||	# regular1822
	    ($type == 3) ||	# hdh1822
	    ($type == 4) ||	# ddn-x25
	    ($type == 5) ||	# rfc877-x25
	    ($type == 16) ||	# lapb
	    ($type == 17) ||	# sdlc
	    ($type == 18) ||	# dsi
	    ($type == 19) ||	# e1
	    ($type == 20) ||	# basicIDSN
	    ($type == 21) ||	# primaryISDN
	    ($type == 23) ||	# ppp
	    ($type == 28) ||	# slip
	    ($type == 30) ||	# ds3
	    ($type == 31) ||	# smds
	    ($type == 32)) {	# framerelay
				# full duplex, see Simple Times V1 n5.

	    $full_duplex[$i] = 1;
	} else {
	    $full_duplex[$i] = 0;
	}
	$variable = "ifDescr[" . $i . "]";
	$descr = &snmp_get(1, $variable);
	$descr =~ s/\"//g;
	
	$variable = "ifSpeed[" . $i . "]";
	$speed = &snmp_get(1, $variable);
	# convert from bits/sec to kBytes/sec
	$kbps = $speed/(1000);

#	$variable = "ifPhysAddress[" . $i . "]";
#	$addr = &snmp_get(1, $variable);
	
	$variable = "ifInOctets[" . $i . "]";
	$in = &snmp_get(1, $variable);
	
	$variable = "ifInErrors[" . $i . "]";
	$inerrors = &snmp_get(1, $variable);
	
	$variable = "ifOutOctets[" . $i . "]";
	$out = &snmp_get(1, $variable);
	
	$variable = "ifOutErrors[" . $i . "]";
	$outerrors = &snmp_get(1, $variable);
	
	
	$iucast = &snmp_get(1, "ifInUcastPkts[" . $i . "]");
	$inucast = &snmp_get(1, "ifInNUcastPkts[" . $i . "]");
	$idiscards = &snmp_get(1,"ifInDiscards[" . $i . "]");
	$iunknown = &snmp_get(1,"ifInUnknownProtos[" . $i . "]");
	
	$oucast = &snmp_get(1, "ifOutUcastPkts[" . $i . "]");
	$onucast = &snmp_get(1, "ifOutNUcastPkts[" . $i . "]");
	$odiscards = &snmp_get(1,"ifOutDiscards[" . $i . "]");
	$oqlen = &snmp_get(1,"ifOutQLen[" . $i . "]");
	$ipInAddrErrors = &snmp_get(1,"ipInAddrErrors[" . $i . "]");

	$speed[$i] = $speed;
	$ifkind[$i] = $ifkind;
	&savelast();

	
	printf("%s[%s]: ipaddress=%s, netmask=%s,\n",
	       $ifkind, $i, $ipaddress, $netmask);

#;	if ($addr ne "") {
#;	    printf("\tEthernet Addr: %s\n", 	    $addr);
#;	}
	if ($kbps > 1000 ) {
	    printf("\t%4.1f Mb/sec\n",$kbps/1000.0);
	} else {
	    printf("\t%4.1f Kb/sec\n",$kbps);
	}
	
#	printf("\tunicast packets=%d, non-unicast packets=%d, discards=%d, unknown=%d\n",
#	       $iucast, $inucast, $idiscards, $iunknown);

    }
}

$count = 10;
while ($count--) {
    printf("\nsleeping for $sleeptime seconds...");
# wait until an even number of seconds...
    &wait_until();
    $now=time; 
#sleep($sleeptime);
    printf("...\n");
# even though the router may have more interfaces
    foreach $ipaddress (@ipaddresses) {
	
	if ($ipaddress ne "127.0.0.1") {
	    $variable = "ipAdEntNetMask[" . $ipaddress . "]";
	    $netmask = &snmp_get(1, $variable);
	    
	    $variable = "ipAdEntIfIndex[" . $ipaddress . "]";
	    $i = &snmp_get(1, $variable);
	    
#;	$variable = "ifType[" . $i . "]";
#;	$type = &snmp_get(1, $variable);
	    $type = $type[$i];
	    $ifkind = $ifkind[$i];
	    
	    $variable = "ifInOctets[" . $i . "]";
	    $in = &snmp_get(1, $variable);
	    
	    $variable = "ifInErrors[" . $i . "]";
	    $inerrors = &snmp_get(1, $variable);
	    
	    $variable = "ifOutOctets[" . $i . "]";
	    $out = &snmp_get(1, $variable);
	    
	    $variable = "ifOutErrors[" . $i . "]";
	    $outerrors = &snmp_get(1, $variable);
	    
	    
	    $iucast = &snmp_get(1, "ifInUcastPkts[" . $i . "]");
	    $inucast = &snmp_get(1, "ifInNUcastPkts[" . $i . "]");
	    $idiscards = &snmp_get(1,"ifInDiscards[" . $i . "]");
	    $iunknown = &snmp_get(1,"ifInUnknownProtos[" . $i . "]");
	    
	    $oucast = &snmp_get(1, "ifOutUcastPkts[" . $i . "]");
	    $onucast = &snmp_get(1, "ifOutNUcastPkts[" . $i . "]");
	    $odiscards = &snmp_get(1,"ifOutDiscards[" . $i . "]");
	    $oqlen = &snmp_get(1,"ifOutQLen[" . $i . "]");
	    $ipInAddrErrors = &snmp_get(1,"ipInAddrErrors[" . $i . "]");
	    
# look at the differences between now and last time
	    $in_delta = $in - $in[$i];
	    $inerrors_delta = $inerrors - $inerrors[$i];
	    $out_delta = $out - $out[$i];
	    $outerrors_delta = $outerrors - $outerrors[$i];
	    $iucast_delta = $iucast - $iucast[$i];
	    $inucast_delta = $inucast - $inucast[$i];
	    $idiscards_delta = $idiscards - $idiscards[$i];
	    $iunknown_delta = $iunknown - $iunknown[$i];
	    $oucast_delta = $oucast - $oucast[$i];
	    $onucast_delta = $onucast - $onucast[$i];
	    $odiscards_delta = $odiscards - $odiscards[$i];
	    $ipInAddrErrors_delta = $ipInAddrErrors - $ipInAddrErrors[$i];
	    
# save them for next time
	    
	    &savelast();
	    
#	calculate the utilization -
	    
	    #util = ((8 * (in_delta + out_delta)/sleeptime) / speed)
# except if a point to point, in which case it's 
	    #util = ((8 * max(in_delta + out_delta)/sleeptime) / speed)
	    
	    if ( $full_duplex[$i]) {
#	    printf("----Full Duplex----\n");
		if ($in_delta > $out_delta) {
		    $util=((8 * ($in_delta) / $sleeptime) / $speed[$i])*100.0;
		} else {
		    $util=((8 * ($out_delta) / $sleeptime) / $speed[$i])*100.0;
		}
		
	    } else {
		$util=((8 * ($in_delta + $out_delta) / $sleeptime) / $speed[$i])*100.0;
# because speed was already converted into bytes/second
	    }
	    
# calculate the error rate
	    
	    $ierate = $inerrors_delta /$sleeptime;
	    $oerate = $outerrors_delta /$sleeptime;
	    
# what is the total packets? should be Unicast and Non-Unicast packets
	    
	    $total_input_packets = $iucast_delta + $inucast_delta;
	    $total_output_packets = $oucast_delta + $onucast_delta;
# calculate the input/output rate
	    
	    $irate = ($total_input_packets)/$sleeptime;
	    $orate = ($total_output_packets)/$sleeptime;
	    
# calculate the i/o percentage
	    
	    if ($irate > 0) {
		$iepercent = $ierate/$irate;
	    } else {
		$iepercent = 0;
	    }
	    if ($orate > 0) {
		$oepercent = $oerate/$orate;
	    } else {
		$oepercent = 0;
	    }
	    
	    $discards = $idiscards_delta + $odiscards_delta;
	    
	    $util[$i] = $util;
	    
# utilization is % of usage of speed
# so avail bandwidth is (100-util)*speed[i]
	    
	    $kbps = $speed[$i]/1000.0;
	    $availpercent=(100.0-$util[$i]);
	    $avail=($availpercent*$kbps)/100.0;
	    
	    
# done calculations, now print
	    
	    
	    printf("%s[%s]=%s:", 
		   $ifkind[$i],$i, $ipaddress,  $i);
	    printf("\tUtil=%4.1f%%, I=%4.1f Pkts/sec, O=%4.1f Pkts/sec",
		   $util, $irate, $orate);
	    if ($avail > 1000 ) {
		printf(", Avail= %5.1f Mb/sec\n",$avail/1000.0);
	    } else {
		printf(", Avail: %5.1f Kb/sec\n",$avail);
	    }
	    if($iepercent > 0.01 || $oepercent > 0.01 || $discards > 0) {
		printf("\tinput error = %6.2f%%, output error = %6.2f%%, Discards = %d\n",
		       $iepercent, $oepercent, $discards);
	    }
	    
#ifdef DEBUG2
	    printf("\tinput Packets = %d, output packets = %d\n",
		   $total_input_packets, $total_output_packets);
	    
	    printf("\tunicast packets=%d, non-unicast packets=%d, discards=%d, unknown=%d\n",
		   $iucast, $inucast, $idiscards, $iunknown);
	    
	    printf("\tInput: %d, Errs=%d, unicast packets=%d, non-unicast packets=%d, discards=%d, unknown=%d\n",
		   $in_delta, $inerrors_delta, $iucast_delta, $inucast_delta, $idiscards_delta, $iunknown_delta);
	    printf("\tOutput: %d, Errs=%d, uniPack=%d, bcastPack=%d, discards=%d, QueueLen=%d \n",
		   $out_delta, $outerrors_delta, $oucast_delta, $onucast_delta, $odiscards, $oqlen);
	    printf("\tInput: %6.2f bytes/second, uni=%6.2f Packets/sec, bcast=%6.2f Packets/sec\n",
		   $in_delta/$sleeptime,  $iucast_delta/$sleeptime, $inucast_delta/$sleeptime);
	    printf("\tOutput: %6.2f bytes/second, uni=%6.2f Packets/sec, bcast=%6.2f Packets/sec\n",
		   $out_delta/$sleeptime,  $oucast_delta/$sleeptime, $onucast_delta/$sleeptime);
	    
	    
#endif
	}
    }
}

	
	


# close the SNMP connection
#
&snmp_disconnect(1);
&snmp_close(1);







exit 1;
sub savelast {
	$in[$i] = $in;
	$inerrors[$i] = $inerrors;
	$out[$i] = $out;
	$outerrors[$i] = $outerrors;
	$iucast[$i] = $iucast;
	$inucast[$i] = $inucast;
	$idiscards[$i] = $idiscards;
	$iunknown[$i] = $iunknown;
	$oucast[$i] = $oucast;
	$onucast[$i] = $onucast;
	$odiscards[$i] = $odiscards;
	$oqlen[$i] = $oqlen;
	$ipInAddrErrors[$i] = $ipInAddrErrors;
    }
sub get_second {
    local($s1);
    ($sec, $min, $hour, $mday, $mon, $year,$wday,$yday,$isdst) = localtime(time);
    return $sec;
}

sub wait_until {
    $s = &get_second();		# get current second
				# The second could be less than the wait time
    $s = $s % $seconds;
    $s1 = $seconds - $s;
    $verbose && printf(STDERR " - sleeping %d seconds\n", $s1);
				# how long to wait?
    if ( $s1 < 1 ) {
	printf(STDERR "Sleeping 0 seconds - mistake?\n");
    }
    sleep ($s1);

}
