package palarm;
#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       alarm.pl
##     SYSTEM   NAME:       alarm
##     ORIGINAL AUTHOR(S):  Jan van Oorschot
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Thu Jul 14 16:24:02 1994
##
## DESCRIPTION: Create and Destry alarm rows
##              
#########################################################################
## CHANGE INFORMATION ##
#########################
##      JvO - Jul 14, 1994:  Created
#########################################################################
require "spook.pl";	   
require "rmon/rmon.pl";

sub alarmCreatorCB
{
	local($cnr,$colnam,$colnr) = @_;
	local($varName , $res , $iface , $int);

	# Data to be set for an alarm table
	#
	# alarmInterval          --> interval(secs) over which the data
	#                            is sampled and compared with the
	#                            rising and falling thresholds
	# alarmVariable          --> variable to be sampled
	# alarmSampleType        --> absoluteValue(1)/deltaValue(2)
	# alarmValue             --> value of statistic during last sample period
	#                            (ReadOnly)
	# alarmStartupAlarm      --> risingAlarm(1)/fallingAlarm(2)/
	#                            risingOrFallingAlarm(3)
	# alarmRisingThreshold   --> rising threshold for varaible
	# alarmFallingThreshold  --> falling threshold for variable
	# alarmRisingEventIndex  --> event to send by rising alarm
	#                            (0 if not used)
	# alarmFallingEventIndex --> event to send by falling alarm
	#                            (0 if not used)
	#
	$snmpCommand="alarmInterval[$colnr]=$alarmInterval";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $alarmInterval)
        {
             return 0;
        }
	$snmpCommand = "alarmVariable[$colnr]=$alarmVariable";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $alarmVariable)
        {
             return 0;
        }
	$snmpCommand = "alarmSampleType[$colnr]=$alarmSampleType";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $alarmSampleType)
        {
             return 0;
        }
	$snmpCommand = "alarmStartupAlarm[$colnr]=$alarmStartupAlarm";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $alarmStartupAlarm)
        {
             return 0;
        }
	$snmpCommand = "alarmRisingThreshold[$colnr]=$alarmRisingThreshold";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $alarmRisingThreshold)
        {
             return 0;
        }
	$snmpCommand = "alarmFallingThreshold[$colnr]=$alarmFallingThreshold";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $alarmFallingThreshold)
        {
             return 0;
        }
	$snmpCommand = "alarmRisingEventIndex[$colnr]=$alarmRisingEventIndex";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $alarmRisingEventIndex)
        {
             return 0;
        }
	$snmpCommand = "alarmFallingEventIndex[$colnr]=$alarmFallingEventIndex";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $alarmFallingEventIndex)
        {
             return 0;
        }
	return 1;
}	   

# create the collector with the correct inFun
sub main'alarmCreator
{
    local(
	      $cnr,$owner,
              $alarmInterval,
              $alarmVariable,
              $alarmSampleType,
              $alarmStartupAlarm,
              $alarmRisingThreshold,
              $alarmFallingThreshold,
              $alarmRisingEventIndex,
              $alarmFallingEventIndex
	  ) =@_;
    $colnr = &main'create_new_collector(
				    $cnr,
				    "alarm",
				    $owner,
				    palarm'alarmCreatorCB) || return 0;
    return( $colnr);
}

# destroy the collector
sub main'alarmTerminator
{
    local($conn,$coll, $owner) = @_;

    return &main'remove_collector($conn,"alarm",$coll,$owner);
}

#
# receive a row of the table, for the use with snmp_tbl
#
sub alarmGardnerCB
{
	local($i,$j,@repl) = @_;
	if($j == 1)
	{
	    print $localFile "\n$localId $localTable ";
	}
	print $localFile "$repl[2] ";
}

#
# request the host table
#
# input variables:
#      
#      1: $conn        spook connection number
#      4: $coll        collector number of host collector
#      5: $id          identification string
#      6: $file        file handle to write to
#
sub main'alarmGardner
{
    local( $conn, $coll, $id, $file) = @_;
    local( @res );

    $localId = $id;
    $localFile = $file;

    $localTable = "alarmControl";
    @res = &main'snmp_get( $conn,
         (
              "alarmIndex[$coll]",                    # 0
              "alarmInterval[$coll]",                 # 1
              "alarmVariable[$coll]",                 # 2
              "alarmSampleType[$coll]",               # 3
              "alarmValue[$coll]",                    # 4
              "alarmStartupAlarm[$coll]",             # 5
              "alarmRisingThreshold[$coll]",          # 6
              "alarmFallingThreshold[$coll]",         # 7
              "alarmRisingEventIndex[$coll]",         # 8
              "alarmFallingEventIndex[$coll]",        # 9
              "alarmOwner[$coll]",                    # 10
              "alarmStatus[$coll]",                   # 11
         ));
    $time = time();
    print $file "\n$id alarmStart $time $res[1] $res[2] $res[3] $res[4] $res[5] $res[6] $res[7] $res[8] $res[9] $res[10] $res[11]";
    return 1;
}
1;





