package channel;
#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       channel.pl
##     SYSTEM   NAME:       channel
##     ORIGINAL AUTHOR(S):  Jan van Oorschot
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Thu Jul 14 08:57:18 1994
##
## DESCRIPTION: Create and destroy channels
##              
#########################################################################
## CHANGE INFORMATION ##
#########################
##      JvO - Jul 14, 1994:  Created
#########################################################################
require "spook.pl";	   
require "rmon/rmon.pl";

sub channelCreatorCB
{
	local($cnr,$colnam,$colnr) = @_;
	local($varName , $res , $iface , $int);

	# Data to be set for an channel table
	#
        # channelIfIndex          --> interface to receive frame from
	# channelAcceptType       --> acceptMatched(1)
	#                             acceptFailed(2)
	# channelDataControl      --> on(1)
	#                             off(2)
	# channelTurnOnEventIndex --> pointer to event which chanches 
	#                             channelDataControl from off to on.
	#                             (0 if not used)
	# channelTurnOffEventIndex--> pointer to event which chanches
	#                             channelDataControl from on to off.
	#                             (0 if not used)
	# channelEventIndex       --> id of event to generate when a 
	#                             frame is accepted
	#                             (0 if not used)
	# channelEventStatus      --> eventReady(1)  one event may be gent
	#                             eventFired(2)  no events may be gent
	#                             eventAlwaysReady(3) always gen 
	# channelMatches          --> # frames matched by channel (ReadOnly)
	# channelDescription      --> optional description of channel
        #
	$snmpCommand = "channelIfIndex[$colnr]=$channelIfIndex";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             $main'TrickletErrStr = "channelCreator: cant set ifIndex\n$main'TrickletErrStr";
             return 0;
        }
	$snmpCommand = "channelAcceptType[$colnr]=$channelAcceptType";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	$snmpCommand = "channelDataControl[$colnr]=$channelDataControl";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	$snmpCommand = "channelTurnOnEventIndex[$colnr]=$channelTurnOnEventIndex";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	$snmpCommand = "channelTurnOffEventIndex[$colnr]=$channelTurnOffEventIndex";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	$snmpCommand = "channelEventIndex[$colnr]=$channelEventIndex";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	$snmpCommand = "channelEventStatus[$colnr]=$channelEventStatus";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	$snmpCommand = "channelDescription[$colnr]=\"$channelDescription\"";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	return 1;
}	   

# create the etherStats collector with the correct inFun
sub main'channelCreator
{
    local(
	  $cnr,$owner,
	  $channelIfIndex,
	  $channelAcceptType,
	  $channelDataControl,
	  $channelTurnOnEventIndex,
	  $channelTurnOffEventIndex,
	  $channelEventIndex,
	  $channelEventStatus,
	  $channelDescription
	  ) =@_;
    $colnr = &main'create_new_collector(
				    $cnr,
				    "channel",
				    $owner,
				    channel'channelCreatorCB) || return 0;
    return( $colnr);
}

sub main'channelTerminator
{
    local($conn,$coll, $owner) = @_;

    return &main'remove_collector($conn,"channel",$coll,$owner);
}

#
# receive a row of the table, for the use with snmp_tbl
#
sub channelGardnerCB
{
	local($i,$j,@repl) = @_;
	if($j == 1)
	{
	    print $localFile "\n$localId $localTable ";
	}
	print $localFile "$repl[2] ";
}

sub main'channelGardner
{
    local( $conn, $coll, $id, $file) = @_;
    local( @res );

    $localId = $id;
    $localFile = $file;

    $localTable = "channelControl";
    @res = &main'snmp_get( $conn,
         (
              "channelIndex[$coll]",             # 0
              "channelIfIndex[$coll]",                  # 1
              "channelAcceptType[$coll]",        # 2
              "channelDataControl[$coll]",       # 3
              "channelTurnOnEventIndex[$coll]",  # 4
              "channelTurnOffEventIndex[$coll]", # 5
              "channelEventIndex[$coll]",        # 6
              "channelEventStatus[$coll]",       # 7
              "channelMatches[$coll]",           # 8
              "channelDescription[$coll]",       # 9
              "channelOwner[$coll]",             # 10
              "channelStatus[$coll]"            # 11
         ));
    $time = time();
    print $file "\n$id channelControlStart $time $res[1] $res[2] $res[3] $res[4] $res[5] $res[6] $res[7] $res[8] $res[9] $res[10] $res[11]";  
    return 1;
}
1;





