package event;
#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       event.pl
##     SYSTEM   NAME:       event
##     ORIGINAL AUTHOR(S):  Jan van Oorschot
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Thu Jul 14 15:45:40 1994
##
## DESCRIPTION: Create and Destroy event rows
##              
#########################################################################
## CHANGE INFORMATION ##
#########################
##      JvO - Jul 14, 1994:  Created
#########################################################################
require "spook.pl";	   
require "rmon/rmon.pl";

sub eventCreatorCB
{
	local($cnr,$colnam,$colnr) = @_;
	local($varName , $res , $iface , $int);

	# Data to be set for an event table
	#
	# eventDescription        --> description of event
	# eventType               --> none(1)/log(2)/snmp-trap(3)/log-and-trap(4)
	# eventCommunity          --> community/trap to send
	# eventLastTimeSent       --> sysUpTime when last event was send
	#                             0 if never send
	#                             (ReadOnly)
	$snmpCommand="eventDescription[$colnr]=\"$eventDescription\"";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $eventDescription)
        {
             return 0;
        }
	$snmpCommand = "eventType[$colnr]=$eventType";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $eventType)
        {
             return 0;
        }
	$snmpCommand = "eventCommunity[$colnr]=\"$eventCommunity\"";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $eventCommunity)
        {
             return 0;
        }
	return 1;
}	   

# create the collector with the correct inFun
sub main'eventCreator
{
    local(
	      $cnr,$owner,
              $eventDescription,
              $eventType,
              $eventCommunity
	  ) =@_;
    $colnr = &main'create_new_collector(
				    $cnr,
				    "event",
				    $owner,
				    event'eventCreatorCB) || return 0;
    return( $colnr);
}

# destroy the collector
sub main'eventTerminator
{
    local($conn,$coll, $owner) = @_;

    return &main'remove_collector($conn,"event",$coll,$owner);
}

#
# receive a row of the table, for the use with snmp_tbl
#
sub eventGardnerCB
{
	local($i,$j,@repl) = @_;
	if($j == 1)
	{
	    print $localFile "\n$localId $localTable ";
	}
	print $localFile "$repl[2] ";
}

#
# request the host table
#
# input variables:
#      
#      1: $conn        spook connection number
#      4: $coll        collector number of host collector
#      5: $id          identification string
#      6: $file        file handle to write to
#
sub main'eventGardner
{
    local( $conn, $coll, $id, $file) = @_;
    local( @res );

    $localId = $id;
    $localFile = $file;

    $localTable = "eventControl";
    @res = &main'snmp_get( $conn,
         (
              "eventIndex[$coll]",            # 0
              "eventDescription[$coll]",      # 1
              "eventType[$coll]",             # 2
              "eventCommunity[$coll]",        # 3
              "eventLastTimeSent[$coll]",     # 4
              "eventOwner[$coll]",            # 5
              "eventStatus[$coll]",           # 6
         ));
    $time = time();
    print $file "\n$id eventStart $time $res[1] $res[2] $res[3] $res[4] $res[5] $res[6]";
    return 1;
}
1;





