package filter;
#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       filter.pl
##     SYSTEM   NAME:       filter
##     ORIGINAL AUTHOR(S):  
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Thu Jun 30 16:19:54 1994
##
## DESCRIPTION: Create/Descroy Filters
##              
#########################################################################
## CHANGE INFORMATION ##
#########################
##       - Jun 30, 1994:  Created
#########################################################################
require "spook.pl";	   
require "rmon/rmon.pl";

sub filterCreatorCB
{
	local($cnr,$colnam,$colnr) = @_;
	local($varName , $res , $iface , $int);

	# Data to be set for an filter table
	#
        # filterChannelIndex    --> which channel to attach to
        # filterPktDataOffset   --> offset in frame
        # filterPktData         --> data to look for in frame
        # filterPktDataMask     --> AND mask to use
        # filterPktDataNotMask  --> inverse AND mask
        # filterPktStatus       --> rund/jabber/CRC error mask
        # filterPktStatusMask   --> AND mask for status
        # filterPktStatusNotMask -> inverse AND mask for status
        #
	$snmpCommand = "filterChannelIndex[$colnr]=$iniChannelIndex";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	$snmpCommand = "filterPktDataOffset[$colnr]=$iniPktDataOffset";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	$snmpCommand = "filterPktData[$colnr]=$iniPktData";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	$snmpCommand = "filterPktDataMask[$colnr]=$iniPktDataMask";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
	$snmpCommand = "filterPktDataNotMask[$colnr]=$iniPktDataNotMask";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if(! defined($res))
        {
             return 0;
        }
#	$snmpCommand = "filterPktStatus[$colnr]=$iniPktStatus";
#	$res=&main'snmp_set($cnr,$snmpCommand);
#        if($res != $iniPktStatus)
#        {
#             return 0;
#        }
#	$snmpCommand = "filterPktStatusMask[$colnr]=$iniPktStatusMask";
#	$res=&main'snmp_set($cnr,$snmpCommand);
#        if($res != $iniPktStatusMask)
#        {
#             return 0;
#        }
#	$snmpCommand = "filterPktStatusNotMask[$colnr]=$iniPktStatusNotMask";
#	$res=&main'snmp_set($cnr,$snmpCommand);
#        if($res != $iniPktStatusNotMask)
#        {
#             return 0;
#        }
	return 1;
}	   

# create the etherStats collector with the correct inFun
sub main'filterCreator
{
    local(
	  $cnr,$owner,
	  $iniChannelIndex,
	  $iniPktDataOffset,
	  $iniPktData,
	  $iniPktDataMask,
	  $iniPktDataNotMask,
	  $iniPktStatus,
	  $iniPktStatusMask,
	  $iniPktStatusNotMask) =@_;
    $colnr = &main'create_new_collector(
				    $cnr,
				    "filter",
				    $owner,
				    filter'filterCreatorCB) || return 0;
    return( $colnr);
}

# destroy the host collector
sub main'filterTerminator
{
    local($conn,$coll, $owner) = @_;

    return &main'remove_collector($conn,"filter",$coll,$owner);
}

#
# receive a row of the table, for the use with snmp_tbl
#
sub filterGardnerCB
{
	local($i,$j,@repl) = @_;
	if($j == 1)
	{
	    print $localFile "\n$localId $localTable ";
	}
	print $localFile "$repl[2] ";
}

#
# request the host table
#
# input variables:
#      
#      1: $conn        spook connection number
#      4: $coll        collector number of host collector
#      5: $id          identification string
#      6: $file        file handle to write to
#
sub main'filterGardner
{
    local( $conn, $coll, $id, $file) = @_;
    local( @res );

    $localId = $id;
    $localFile = $file;

    $localTable = "filterControl";
    @res = &main'snmp_get( $conn,
         (
	  "filterChannelIndex[$coll]",    # 0
	  "filterPktDataOffset[$coll]",   # 1
	  "filterPktData[$coll]",         # 2
	  "filterPktDataMask[$coll]",     # 3 
	  "filterPktDataNotMask[$coll]",  # 4
	  "filterPktStatus[$coll]",       # 5
	  "filterPktStatusMask[$coll]",   # 6
	  "filterPktStatusNotMask[$coll]" # 7
         ));
    $time = time();
    print $file "\n$id hostControlStart $time $res[1] $res[2] $res[3] $res[4] $res[5] $res[6] $res[7] $res[8] $res[9]";  
    return 1;
}
1;





