package hostTopN;
#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       hosttopn.pl
##     SYSTEM   NAME:       hosttopn
##     ORIGINAL AUTHOR(S):  
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Thu Jun 30 09:32:49 1994
##
## DESCRIPTION: Basic functions for the hostTopN table
##              
#########################################################################
## CHANGE INFORMATION ##
#########################
##       - Jun 30, 1994:  Created
#########################################################################
require "spook.pl";	   
require "rmon/rmon.pl";
#
# define the functions
#
#
# function iniFun will be called during initialisation
# of the collector. This is the place to set all kind
# of collector specific values. In the case of etherStats, 
# this is only the ethernet-interface number etherStatsDataSource
#
sub hostTopNCreatorCB
{
	local($cnr,$colnam,$colnr) = @_;
	local($varName , $res , $iface , $int);

	# Data to be set for an hostTopN table
	#
	# hostTopNHostIndex            host table to use
	# hostTopNRateBase             which variable to select on
	# hostTopNTimeRemaining        time to run
	# hostTopNRequestedSize        number of hosts tracked
	#
	$snmpCommand = "hostTopNHostIndex[$colnr]=$iniHostIndex";
	$res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $iniHostIndex)
        {
             return 0;
        }
        $snmpCommand = "hostTopNRateBase[$colnr]=$iniRateBase";
        $res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $iniRateBase)
        {
             return 0;
        }
	$snmpCommand = "hostTopNTimeRemaining[$colnr]=$iniTimeRemaining";
        $res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $iniTimeRemaining)
        {
             return 0;
        }
        $snmpCommand = "hostTopNRequestedSize[$colnr]=$iniRequestedSize";
        $res=&main'snmp_set($cnr,$snmpCommand);
        if($res != $iniRequestedSize)
        {
             return 0;
        }
	return 1;
}	   

# create the etherStats collector with the correct inFun
sub main'hostTopNCreator
{
    local(
	  $cnr,$owner,
	  $iniHostIndex,$iniRateBase,
	  $iniTimeRemaining,$iniRequestedSize) = @_;
    
    $colnr = &main'create_new_collector(
				    $cnr,
				    "hostTopN",
				    $owner,
				    hostTopN'hostTopNCreatorCB) || return 0;
    return( $colnr);
}

# destroy the host collector
sub main'hostTopNTerminator
{
    local($conn,$coll, $owner) = @_;

    return &main'remove_collector($conn,"hostTopN",$coll,$owner);
}

#
# receive a row of the table, for the use with snmp_tbl
#
sub hostTopNGardnerCB
{
	local($i,$j,@repl) = @_;
	if($j == 1)
	{
	    print $localFile "\n$localId $localTable ";
	}
	print $localFile "$repl[2] ";
}

#
# request the host table
#
# input variables:
#      
#      1: $conn        spook connection number
#      4: $coll        collector number of host collector
#      5: $id          identification string
#      6: $file        file handle to write to
#
sub main'hostTopNGardner
{
    local( $conn, $coll, $id, $file) = @_;
    local( @res );

    $localId = $id;
    $localFile = $file;

    $localTable = "hostTopNControl";
    @res = &main'snmp_get($conn,    #',
         (
	  "hostTopNControlIndex[$coll]",  # 0
	  "hostTopNHostIndex[$coll]",     # 1
	  "hostTopNRateBase[$coll]",      # 2
	  "hostTopNTimeRemaining[$coll]", # 3
	  "hostTopNDuration[$coll]",      # 4
	  "hostTopNRequestedSize[$coll]", # 5
	  "hostTopNGrantedSize[$coll]",	  # 6
	  "hostTopNStartTime[$coll]",     # 7
	  "hostTopNOwner[$coll]",         # 8
	  "hostTopNStatus[$coll]"         # 9
         ));
    $time = time();
    print $file "\n$id hostControlStart $time $res[1] $res[2] $res[3] $res[4] $res[5] $res[6] $res[7] $res[8] $res[9]";  

    $localTable = "hostTopN";
    &main'snmp_tbl($conn,hostTopN'hostTopNGardnerCB,
         (
	  "hostTopNReport[$coll]", # 0
	  "hostTopNIndex[$coll]",  # 1
	  "hostTopNAddress[$coll]",# 2
	  "hostTopNRate[$coll]"	   # 3
         ));

    $localTable = "hostTopNControl";
    @res = &main'snmp_get($conn,    #',
         (
	  "hostTopNControlIndex[$coll]",  # 0
	  "hostTopNHostIndex[$coll]",     # 1
	  "hostTopNRateBase[$coll]",      # 2
	  "hostTopNTimeRemaining[$coll]", # 3
	  "hostTopNDuration[$coll]",      # 4
	  "hostTopNRequestedSize[$coll]", # 5
	  "hostTopNGrantedSize[$coll]",	  # 6
	  "hostTopNStartTime[$coll]",     # 7
	  "hostTopNOwner[$coll]",         # 8
	  "hostTopNStatus[$coll]"         # 9
         ));
    $time = time();
    print $file "\n$id hostControlStart $time $res[1] $res[2] $res[3] $res[4] $res[5] $res[6] $res[7] $res[8] $res[9]";  
    return 1;
}
1;





