package etherStats;
#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       etherstats.pl
##     SYSTEM   NAME:       etherstats
##     ORIGINAL AUTHOR(S):  Hans Otten
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Tue Aug  2 13:39:35 1994
##
## DESCRIPTION: 
##              
#########################################################################
## CHANGE INFORMATION ##
#########################
##      HO - Aug 2, 1994:  Created
#########################################################################
require "spook.pl";	   
require "rmon/rmon.pl";

# creation of an etherStats row/collector requires the setting of:
# o etherStatsDataSource
# and that's it. another ' to lose the grey stuff

sub etherStatsCreatorCB
{
	local($connNr , $collName , $collNr) = @_;
	local($res);
	
	$res = &main'snmp_set($connNr, $collName . "DataSource\[$collNr\]=$iniIface");
	if(! defined($res))
	{
		return undef;
	}
	return 1;
}	   

# create the etherStats collector with the correct inFun
sub main'etherStatsCreator
{
    local($conn, $owner, $iface) = @_;

    $iniIface = $iface;
    
    $collNr = &main'create_new_collector(
				    $conn,
				    "etherStats",
				    $owner,
				    etherStats'etherStatsCreatorCB) || return 0;
    return($collNr);
}

# destroy the etherStats collector
sub main'etherStatsTerminator
{
    local($conn, $coll, $owner) = @_;

    return &main'remove_collector($conn, "etherStats", $coll, $owner);
}

#
# receive a row of the table, for the use with snmp_tbl
#

sub etherStatsGardnerCB
{
	local($i, $j, @repl) = @_;
	if($j == 1)
	{
	    print $localFile "\n$localId $localTable ";
	}
	print $localFile "$repl[2] ";
}

#
# request the etherStats table
#
# input variables:
#      
#      1: $conn        spook connection number
#      2: $coll        collector number of host collector
#      3: $id          identification string
#      6: $file        file handle to write to
#
sub main'etherStatsGardner
{
    local( $conn, $coll, $id, $file) = @_;
    local( @res );

    $localId = $id;
    $localFile = $file;

    $localTable = "etherStats";
    @res = &main'snmp_get($conn,
         (
            "sysUpTime[0]",                           # 0
            "etherStatsIndex[$coll]",                 # 1
            "etherStatsDataSource[$coll]",            # 2
            "etherStatsDropEvents[$coll]",            # 3
            "etherStatsOctets[$coll]",                # 4
            "etherStatsPkts[$coll]",                  # 5
            "etherStatsBroadcastPkts[$coll]",         # 6
            "etherStatsMulticastPkts[$coll]",         # 7
            "etherStatsCRCAlignErrors[$coll]",        # 8
            "etherStatsUndersizePkts[$coll]",         # 9
            "etherStatsOversizePkts[$coll]",          # 10
            "etherStatsFragments[$coll]",             # 11 
            "etherStatsJabbers[$coll]",               # 12
            "etherStatsCollisions[$coll]",            # 13
            "etherStatsPkts64Octets[$coll]",          # 14 
            "etherStatsPkts65to127Octets[$coll]",     # 15
            "etherStatsPkts128to255Octets[$coll]",    # 16
            "etherStatsPkts256to511Octets[$coll]",    # 17
            "etherStatsPkts512to1023Octets[$coll]",   # 18
            "etherStatsPkts1024to1518Octets[$coll]",  # 19
            "etherStatsOwner[$coll]",                 # 20
            "etherStatsStatus[$coll]"                 # 21
         ));
    $time = time();
    print $file "\n$id etherStats $time $res[0] $res[1] $res[2] $res[3] $res[4] $res[5] $res[6] $res[7] $res[8] $res[9] $res[10] $res[11] $res[12] $res[13] $res[14] $res[15] $res[16] $res[17] $res[18] $res[19] $res[20] $res[21]";  
    return 1;
}
1;
