package trlog;
#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       trlog.pl
##     SYSTEM   NAME:       trlog
##     ORIGINAL AUTHOR(S):  Jan van Oorschot
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Tue Aug  9 09:01:28 1994
##
## DESCRIPTION: A sherlock application to log traps received
##              
#########################################################################
## CHANGE INFORMATION ##
#########################
##      JvO - Aug 9, 1994:  Created
#########################################################################
sub Handle_Cold_Trap
{
    # verify that it is a cold-start trap for this application
    # Trap[3] = dutepp2.et.tudelft.nl(130.161.144.67) --> RMON agent
    # Trap[6] = coldStart(0)                          --> exact match needed
    $NextTimer = 0;
    local($trnam,$trnum) = $Trap[6] =~ /^(\S*)\((\d+)\)$/;
    if( $trnum != 0 )
    {
	return 0;
    }
    ($name,$ip) = $Trap[3] =~ /^(\S*)\((\S*)\)$/;
    if($ip ne $RMONIP)
    {
	return 0;
    }
    &main'SherlockLog("$ID: cold start, reinitialise");
    return 1;
}
###########
# Function Entry Points of this Sherlock Application
###########
sub main'trlogInit
{
    local($ID,$Arg) = @_;
    local($old);
    $TrapLog = $main'sherDir . "/" . $ID . ".trlog"; #'
    if( !open(TRAPLOG,">>$TrapLog"))
    {
	&main'SherlockLog("trlog: cant open traplog file $TrapLog"); #'
        return -1;
    }
    $old = select(TRAPLOG); $| =1 ; select($old);
    return 0;			# dont wake up, only activated during
				# traps
}

sub main'trlogTimer
{
    ($ID,$Tim,$Arg) = @_;
    # should not be called for this trap capturing application
    &main'SherlockLog("trlog: called by Timer ?!?!?");
    return 0;
}

sub main'trlogTrap
{
    local($ID,$Arg,@Trap) = @_;
    local($tim) = &main'time2str(time()); #'
    print TRAPLOG "<$ID $tim> $Trap[3] $Trap[6]\n";
    return 0;
}

sub main'trlogExit
{
    ($ID,$Arg) = @_;
    close(TRAPLOG);
    return 0;
}

1;
