package timer;
#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       timer.pl
##     SYSTEM   NAME:       timer
##     ORIGINAL AUTHOR(S):  Jan van Oorschot
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Wed Jul 20 09:55:50 1994
##
## DESCRIPTION: Implements a timer library in perl. Keeps 
##              track of all outstanding timers, and returns
##              on request the next timer.
##
##              All timers consist of a triple:
##
##              ($id,$time,$args)
##
##
## 
#########################################################################
## CHANGE INFORMATION ##
#########################
##      JvO - Jul 20, 1994:  Created
#########################################################################

sub main'TimerInit
{
    local(@args) = @_;

    # initialise the ass. arrays containing the timers
    %TimeTime = ();		# $id   --> $time
    %TimeArgs = ();		# $id   --> $args
    return 1;
}

sub main'TimerPush
{
    local($id,$time,$args) = @_;
    if(defined($TimeTime{$id}))
    {
	$TrickletErrStr = "Timer: id already exists";
	return 0;
    }
    $TimeTime{$id} = $time;
    $TimeArgs{$id} = $args;
    return 1;
}

sub main'TimerPop
{
    local($id) = @_;
    local($time,$args);
    if(!defined($TimeTime{$id}))
    {
	$TrickletErrStr = "Timer: id does not exist";
	print "DEBUG: $TrickletErrStr\n";
	return 0;
    }
    $time = delete($TimeTime{$id});
    $args = delete($TimeArgs{$id});
    return(($id,$time,$args));
}

sub main'TimerNext
{
    $soon = undef;
    foreach $time (values(%TimeTime))
    {
	if((!defined($soon)) || $time < $soon)
	{
	    $soon = $time;
	}
    }
    return $soon;
}

sub main'TimerEvents
{
    local($now) = @_;
    local(@events,$id);
    # return all $id's of timers that have expired
    @events = ();
    foreach $id (keys(%TimeTime))
    {
	if($TimeTime{$id} <= $now)
	{
	    push(@events,$id);
	}
    }
    return @events;
}
1;
