require "timelocal.pl"


sub main'XrayDate
{
local($time) = @_;
local($sec,$min,$hour,$mday,$mon,$year) = localtime($time);

    $year += 1900 if $year >= 70;                 
    $year += 2000 if $year < 70;                 
    return sprintf("%4d-%02d-%02d", $year,$mon+1,$mday);
}

sub main'XrayCeilWeek
{
local($time) = @_;
local($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($time);
     										 					
	return $time + (7 - $wday) *24*60*60;
}

sub main'XrayBuildDataBase
{
local($dir) = @_;

	if (!opendir(XRAYDIR,$dir))
	{
        print STDERR "xray directory can not be opened";
		return -1;
	}
	
	@xrayfiles = reverse(grep(/xray\./,readdir(XRAYDIR)));
	
	closedir(XRAYDIR);
		 
	undef $firstsampletime;
	undef $firstdayreporttime;
	undef $firstweekreporttime;
	undef @firstsample;
	undef @firstdayreport;
	undef @firstweekreport;

	undef $lastsampletime;
	undef $lastdayreporttime;
	undef $lastweekreporttime;
	undef @lastsample;
	undef @lastdayreport;
	undef @lastweekreport;
	
	foreach $file (@xrayfiles)
	{
        ($xray,$type,$agent,$date,$time) = split(/\./,$file);
	
        push(agents,$agent);
	
        $agent_date = "$agent" . "_$date";
	
        if ($type eq "sample")
        {
            $nr = $sampletotalcount{$agent}++;
	        $agent_nr = "$agent" . "_$nr";
	        $nr = $samplecount{$agent_date}++;
	        $agent_date_nr = "$agent" . "_$date" . "_$nr";
	
	        $samples{$agent_nr} = $file;
	        $samples{$agent_date_nr} = $file;
										 
			if ($lastsampletime == undef)		  
			{
				@lastsample = split(/-/,$date);
				$lastsampletime = &timelocal(0,0,0,$lastsample[2],$lastsample[1],$lastsample[0]);
			}
			@firstsample = split(/-/,$date);
			$firstsampletime = &timelocal(0,0,0,$lastsample[2],$lastsample[1],$lastsample[0]);
        }
        elif ($type eq "day")
        {
            $nr = $dayreporttotalcount{$agent}++;
            $agent_nr = "$agent" . "_$nr";
            $nr = $dayreportcount{$agent_date}++;
            $agent_date_nr = "$agent" . "_$date" . "_$nr";
	                
            $dayreports{$agent_nr} = $file;
            $dayreports{$agent_date_nr} = $file;
											 
			if ($lastdayreporttime == undef)
			{
				@lastdayreport = split(/-/,$date);
				$lastdayreporttime = &timelocal(0,0,0,$lastdayreport[2],$lastdayreport[1],$lastdayreport[0]);
			}
			@firstdayreport = split(/-/,$date);
			$firstdayreporttime = &timelocal(0,0,0,$lastdayreport[2],$lastdayreport[1],$lastdayreport[0]);
        }
        elif ($type eq "week")
        {
            $nr = $weekreporttotalcount{$agent}++;
            $agent_nr = "$agent" . "_$nr";
            $nr = $weekreportcount{$agent_date}++;
            $agent_date_nr = "$agent" . "_$date" . "_$nr";
	                
            $weekreports{$agent_nr} = $file;
            $weekreports{$agent_date_nr} = $file;
			
			if ($lastweekreporttime == undef)
			{
				@lastweekreport = split(/-/,$date);
				$lastweekreporttime = &timelocal(0,0,0,$lastweekreport[2],$lastweekreport[1],$lastweekreport[0]);
			}
			@firstweekreport = split(/-/,$date);
			$firstweekreporttime = &timelocal(0,0,0,$lastweekreport[2],$lastweekreport[1],$lastweekreport[0]);
        }
	}
	
	return 0;
}

1;
