#!/usr/local/bin/perl

# this program is a demonstration of the Tricklet 
# perl interface made by the DNPAP group of
# the Technical University Delft, The Netherlands.
# 
require "spook.pl";
#
# handle the arguments
#
if( @ARGV>3 )
{
	die 	"call as:  perl demotbl.pl [<host> <community> [<medium>]\n" ,
		" where:\n" ,
		"	<host>		name of RMON monitor\n" ,
		"	<community>	community name for creating collectors\n",
		"	<medium>	UDP or PIPE\n";
}
($iniHost , $iniComm , $iniMed , @rest) = @ARGV;
#
# open a SNMP connection 
#
&snmp_open(1) || die "cant open a Spook connection\n";
if($iniHost ne "") { &snmp_host(1,$iniHost);}
if($iniMed ne "")  {&snmp_medium(1,$iniMed);}
&snmp_connect(1) || die "could't connect to ($iniHost,$iniMed)";
if($iniComm ne "") {&snmp_community(1,$iniComm);}
#
# get the table of system group. The snmp_tbl command
# needs a call-back function which will be called 
# for each line of the resulting table as:
#
#	demoFun( rowNr , colNr , ((valName1,valIndex1,valValue1)(...) ...) )
#
sub demoFun
{
	local($i,$j,@repl) = @_;
	
	print "<$i><$j> --> $repl[0]\[$repl[1]\]\=$repl[2]\n";
}

&snmp_tbl(1,main'demoFun,("system[]" , "system[]" ));
#
# close the SNMP connection
#
&snmp_disconnect(1);
&snmp_close(1);




