#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       fsmtst.pl
##     SYSTEM   NAME:       fsmtst
##     ORIGINAL AUTHOR(S):  Jan van Oorschot
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Tue Jul 26 09:26:55 1994
##
## DESCRIPTION: Test the FSM (Finite State Machine) package
##              
#########################################################################
## CHANGE INFORMATION ##
#########################
##      JvO - Jul 26, 1994:  Created
#########################################################################
require "tricklet.pl";
require "fsm.pl";

$pf = "main'FSM";

sub doerr
{
    print "$TrickletErrNo: $TrickletErrStr";
    die;
}

&FSM_Create($pf) || &doerr();

&FSM_State($pf,"state1",main'fun1) || &doerr();
&FSM_Transition($pf,"state1",0,"state2") || &doerr();
&FSM_Transition($pf,"state1",1,"state3") || &doerr();

&FSM_State($pf,"state2",main'fun2) || &doerr();
&FSM_Transition($pf,"state2",0,"state1") || &doerr();
&FSM_Transition($pf,"state2",1,"state3") || &doerr();

&FSM_State($pf,"state3",main'fun3) || &doerr();
&FSM_Transition($pf,"state3",0,"exit") || &doerr();

&FSM_Resolve($pf) || &doerr();

&FSM_Dump($pf) || &doerr();

&FSM_Run($pf,"state1") || &doerr();

sub fun1
{
    print "fun1\n";
    return 0;
}
sub fun2
{
    print "fun2\n";
    return 4;
}
sub fun3
{
    print "fun3\n";
    return 0;
}

@vars = ("main'var1","main'var2");

&FSM_TaskInit($pf,@vars);

$var1  = 1;
$var2  = 2;
&FSM_TaskSwitchOut($pf,"task1");
&FSM_TaskDump($pf);


$var1  = 3;
$var2  = 4;
&FSM_TaskSwitchOut($pf,"task2");
&FSM_TaskDump($pf);

&FSM_TaskSwitchIn($pf,"task1");
&FSM_TaskDump($pf);

&FSM_TaskSwitchIn($pf,"task2");
&FSM_TaskDump($pf);
