#!/usr/local/bin/perl
#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       alarmtst.pl
##     SYSTEM   NAME:       alarmtst
##     ORIGINAL AUTHOR(S):  Jan van Oorschot
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Thu Jul 14 16:49:08 1994
##
## DESCRIPTION: test the alarm collector
##              
#########################################################################
## CHANGE INFORMATION ##
#########################
##      JvO - Jul 14, 1994:  Created
#########################################################################
require "spook.pl";	   
require "rmon/rmon.pl";
require "rmon/alarm.pl";

@ErrorMessage =
(
"call as:  perl alarmtst.pl",
"        alarmInterval          --> interval(secs) over which the data",
"                                   is sampled and compared with the",
"                                   rising and falling thresholds",
"        alarmVariable          --> variable to be sampled",
"        alarmSampleType        --> absoluteValue(1)/deltaValue(2)",
"        alarmValue             --> value of statistic during last sample period",
"                                   (ReadOnly)",
"        alarmStartupAlarm      --> risingAlarm(1)/fallingAlarm(2)/",
"                                   risingOrFallingAlarm(3)",
"        alarmRisingThreshold   --> rising threshold for varaible",
"        alarmFallingThreshold  --> falling threshold for variable",
"        alarmRisingEventIndex  --> event to send by rising alarm",
"                                   (0 if not used)",
"        alarmFallingEventIndex --> event to send by falling alarm",
"                                   (0 if not used)",
"              [host community]"
);

$ires = &snmp_commandline_open(1,8,@ARGV);
if($ires == -1){ foreach $line (@ErrorMessage) { print "$line\n";};exit;};
  (
              $iniAlarmInterval,
              $iniAlarmVariable,
              $iniAlarmSampleType,
              $iniAlarmStartupAlarm,
              $iniAlarmRisingThreshold,
              $iniAlarmFallingThreshold,
              $iniAlarmRisingEventIndex,
              $iniAlarmFallingEventIndex
  ) = @ARGV;
#
# do the filter Thingy
#
$iniColl = &alarmCreator( 1, $iniOwnerString ,  
              $iniAlarmInterval,
              $iniAlarmVariable,
              $iniAlarmSampleType,
              $iniAlarmStartupAlarm,
              $iniAlarmRisingThreshold,
              $iniAlarmFallingThreshold,
              $iniAlarmRisingEventIndex,
              $iniAlarmFallingEventIndex
	   ) || die "could not create collector" ;

&alarmGardner(1,$iniColl,"alarmtst",STDOUT);

&alarmTerminator(1,$iniColl,$iniOwnerString);


&snmp_close(1);



