#!/usr/local/bin/perl

# Tests the Discovery Node  collector by starting a collector, sleeping
# for a given period of time, collecting information from
# the collecting and then terminating the collector.

require "spook.pl";	   
require "rmon/rmon.pl";
require "rmon/discnode.pl";

#
# handle the arguments
#
if( @ARGV<1 || @ARGV>3 )
{
	die 	"call as:  perl discnodetst.pl <period> [<host> <community> <medium>]\n" ,
		" where:\n" ,
		"       <period>        sleeping period in seconds\n",
		"	<host>		name of RMON monitor\n" ,
		"	<community>	community name for creating collectors\n",
		"	<medium>	UDP or PIPE\n";
}
($iniPeriod, $iniHost , $iniComm , $iniMed,@rest) = @ARGV;

# create the SPOOK connection
&snmp_open(1) || die "cant open a Spook connection\n";

if($iniHost ne "") { &snmp_host(1,$iniHost);}
if($iniMed ne "")  {&snmp_medium(1,$iniMed);}
if($iniComm ne "") {&snmp_community(1,$iniComm);}

&snmp_connect(1) || die "could't connect to ($iniHost,$iniMed)";

#
# Discovery Node specific code
#
print STDERR "interogating discNode collector $iniColl\n";
$iniColl = &discNodeCreator( 1, $iniOwnerString , "ifIndex[1]") || die "could not create collector" ;
sleep($iniPeriod);
&discNodeGardner(1,$iniColl,"test",STDOUT );
&discNodeTerminator(1,$iniColl,$iniOwnerString);

&snmp_disconnect(1);
&snmp_close(1);

