#!/usr/local/bin/perl

# Tests the History collector by starting a collector, sleeping
# for a given period of time, collecting information from
# the collecting and then terminating the collector.

require "spook.pl";	   
require "rmon/rmon.pl";
require "rmon/history.pl";

#
# handle the arguments
#
if( @ARGV<3 || @ARGV>6 )
{
	die 	"call as:  perl historytst.pl <interval> <#intervals> <display-period> [<host> <community> <medium>]\n" ,
		" where:\n" ,
		"       <interval>   interval in seconds during which data is collected\n",
		"       <#intervals> number of intervals displayed\n",
		"       <display-period>  refresh rate in seconds\n",
		"	<host>	     name of RMON monitor\n" ,
		"	<community>  community name for creating collectors\n",
		"	<medium>     UDP or PIPE\n";
}
($iniInt,$iniNrInt,$iniPeriod,$iniHost , $iniComm , $iniMed,@rest) = @ARGV;

# create the SPOOK connection
&snmp_open(1) || die "cant open a Spook connection\n";

if($iniHost ne "") { &snmp_host(1,$iniHost);}
if($iniMed ne "")  {&snmp_medium(1,$iniMed);}
if($iniComm ne "") {&snmp_community(1,$iniComm);}

&snmp_connect(1) || die "could't connect to ($iniHost,$iniMed)";

#
# History Specific code
#
print STDERR "interogating history collector $iniColl\n";
$iniColl = &historyCreator( 1, $iniOwnerString , "ifIndex[1]" , $iniInt , $iniNrInt) || die "could not create collector" ;

#prepare the signal handler
sub sigHandler
{
	local($sig) = @_;
	print("\nTerminating etherstats collector and exiting\n");
	# remove the etherStats collector
	&remove_collector(1,"historyControl",$iniColl,$iniOwnerString) || die "failed removing\n";
	
	# close the Spook connection
	&snmp_disconnect(1);
	&snmp_close(1);
	exit;
}
$SIG{'INT'}  = 'sigHandler';
$SIG{'QUIT'} = 'sigHandler';


#
# create a gnuplot process
#
open(GNUPLOT, '| /usr/local/bin/gnuplot') || die "can't open gnuplot";
select(GNUPLOT); $| = 1;
select(STDOUT);

#
# OK, redisplay history at regular intervals
#
while(1)
{
    $tfile="main'GAROUT";
    sleep($iniPeriod);
    open($tfile,'>/tmp/eikel.dat') || die "could not open gardner output file";
    print $tfile "# starting 3 gnuplot line\n";
    &historyGardner(1,$iniColl,"test",$tfile );
#    &historyGardner(1,$iniColl,"test",STDOUT);
    close($tfile);
    &historyPainter('/tmp/eikel.dat',main'GNUPLOT);
}

#
# Close the SPOOK connection, we should not reach this
#
&snmp_disconnect(1);
&snmp_close(1);

