#!/usr/local/bin/perl
#########################################################################
## MODULE INFORMATION#
######################
##     FILE     NAME:       hosttopntst.pl
##     SYSTEM   NAME:       hosttopntst
##     ORIGINAL AUTHOR(S):  
##     VERSION  NUMBER:     1.00
##     CREATION DATE:       Thu Jun 30 11:29:00 1994
##
## DESCRIPTION: test the hostTopN support
##              
#########################################################################
## CHANGE INFORMATION ##
#########################
##       - Jun 30, 1994:  Created
#########################################################################
require "spook.pl";	   
require "rmon/rmon.pl";
require "rmon/hosttopn.pl";

@ErrorMessage =
(
"call as:  perl hosttopntst.pl <HostIndex> <RateBase> <TimeRemaining>",
"                              <RequestedSize> [<host> <community> <medium>]",
"where:    HostIndex      --> index of host table to use",
"          RateBase       --> variable of host table to use",
"                          hostTopNInPkts(1)",
"                          hostTopNOutPkts(2)",
"                          hostTopNInOctets(3)",
"                          hostTopNOutOctets(4)",
"                          hostTopNOutErrors(5)",
"                          hostTopNOutBroadcastPkts(6)",
"                          hostTopNOutMulticastPkts(7)",
"          TimeRemaining  --> time the topN should be measured",
"          RequestedSize  --> number of hosts (N in the TopN)"
);

$ires = &snmp_commandline_open(1,4,@ARGV);
if($ires == -1){ foreach $line (@ErrorMessage) { print "$line\n";};exit;}
($iniHostIndex,$iniRateBase,$iniTimeRemaining,$iniRequestedSize) = @ARGV;

#
# do the hostTopN Thingy
$iniColl = &hostTopNCreator( 1, $iniOwnerString , 
			    $iniHostIndex,
			    $iniRateBase,
			    $iniTimeRemaining,
			    $iniRequestedSize) || 
    die "could not create collector" ;
print "interogating hostTopN collector $iniColl\n";
sleep($iniTimeRemaining+3);
&hostTopNGardner(1,$iniColl,"test",STDOUT );
&hostTopNTerminator(1,$iniColl,$iniOwnerString);

&snmp_close(1);



