#!/usr/local/bin/perl
#
# Tests the Host collector by starting a collector, sleeping
# for a given period of time, collecting information from
# the collecting and then terminating the collector.
#

require "spook.pl";	   
require "rmon/rmon.pl";
require "rmon/host.pl";

#
# handle the arguments
#
if( @ARGV<1 || @ARGV>3 )
{
	die 	"call as:  perl hosttst.pl period [<host> <community> <medium>]\n" ,
		" where:\n" ,
		"       <period>        sleeping period in seconds",
		"	<host>		name of RMON monitor\n" ,
		"	<community>	community name for creating collectors\n",
		"	<medium>	UDP or PIPE\n";
}
($iniPeriod,$iniHost , $iniComm , $iniMed,@rest) = @ARGV;

# create the SPOOK connection to the RMON monitor
&snmp_open(1) || die "cant open a Spook connection\n";
if($iniHost ne "") { &snmp_host(1,$iniHost);}
if($iniComm ne "") {&snmp_community(1,$iniComm);}
if($iniMed ne "")  {&snmp_medium(1,$iniMed);}

&snmp_connect(1) || die "could't connect to ($iniHost,$iniMed)";

#
# do the Host Thingy
print STDERR "interogating host collector $iniColl\n";
$iniColl = &hostCreator( 1, $iniOwnerString , "ifIndex[1]") || die "could not create collector" ;
sleep($iniPeriod);
&hostGardner(1,$iniColl,"test",STDOUT );
&hostTerminator(1,$iniColl,$iniOwnerString);
#
#

&snmp_disconnect(1);
&snmp_close(1);

