#!/usr/local/bin/perl

# this program is a demonstration of the Tricklet 
# perl interface made by the DNPAP group of
# the Technical University Delft, The Netherlands.
# 
require "spook.pl";
#
# handle the arguments
#
if( @ARGV!=5 )
{
	die 	"call as:  perl scheme.pl script-nr run-nr <host> <community>\n" ,
		" where:\n" ,
                "       <script>        name of script file\n",
                "       <script-nr>     number of script to upload\n",
                "       <run-nr>        number of run\n",
		"	<host>		name of RMON monitor\n" ,
          	"	<community>	community name for creating collector";
}
($scriptfile,$cnr,$rnr, $iniHost , $iniComm, @rest) = @ARGV;
#
# open a SNMP connection 
#
&snmp_open(1) || die "cant open a Spook connection\n";
if($iniHost ne "") { &snmp_host(1,$iniHost);}
if($iniMed ne "")  {&snmp_medium(1,$iniMed);}
&snmp_connect(1) || die "could't connect to ($iniHost,$iniMed)";
if($iniComm ne "") {&snmp_community(1,$iniComm);}


#
# open a scheme collector
#
$res = &snmp_set(1,"subscriptSourceControlStatus[$cnr]=2");
if($res!=2) { die "failed subscriptSourceControlStatus[$cnr]=2";}
$res = &snmp_set(1,"subscriptSourceControlLanguage[$cnr]=1");
if($res!=1) { die "failed subscriptSourceControlLanguage[$cnr]=1";}
$res = &snmp_set(1,"subscriptSourceControlOwner[$cnr]=\"jan\"");
if($res ne "\"jan\"") 
{ 
    die "failed subscriptSourceControlOwner[$cnr]=\"jan\"";
}
#
# read a file, and store it as script in the beholder
#

open(INPUT,$scriptfile) || die "can't open script file";
$cnt = 1;
while($str = <INPUT>)
{
    chop $str;
    $res = &snmp_set(1,"subscriptSourceLine[$cnr.$cnt] = \"$str\"");
    $cnt++;
}

$res = &snmp_set(1,"subscriptSourceControlStatus[$cnr]=1");
if($res!=1) { die "failed subscriptSourceControlStatus[$cnr]=1";}

$res = &snmp_set(1,"subscriptRunControlStatus[$rnr]=2");
if($res!=2) { die "failed subscriptRunControlStatus[$rnr]=2";}

$res = &snmp_set(1,"subscriptRunControlScript[$rnr]=$cnr");
if($res!=$cnr) { die "failed subscriptRunControlScript[$rnr]=$cnr";}

$res = &snmp_set(1,"subscriptRunControlOwner[$rnr]=\"jan\"");
if($res ne "\"jan\"") 
{ 
    die "failed subscriptRunControlOwner[$rnr]=\"jan\"";
}

$res = &snmp_set(1,"subscriptRunControlStatus[$rnr]=1");
if($res != 1) {die "failed subscriptRunControlStatus[$rnr]=1";} 

$res = &snmp_set(1,"subscriptRunControlCommand[$rnr]=2");
if($res != 2) {die "failed subscriptRunControlCommand[$rnr]=2";}

#
# close the SNMP connection
#
&snmp_disconnect(1);
&snmp_close(1);

