# initialize, create pipes and start Spook
SnmpInit()
{
        ret=""
        response=""
        varbind=""
        error=""

        # give names to named pipes
        spookin=spook.in.$$
        spookout=spook.out.$$

        # make named pipes
        mknod $spookin p
        mknod $spookout p

        # start stdspook in background and 
        # connect in- and output to named pipes
        exec stdspook < $spookin > $spookout &
        spookpid=$!

        # create file handle 3 for input and 4 for output
        exec 4> $spookin 3< $spookout

        # install trap handler
        trap 'SnmpExit; exit' 1 2 3 8 10 11 12 13 15

	return 0
}


# terminate Spook
SnmpKill()
{
        Snmp "."
	return
}


# kill Spook and clean up named pipes
SnmpExit()
{
        SnmpKill
        rm -f $spookin
        rm -f $spookout
	return 0
}
        

# do a SNMP request
Snmp()
{
        echo "$*" > $spookin
        read response < $spookout
        case "$response" in
        ?+*) ret="success"; varbind=`SnmpResp2Varbind "$response"`; error="" ;;
        ?-*) ret="failure"; varbind=""; set - $response; shift; error="$*"; return 1 ;;
	\?.) ret="end"; varbind=""; error="" ;;
        *)   ret="unknown"; varbind=""; error="unknown"; return 1 ;;
        esac
	return 0
}


# convert response to varbinds
SnmpResp2Varbind()
{
	case "$*" in
	\?+*) echo "$*" | awk '{ print substr($0, 3) }' ;;
	*)    echo "" ;;
	esac
}


# set SNMP host
SnmpHost()
{
        Snmp "= host $*"
	return
}


# set SNMP community name
SnmpCommunity()
{
        Snmp "= community $*"
	return
}


# open SNMP connection to host
SnmpOpen()
{
        Snmp "["
	return
}


# close SNMP connection to host
SnmpClose()
{
        Snmp "]"
	return
}


# set get request
SnmpGet()
{
        Snmp "< $*"
	return
}


# set set request
SnmpSet()
{
        Snmp "> $*"
	return
}


# set next request
SnmpNext()
{
        Snmp "} $*"
	return
}


# set table request
SnmpTable()
{
        Snmp "* $*"
	return
}


# execute request
SnmpExec()
{
        Snmp "?"
	return
}
