(define packet-counter 0)

(define (mac-callback id interface packet param)
		(set! packet-counter (+ packet-counter 1))
)

(define (mib-callback id request varbind param)
	(define oid (varbind-id varbind))
	(define idlen (vector-length oid))
	(cond 
		((= request 3) 
			4)
		((or
			(> idlen 3)
			(and 
				(= request 1) 
				(> idlen 2)))
			2)
		(else
			(cond
				((= request 1)
					(define newid (make-vector (+ idlen 1) 0)))
				(else
					(define newid (make-vector idlen 0)))
			)
			(vector-set! newid 0 (vector-ref oid 0))
			(vector-set! newid 1 (vector-ref oid 1))
			(set-varbind-id! varbind newid)
			(set-varbind-type! varbind 1)
			(set-varbind-syntax! varbind packet-counter)
			varbind)
	)
)

(define (init)
		(display "init called")
)                  
	
(define (start)
		(display "start called")
		(define mac-id (mac-register mac-callback 1 0))
		(define mib-id (mib-register-results #(1) mib-callback 1 3 0))
)
	
(define (stop)
		(display "stop called")
)
	
(define (resume)
		(display "resume called")
)
	
(define (exit)
		(display "exit called")
		(mac-deregister mac-id)
		(mib-deregister mib-id)
)
	
(command-register "init" init)
(command-register "start" start)
(command-register "stop" stop)
(command-register "resume" resume)
(command-register "exit" exit)
