(define packet-counter 0)

(define (mac-callback id interface packet param)
		(set! packet-counter (+ packet-counter 1))
)

(define (mib-callback id request varbind param)
	(display "mib-callback called")
	(define oid (varbind-id varbind))
	(define idlen (vector-length oid))
	(cond 
		((= request 3) 
			4)
		((and 
			(= request 1) 
			(> idlen 2)) 
			2)
		(else
			(define newid (make-vector (+ idlen 1) 0))
			(vector-set! newid 0 (vector-ref oid 0))
			(vector-set! newid 1 (vector-ref oid 1))
			(set-varbind-id! varbind newid)
			(set-varbind-type! varbind 1)
			(set-varbind-syntax! varbind packet-counter)
			varbind)
	)
)

(define (snmp-callback id status index varbinds param)
		(display "snmp-callback called")
		(display id)
		(display status)
		(display index)
		(display varbinds)
)

(define (timer-callback id now param)
		(display "timer-callback called")
		(display now)
		(display packet-counter)
		(newline)
)

(define (init)
		(display "init called")
		(define varbind (make-varbind #(1 1) 1 1))
		(set-varbind-type! varbind 1)
)                  
	
(define (start)
		(display "start called")
		(define timer-id (timer-register timer-callback 30000 0 0))
		(define mac-id (mac-register mac-callback 1 0))
		(define mib-id (mib-register-results #(1) mib-callback 1 3 0))
		(define snmp-id (snmp-connect snmp-callback "dutepp34" 161 "get" "public" 0))
		(define sysDescr (make-varbind #(1 3 6 1 2 1 1 1 0) 0 ""))
		(snmp-send snmp-id (make-vector 1 sysDescr))
)
	
(define (stop)
		(display "stop called")
)
	
(define (resume)
		(display "resume called")
)
	
(define (exit)
		(display "exit called")
		(timer-deregister timer-id)
		(mac-deregister mac-id)
		(mib-deregister mib-id)
		(snmp-deregister snmp-id)
)
	
(command-register "init" init)
(command-register "start" start)
(command-register "stop" stop)
(command-register "resume" resume)
(command-register "exit" exit)
