(define source-id -1)
(define interval-id -1)
(define buckets-id -1)
(define topn-source-id -1)
(define topn-dest-id -1)
(define topn-pkts-id -1)
(define timer-id -1)

(define source-val 1)
(define interval-val 30)
(define buckets-val 10)

(define matrix-root (vector 1 3 6 1 2 1 16 6 2 1 1 source-val))

(define matrix-table (make-hash 3001))

(define topn-val #())


(define (vector-copy vec)
	(list->vector (vector->list vec))
)

(define (subvector vec start len)
	(define sub (make-vector len))
	(do ((i 0 (+ i 1)))
		((= i len) sub)
		(vector-set! sub i (vector-ref vec (+ i start))))
)

(define (source id request varbind param)
	(let*
	((oid (varbind-id varbind))
	(idlen (vector-length oid)))
	(cond 
		((= request 3) 
			(set! source-val (varbind-syntax varbind))
			varbind)
		((or
			(> idlen 3)
			(and 
				(= request 1) 
				(> idlen 2)))
			2)
		(else
			(cond
				((= request 1)
					(define newid (make-vector (+ idlen 1) 0)))
				(else
					(define newid (make-vector idlen 0)))
			)
			(vector-set! newid 0 (vector-ref oid 0))
			(vector-set! newid 1 (vector-ref oid 1))
			(set-varbind-id! varbind newid)
			(set-varbind-type! varbind 1)
			(set-varbind-syntax! varbind source-val)
			varbind)
	))
)

(define (interval id request varbind param)
	(let*
	((define oid (varbind-id varbind))
	(define idlen (vector-length oid)))
	(cond 
		((= request 3) 
			(set! interval-val (varbind-syntax varbind))
			varbind)
		((or
			(> idlen 3)
			(and 
				(= request 1) 
				(> idlen 2)))
			2)
		(else
			(cond
				((= request 1)
					(define newid (make-vector (+ idlen 1) 0)))
				(else
					(define newid (make-vector idlen 0)))
			)
			(vector-set! newid 0 (vector-ref oid 0))
			(vector-set! newid 1 (vector-ref oid 1))
			(set-varbind-id! varbind newid)
			(set-varbind-type! varbind 1)
			(set-varbind-syntax! varbind interval-val)
			varbind)
	))
)

(define (buckets id request varbind param)
	(let*
	((define oid (varbind-id varbind))
	(define idlen (vector-length oid)))
	(cond 
		((= request 3) 
			(set! buckets-val (varbind-syntax varbind))
			varbind)
		((or
			(> idlen 3)
			(and 
				(= request 1) 
				(> idlen 2)))
			2)
		(else
			(cond
				((= request 1)
					(define newid (make-vector (+ idlen 1) 0)))
				(else
					(define newid (make-vector idlen 0)))
			)
			(vector-set! newid 0 (vector-ref oid 0))
			(vector-set! newid 1 (vector-ref oid 1))
			(set-varbind-id! varbind newid)
			(set-varbind-type! varbind 1)
			(set-varbind-syntax! varbind buckets-val)
			varbind)
	))
)

(define (topn id request varbind param)
	(let*
	((define oid (varbind-id varbind))
	(define idlen (vector-length oid))
	(define subid 0))
	(cond 
		((= request 3) 
			4)
		((and 
				(= request 0) 
				(not (= idlen 3)))
			2)
		(else
			(if (> idlen 2)
				(set! subid (vector-ref oid 2))
			)
			(if (= request 1)
				(begin
				(set! subid (+ subid 1))
				(if (< subid 1)
					(set! subid 1)
				))
			)
			(if (or
					(> subid (vector-length topn-val))
					(< subid 1)
					(> subid buckets-val))
				2
				(let
				((newid (make-vector 3 0)))
				(vector-set! newid 0 (vector-ref oid 0))
				(vector-set! newid 1 (vector-ref oid 1))
				(vector-set! newid 2 subid)
				(set-varbind-id! varbind newid)
				(cond 
					((= id topn-source-id)
						(set-varbind-type! varbind 2)
						(set-varbind-syntax! varbind (car (vector-ref topn-val (- subid 1)))))
					((= id topn-dest-id)
						(set-varbind-type! varbind 2)
						(set-varbind-syntax! varbind (cadr (vector-ref topn-val (- subid 1)))))
					((= id topn-pkts-id)
						(set-varbind-type! varbind 1)
						(set-varbind-syntax! varbind (caddr (vector-ref topn-val (- subid 1)))))
				)
				varbind)
			)
		)
	))
)

(define (sample id now param)
	(let*
	((matrix-source (make-varbind (vector-copy matrix-root) 1 0))
	(matrix-dest (make-varbind (vector-copy matrix-root) 1 0))
	(matrix-pkts (make-varbind (vector-copy matrix-root) 1 0))
	(matrix-next (vector matrix-source matrix-dest matrix-pkts))
	(links '())
	(entry '())
	(delta 0)
	(count 1)
	(src 0))
	(vector-set! (varbind-id matrix-source) 10 1)
	(vector-set! (varbind-id matrix-dest) 10 2)
	(vector-set! (varbind-id matrix-pkts) 10 4)
	(set! topn-val (make-vector buckets-val '()))
	(do ((result (mib-next matrix-next) (mib-next matrix-next)))
		((or (> count 200) (eqv? result #f)
			(and (number? result) (not (= result 0)))
			(not (equal? (subvector (varbind-id (vector-ref result 0)) 0 12) matrix-root)))
			matrix-table)
		(set! count (+ count 1))
		(set! matrix-next result)
		(set! matrix-source (vector-ref matrix-next 0))
		(set! matrix-dest (vector-ref matrix-next 1))
		(set! matrix-pkts (vector-ref matrix-next 2))
		(set! delta 0)
		(display "source")
		(set! src (varbind-syntax matrix-source))
		(display (char->integer (vector-ref src 0)))
		(display (char->integer (vector-ref src 1)))
		(display (char->integer (vector-ref src 2)))
		(display (char->integer (vector-ref src 3)))
		(display (char->integer (vector-ref src 4)))
		(display (char->integer (vector-ref src 5)))
		(set! links (hash-ref matrix-table (varbind-syntax matrix-source)))
		(set! entry (assoc (varbind-syntax matrix-dest) links))
		(if (or (null? links) (not entry))
			(begin
			(hash-set! matrix-table (varbind-syntax matrix-source) (cons (list (varbind-syntax matrix-dest) (varbind-syntax matrix-pkts)) links)))
			(begin 
		(display "dest")
		(set! src (varbind-syntax matrix-dest))
		(display (char->integer (vector-ref src 0)))
		(display (char->integer (vector-ref src 1)))
		(display (char->integer (vector-ref src 2)))
		(display (char->integer (vector-ref src 3)))
		(display (char->integer (vector-ref src 4)))
		(display (char->integer (vector-ref src 5)))
		(display "pkts")
			(display (cadr entry)) (set! delta (- (varbind-syntax matrix-pkts) (cadr entry)))
				(set-car! (cdr entry) (varbind-syntax matrix-pkts)))
		)
		(if (> delta 0)
			(let
			((done #f)
			(i 0)
			(j 0))
			(do ((i 0 (+ i 1)))
				((or (= i buckets-val) done) i)
				(if (or (eqv? (vector-ref topn-val i) '())
					(> delta (caddr (vector-ref topn-val i))))
					(begin
					(do ((j (- buckets-val 1) (- j 1)))
						((= j i) 0)
						(vector-set! topn-val j (vector-ref topn-val (- j 1)))
					)
					(vector-set! topn-val i (list (vector-copy (varbind-syntax matrix-source)) (vector-copy (varbind-syntax matrix-dest)) delta))
					(set! done #t))
				)
			))
		)
	))
)

(define (init)
	(set! source-id (mib-register-args #(1) source 1 3 0))
	(set! interval-id (mib-register-args #(2) interval 1 3 0))
	(set! buckets-id (mib-register-args #(3) buckets 1 3 0))
	(set! topn-source-id (mib-register-results #(1) topn 2 1 0))
	(set! topn-dest-id (mib-register-results #(2) topn 2 1 0))
	(set! topn-pkts-id (mib-register-results #(3) topn 1 1 0))
)

(define (start)
	(set! timer-id (timer-register sample (* interval-val 1000) 0 0))
)

(define (stop)
	(timer-deregister timer-id)
)

(define (resume)
	(set! timer-id (timer-register sample (* interval-val 1000) 0 0))
)

(define (exit)
	(timer-deregister timer-id)
	(mib-deregister source-id)
	(mib-deregister interval-id)
	(mib-deregister buckets-id)
	(mib-deregister topn-source-id)
	(mib-deregister topn-dest-id)
	(mib-deregister topn-pkts-id)
)

(command-register "init" init)
(command-register "start" start)
(command-register "stop" stop)
(command-register "resume" resume)
(command-register "exit" exit)
