proc Varbind2List {varbind} {
	for {set i 0; set list {}} {$i < [llength $varbind]} {incr i} {
		set s [lindex $varbind $i]
		set j [string first "=" $s] 
		if {$j > 0} {
			set t [string range $s 0 [expr $j -1]]
			set value [string range $s [expr $j +1] end]
		} else {
			set t $s
			set value {}
		}
		set m [string first "\[" $t]
		set n [string last "\]" $t]
		if {$m > 0 && $n > 0 && $m < $n} {
			set name [string range $t 0 [expr $m -1]]
			set index [string range $t [expr $m +1] [expr $n -1]]
		} else {
			set name $t
			set index {}
		}
		lappend list [list $name $index $value]
	}
	return $list
}


proc List2Varbind {list} {
	for {set i 0; set varbind {}} {$i < [llength $list]} {incr i} {
		set entry [lindex $list $i]
		set name [lindex $entry 0]
		set index [lindex $entry 1]
		set value [lindex $entry 2]
		if {$index == "" && $value == ""} {
			lappend varbind "$name"
		} elseif {$index == ""} {
			lappend varbind "$name=$value"
		} elseif {$value == ""} {
			lappend varbind "$name\[$index\]"
		} else {
			lappend varbind "$name\[$index\]=$value"
		}
	}
	return [join $varbind ";"]
}


proc MibRead {} {
	global mib2oid
	global oid2mib
	global miblist

	if [catch {open "|snmp-dump iso" "r"} fd] {
		error "can't open snmp-dump"
		return -1
	}

	while {[gets $fd line] > 0} {
		set name [lindex $line 0]
		set oid [lindex $line 4]
		set mib2oid($name) [lrange $line 1 4]
		set oid2mib($oid)  [lrange $line 0 3] 
		lappend miblist $name
	}

	if [catch {close $fd}] {
		error "can't close snmp-dump"
		return -1
	}

	return 0
}
