#! /usr/local/bin/tclsh


source snmp.tcl
source mib.tcl
source rmon.tcl


if {$argc < 1} {
	puts "usage: $argv0 agent"
	exit 1
}


if {[set fd [SnmpInit]] < 0} {
	puts "failed to initialize SNMP"
} else {
	puts "SNMP initialized"
}

SnmpHost $fd [lindex $argv 0]
SnmpCommunity $fd secret

if {[SnmpOpen $fd] < 0} {
	puts "can't open connection"
}

SnmpGet $fd [list "sysDescr" "sysContact" "sysLocation"]
if {[SnmpExec $fd] < 0} {
	puts "request failed: $snmperror($fd)"
} else {
	for {set i 0} {$i < [llength $snmpvarbind($fd)]} {incr i} {
		puts [lindex $snmpvarbind($fd) $i]
	}
	for {set i 0} {$i < [llength $snmpvarlist($fd)]} {incr i} {
		puts [lindex $snmpvarlist($fd) $i]
	}
}

set owner [exec whoami]

puts "hostControlIndex: [set index [RmonNextIndex $fd hostControl]]"
#RmonCreate $fd hostControl $index $owner
#RmonActivate $fd hostControl $index
#puts "hostControlIndex: [RmonNextIndex $fd hostControl]"
puts "hostControl instances: [RmonInstance $fd hostControl]"
#exec sleep 20
#RmonDelete $fd hostControl $index

puts "loading MIB ..."
if {[MibRead] < 0} {
	puts "error loading MIB"
} else {
	puts "MIB loaded"
}

puts "sysDescr info: $mib(sysDescr)"
puts "sysDescr info: $bim(1.3.6.1.2.1.1.1)"

if {[SnmpClose $fd] < 0} {
	puts "can't close connection"
}

SnmpKill $fd
