/*
     libscheme	
     Copyright (C) 1994 Brent Benson

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 1, or (at your option)
     any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#define VFILE
#define VFKEEPSTUB

#include "scheme.h"

Scheme_Object *jantje(int argc,Scheme_Object *argv[]);
Scheme_Object *GetSchemePtr(int argc,Scheme_Object *argv[]);

static Scheme_Env *global_env;


int main(int argc,char **argv)
{
  Scheme_Object *obj;

  VSPACE *vsp;
  
  vsp = vspace_create();
  vspace_setcur(vsp);
  vf_real2virt(argv[1],"stdin"); /* read a real file to stdin */
  
  vspace_dump(vsp);
  
  global_env = scheme_basic_env ();
  GC_expand_hp (40);
  do
    {
      obj = scheme_read (stdin);
      if (obj == scheme_eof)
	{
	  break;
	}
      scheme_add_global("jantje",scheme_make_prim(jantje),global_env);
      scheme_add_global("tst",scheme_make_prim(GetSchemePtr),global_env);
      obj = SCHEME_CATCH_ERROR(scheme_eval (obj, global_env),0);
      if (obj)
	{
	  scheme_write (stdout, obj);
	  printf ("\n");
	}
    }
  while ( 1 );

  vspace_dump(vsp);
  vspace_destroy(vsp);
  return 0;
  
}

Scheme_Object *
jantje(int argc,Scheme_Object *argv[])
{
     int i;

     fprintf(stderr,"here is jantje\n");
     
     for(i=0;i<argc;i++)
     {
          scheme_write(stderr,argv[i]);
          fprintf(stderr,"\n");
          
     }
     return scheme_true;
}

static char name[256];

Scheme_Object *GetSchemePtr(int argc,Scheme_Object *argv[])
{
     Scheme_Object *obj;
     int i;
     

     for(i=0;i<argc;i++)
     {
          scheme_write(stdout,argv[i]);
          printf("\n");
          if( SCHEME_CHARP(argv[i])    )
          {
               printf("argv[%d] = SCHEME_CHARP\n",i);
          }
          if( SCHEME_INTP(argv[i])     )
          {
               printf("argv[%d] = SCHEME_INTP\n",i);
          }
          if( SCHEME_DBLP(argv[i])     )
          {
               printf("argv[%d] = SCHEME_DBLP\n",i);
          }
          if( SCHEME_NUMBERP(argv[i])  )
          {
               printf("argv[%d] = SCHEME_NUMBERP\n",i);
          }
          if( SCHEME_STRINGP(argv[i])  )
          {
               printf("argv[%d] = SCHEME_STRINGP\n",i);
          }
          if( SCHEME_SYMBOLP(argv[i])  )
          {
               printf("argv[%d] = SCHEME_SYMBOLP\n",i);
          }
          if( SCHEME_BOOLP(argv[i]))
          {
               printf("argv[%d] = SCHEME_BOOLP\n",i);
          }
          if( SCHEME_SYNTAXP(argv[i])  )
          {
               printf("argv[%d] = SCHEME_SYNTAXP\n",i);
          }
          if( SCHEME_PRIMP(argv[i])    )
          {
               printf("argv[%d] = SCHEME_PRIMP\n",i);
          }
          if( SCHEME_CONTP(argv[i])    )
          {
               printf("argv[%d] = SCHEME_CONTP\n",i);
          }
          if( SCHEME_NULLP(argv[i])    )
          {
               printf("argv[%d] = SCHEME_NULLP\n",i);
          }
          if( SCHEME_PAIRP(argv[i])    )
          {
               printf("argv[%d] = SCHEME_PAIRP\n",i);
          }
          if( SCHEME_LISTP(argv[i])    )
          {
               printf("argv[%d] = SCHEME_LISTP\n",i);
          }
          if( SCHEME_VECTORP(argv[i])  )
          {
               printf("argv[%d] = SCHEME_VECTORP\n",i);
          }
          if( SCHEME_CLOSUREP(argv[i]) )
          {
               printf("argv[%d] = SCHEME_CLOSUREP\n",i);
          }
          if( SCHEME_PROCP(argv[i])    )
          {
               printf("argv[%d] = SCHEME_PROCP\n",i);
          }
          if( SCHEME_INPORTP(argv[i])  )
          {
               printf("argv[%d] = SCHEME_INPORTP\n",i);
          }
          if( SCHEME_OUTPORTP(argv[i]) )
          {
               printf("argv[%d] = SCHEME_OUTPORTP\n",i);
          }
          if( SCHEME_EOFP(argv[i])     )
          {
               printf("argv[%d] = SCHEME_EOFP\n",i);
          }
          if( SCHEME_PROMP(argv[i])    )
          {
               printf("argv[%d] = SCHEME_PROMP\n",i);
          }
     }
     
     strcpy(name,SCHEME_STR_VAL(argv[0]));
     fprintf(stderr,"function %s defined\n",name);
     for(i=0;i<argc;i++)
     {
          if(SCHEME_LISTP(argv[i]))
          {
               fprintf(stderr,"LISTP:result executing argument %d\n",i);
               obj = SCHEME_CATCH_ERROR(
                    scheme_eval(argv[i],global_env),
                    0);
               scheme_write(stderr,obj);
               fprintf(stderr,"\n");
          }
          else if(SCHEME_PROCP(argv[i]))
          {
               fprintf(stderr,"PROCP:result executing argument %d\n",i);
               obj = SCHEME_CATCH_ERROR(
                    scheme_eval(
                         scheme_make_pair(argv[i],scheme_null),
                    global_env)
               ,0);
               scheme_write(stderr,obj);
               fprintf(stderr,"\n");
          }
          else
               fprintf(stderr,"cant execute argument %d\n",i);
          
     }
     return argv[0];
}


     
     

     
