include ../../include/gcc_unx.std

SYS     = tricklet
SYSLIB  = tricklet

all: snmp-get snmp-nxt snmp-set snmp-tbl snmp-info snmp-trap snmp-dump stdspook mib-emul

snmp-get: get.o parse.o exec.o $(LIBDIR)/libmibdf.a $(LIBDIR)/libmgmt.a $(LIBDIR)/libsnmp.a $(LIBDIR)/libdnpapx.a $(LIBDIR)/libdnpap.a
	$(LN) $(CFLAGS) -o snmp-get get.o exec.o parse.o $(LDFLAGS)  -lmibdf -lmgmt -lsnmp -ldnpapx -ldnpap $(NETLIB)
			  
snmp-nxt: next.o parse.o exec.o $(LIBDIR)/libmibdf.a $(LIBDIR)/libmgmt.a $(LIBDIR)/libsnmp.a $(LIBDIR)/libdnpapx.a $(LIBDIR)/libdnpap.a
	$(LN) $(CFLAGS) -o snmp-nxt next.o exec.o parse.o $(LDFLAGS)  -lmibdf -lmgmt -lsnmp -ldnpapx -ldnpap $(NETLIB)
			  
snmp-set: set.o parse.o exec.o $(LIBDIR)/libmibdf.a $(LIBDIR)/libmgmt.a $(LIBDIR)/libsnmp.a $(LIBDIR)/libdnpapx.a $(LIBDIR)/libdnpap.a
	$(LN) $(CFLAGS) -o snmp-set set.o exec.o parse.o $(LDFLAGS)  -lmibdf -lmgmt -lsnmp -ldnpapx -ldnpap $(NETLIB)
			  
snmp-tbl: table.o parse.o exec.o $(LIBDIR)/libmibdf.a $(LIBDIR)/libmgmt.a $(LIBDIR)/libsnmp.a $(LIBDIR)/libdnpapx.a $(LIBDIR)/libdnpap.a
	$(LN) $(CFLAGS) -o snmp-tbl table.o exec.o parse.o $(LDFLAGS)  -lmibdf -lmgmt -lsnmp -ldnpapx -ldnpap $(NETLIB)

snmp-info: info.o parse.o $(LIBDIR)/libmibdf.a $(LIBDIR)/libmgmt.a $(LIBDIR)/libsnmp.a $(LIBDIR)/libdnpapx.a $(LIBDIR)/libdnpap.a
	$(LN) $(CFLAGS) -o snmp-info info.o parse.o $(LDFLAGS)  -lmibdf -lmgmt -lsnmp -ldnpapx -ldnpap

snmp-trap: trap.o $(LIBDIR)/libmibdf.a $(LIBDIR)/libnw.a $(LIBDIR)/libsnmp.a $(LIBDIR)/libblock.a $(LIBDIR)/libdnpapx.a $(LIBDIR)/libdnpap.a
	$(LN) $(CFLAGS) -o snmp-trap trap.o $(LDFLAGS)  -lmibdf -lnw \
	-lblock -lsnmp -ldnpapx -ldnpap $(NETLIB)

snmp-dump: dump.o $(LIBDIR)/libmibdf.a $(LIBDIR)/libdnpapx.a $(LIBDIR)/libdnpap.a
	$(LN) $(CFLAGS) -o snmp-dump dump.o $(LDFLAGS)  -lmibdf -ldnpapx -ldnpap
			  
mib-emul: emul.o $(LIBDIR)/libmibdf.a $(LIBDIR)/libnw.a $(LIBDIR)/libsnmp.a $(LIBDIR)/libblock.a $(LIBDIR)/libdnpapx.a $(LIBDIR)/libdnpap.a
	$(LN) $(CFLAGS) -o mib-emul emul.o $(LDFLAGS)  -lmibdf -lnw \
	-lblock -lsnmp -ldnpapx -ldnpap $(NETLIB)

stdspook: stdspook.o spook.o parse.o $(LIBDIR)/libmibdf.a $(LIBDIR)/libmgmt.a $(LIBDIR)/libsnmp.a $(LIBDIR)/libdnpapx.a $(LIBDIR)/libdnpap.a
	$(LN) $(CFLAGS) -o stdspook stdspook.o spook.o parse.o $(LDFLAGS)  -lmibdf -lmgmt -lsnmp -ldnpapx -ldnpap $(NETLIB)

clean:
	- $(RM) *.o
	- $(RM) *.a
	- $(RM) *.exe
	- $(RM) core
	- $(RM) snmp-get
	- $(RM) snmp-nxt
	- $(RM) snmp-set
	- $(RM) snmp-tbl
	- $(RM) snmp-info
	- $(RM) snmp-trap
	- $(RM) snmp-dump
	- $(RM) mib-emul
	- $(RM) stdspook
	- $(RM) *.man
	- $(RM) *.err
	- $(RM) *.bak

install: $(BINDIR)/snmp-get $(BINDIR)/snmp-nxt $(BINDIR)/snmp-set $(BINDIR)/snmp-tbl $(BINDIR)/snmp-info $(BINDIR)/snmp-trap $(BINDIR)/snmp-dump $(BINDIR)/mib-emul $(BINDIR)/stdspook

$(BINDIR)/snmp-get: snmp-get
	$(CP) snmp-get $(BINDIR)/snmp-get

$(BINDIR)/snmp-nxt: snmp-nxt
	$(CP) snmp-nxt $(BINDIR)/snmp-nxt

$(BINDIR)/snmp-set: snmp-set
	$(CP) snmp-set $(BINDIR)/snmp-set

$(BINDIR)/snmp-tbl: snmp-tbl
	$(CP) snmp-tbl $(BINDIR)/snmp-tbl
        
$(BINDIR)/snmp-info: snmp-info
	$(CP) snmp-info $(BINDIR)/snmp-info
        
$(BINDIR)/snmp-trap: snmp-trap
	$(CP) snmp-trap $(BINDIR)/snmp-trap

$(BINDIR)/snmp-dump: snmp-dump
	$(CP) snmp-dump $(BINDIR)/snmp-dump
        
$(BINDIR)/mib-emul: mib-emul
	$(CP) mib-emul $(BINDIR)/mib-emul

$(BINDIR)/stdspook: stdspook
	$(CP) stdspook $(BINDIR)/stdspook
        

get.o: get.c  exec.h parse.h

next.o: next.c  exec.h parse.h

set.o: set.c  exec.h parse.h

info.o: info.c

table.o: table.c  exec.h parse.h

stdspook.o: stdspook.c  parse.h

spook.o: spook.c  parse.h

parse.o: parse.c parse.h

exec.o: exec.c exec.h 

trap.o: trap.c 

dump.o: dump.c 

emul.o: emul.c 
