/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dnpap.h>
#include <message.h>
#include <snmp.h>
#include <mibdf.h>
#include <config.h>
#include "exec.h"
#include "parse.h"


int main(int argc, char **argv);
static INT MibID2String(LONG *id, INT len, CHAR *oid);


int main(int argc, char **argv)
{
	SNMP_OBJECT list[1];
	unsigned listLen;
	int ret;
	char answer[256], oid[256] = "";

	if (ConfigInit(argc, argv) == FALSE || ConfigLoad() == FALSE)
	{
		DnpapMessage(DMC_ERROR, TRICKLET_ERROR, "ConfigInit failed");
		DnpapExit(1);
	}

	MessageInit("stdio:out", MSGFILE, MSGSTDIO, NULL);
	MessageConfig(TRICKLET_ERROR, "Snmp-Info");

	if (argc != 2)
	{
		DnpapMessage(DMC_ERROR, TRICKLET_ERROR, "usage: snmp-info <MIB variable name>");
		DnpapExit(2);
	}

	if (MibDfInit() != 0 || MibDfFullMib() != 0)
	{
		DnpapMessage(DMC_ERROR, TRICKLET_ERROR, "MibDfInit failed");
		DnpapExit(1);
	}

	if (GetList(argv[1], list, 1, &listLen) < 0)
	{
		sprintf(answer, "Couldn't parse <%s>", argv[1]);
		return 0;
	}
	ret = MibDfIDInfo(list[0].Id, (int) (list[0].IdLen - 1), answer);
	if (ret < 0)
	{
		puts("couldn't get info");
		return 1;
	}
	ret = MibID2String(list[0].Id, (int) (list[0].IdLen - 1), oid);
	printf("%s %s\n", answer, oid);
	return 0;
}


INT MibID2String(LONG *id, INT len, CHAR *oid)
{
INT i;

    for (i = 0; i < len-1; i++)
    {
        sprintf(oid, "%ld.", id[i]);
        oid += strlen(oid);
    }
    if (i < len)
    {
        sprintf(oid, "%ld", id[i]);
        oid += strlen(oid);
    }

	if (i == 0)
		return -1;
	return i;
}

